
		.text

		.global	asm_blit_screen
		.global	asm_draw_sprite
		.global	asm_unpack
		.global	asm_stretch_blit

		.equ	bitmask,0x0000ffff

		.extern	trans
		.extern	yy

		.code 32

@
@ Description:
@  asm_blit_screen
@
@ Parameters:
@  r0 = ptr to source data
@  r1 = ptr to frame buffer
@
@ Returns;
@  none.
@

asm_blit_screen:
		stmdb	sp!,{r4-r11,lr}

		ldr		r2,= 320*240*2
		add		r0,r0,r2
		ldr		r2,= 319*240*2-2*2
		add		r1,r1,r2

		mov		r2,#320
.blit_loop_col:

		.REPT	24
		ldmdb	r0!,{r3-r7}
		mov		r11,r3,ror #16
		mov		r10,r4,ror #16
		mov		r9,r5,ror #16
		mov		r8,r6,ror #16
		mov		r7,r7,ror #16
		stmib	r1!,{r7-r11}
		.ENDR

		sub		r1,r1,#960
		subs	r2,r2,#1
		bne		.blit_loop_col

		ldmia	sp!,{r4-r11,pc}

@
@ Description:
@  asm_draw_sprite
@
@ Parameters:
@  r0 = ptr to source data
@  r1 = ptr to destination
@  r2 = source height*2 & destination height*2
@  r3 = width & height*2
@
@ Returns;
@  none.
@

asm_draw_sprite:
		stmdb	sp!,{r4-r8,lr}

		ldr		r6,= bitmask
		and		r5,r3,r6		@ r5 = height
		mov		r4,r3,lsr #16	@ r4 = width
		and		r3,r2,r6		@ r3 = dst height
		mov		r2,r2,asr #16	@ r2 = spr height

		ldr		r8,= trans
		ldr		r8,[r8]
		sub		r0,r0,#2
		sub		r1,r1,#2
.spr_loop_w:
		mov		r6,r5
.spr_loop_h:
		ldrh	r7,[r0,r6]		@ spr data
		cmp		r7,r8			@ transparent ?
		strneh	r7,[r1,r6]		@ if not : store in dst
		subs	r6,r6,#2
		bne		.spr_loop_h

		add		r0,r0,r2
		add		r1,r1,r3
		subs	r4,r4,#1
		bne		.spr_loop_w

		ldmia	sp!,{r4-r8,pc}

@
@ Description:
@  asm_unpack
@
@ Parameters:
@  r0 = ptr to source data
@  r1 = ptr to dest buffer
@  r2 = ptr to end dest buffer
@  r3 = ptr to palette
@
@ Returns;
@  none.
@

asm_unpack:
		stmdb	sp!,{r4-r5,lr}

.unpack_loop:
		ldrb	r4,[r0],#1
		tst		r4,#0x80
		beq		.unpack_copy

		and		r4,r4,#0x7f
		ldrb	r5,[r0],#1
		add		r5,r5,r5
		ldrh	r5,[r3,r5]
.unpack_rle:
		strh	r5,[r1],#2
		subs	r4,r4,#1
		bne		.unpack_rle
		cmp		r1,r2
		bne		.unpack_loop

		ldmia	sp!,{r4-r5,pc}

.unpack_copy:
		ldrb	r5,[r0],#1
		add		r5,r5,r5
		ldrh	r5,[r3,r5]
		strh	r5,[r1],#2
		subs	r4,r4,#1
		bne		.unpack_copy
		cmp		r1,r2
		bne		.unpack_loop

		ldmia	sp!,{r4-r5,pc}

@
@ Description:
@  asm_stretch_blit
@
@ Parameters:
@  r0 = ptr to source data
@  r1 = ptr to destination
@  r2 = ddx
@  r3 = src height
@
@ Returns;
@  none.
@

asm_stretch_blit:
		stmdb	sp!,{r4-r9,lr}

		ldr		r8,= yy-4
		mov		r4,#0
.stretch_loop_w:
		mul		r5,r4,r2
		mov		r6,r5,lsr #8
		mul		r5,r6,r3

		mov		r6,#10
		mov		r7,r8
.stretch_loop_h:
		.REPT	24
		ldr		r9,[r7],#4
		add		r9,r5,r9
		ldrh	r9,[r0,r9]
		strh	r9,[r1],#2
		.ENDR
		subs	r6,r6,#1
		bne		.stretch_loop_h

		add		r4,r4,#1
		cmp		r4,#320
		bne		.stretch_loop_w

		ldmia	sp!,{r4-r9,pc}

		.end
