/*
 * KOF91 GP32 port
 *
 * CopyLeft 2003-2004 by THOR / Shadow Of Dawn
 *
 * All this code is unprotected: do what you want with it !
 *
 * Becareful : as it is a lazy port, implementations are often limited to the use of the game.
 *
 * Code to read .ini files
 */

#include "config.h"
#include "system.h"

#include "gpmem.h"
#include "gpstdio.h"
#include "gpstdlib.h"
#include <stdlib.h>
#include <string.h>

DATAFILE *cfile = NULL;

void set_config_file(const char* name)
{
	ulong i;
	if (cfile!=NULL)
		unload_datafile(cfile);
	cfile = load_datafile(name);
	if (cfile==NULL)
		return;

	for (i=0;i<cfile->len;i++)
	{
		if (cfile->dat[i]==0x0d)
			cfile->dat[i] = 0;
	}
}

void override_config_file(const char* s)
{
	set_config_file(s);
}

ulong nextLine(ulong pos)
{
	if (pos==0)
		return pos;
	while (pos<cfile->len && cfile->dat[pos])
		pos++;
	return pos+2;
}

ulong findSection(const char *name)
{
	int l = strlen(name);
	ulong pos = nextLine(0);
	while (pos<cfile->len)
    {
		/* skip empty lines */
		while (!cfile->dat[pos])
		{
			pos+=2;
			if (pos>=cfile->len)
				return pos;
		}
		/* section ? */
		if ((cfile->dat[pos]=='[') && (strncmp((char*)cfile->dat+pos+1,name,l)==0))
			return nextLine(pos+1); /* found */
		pos = nextLine(pos+1);
    }
	return pos;
}

int get_config_int(const char* section,const char* var,int def)
{
	char*v = get_config_string(section,var,NULL);
	return v==NULL?def:atoi(v);
}

char* get_config_string(const char* section,const char* var,const char* def)
{
	ulong pos = 0;
	int l = strlen(var);
	if (cfile==NULL)
		return (char*)def;
	if (section!=NULL)
	{
		char buf[9];
		strcpy(buf,section);
		strlwr(buf);
		pos = findSection(buf);
	}
	if (pos==cfile->len)
		return (char*)def;
	while (pos<cfile->len)
	{
		/* skip empty lines */
		while (!cfile->dat[pos])
		{
			pos+=2;
			if (pos>=cfile->len)
				return (char*)def;
		}
		/* new section ? */
		if (cfile->dat[pos]=='[')
			return (char*)def;
		if (strncasecmp((char*)cfile->dat+pos,var,l)==0)
		{
			pos+=l;
			if (pos<cfile->len && (cfile->dat[pos]=='='||cfile->dat[pos]==' '))
			{
				while (cfile->dat[pos]!='=')
					pos++;
				pos++;
				while (cfile->dat[pos]==' ')
					pos++;
				return (char*)cfile->dat+pos;
			}
		}
		pos = nextLine(pos+1);
	}
	return (char*)def;
}
