/*
 * KOF91 GP32 port
 *
 * CopyLeft 2003-2004 by THOR / Shadow Of Dawn
 *
 * All this code is unprotected: do what you want with it !
 *
 * Becareful : as it is a lazy port, implementations are often limited to the use of the game.
 *
 */

#ifndef _GFX_H_
#define _GFX_H_

#include "gpdef.h"
#include "system.h"

#define GFX_TEXT 0
#define GFX_DIRECTX_WIN 1
#define GFX_DIRECTX_ACCEL 2
#define GFX_DIRECTX_SOFT 3

#define DRAW_MODE_COPY_PATTERN 0
#define DRAW_MODE_SOLID 1

typedef unsigned short COLOR;

typedef struct
{
	int		w,h;
	COLOR*	buf;
} BITMAP;

typedef struct
{
	COLOR	*pal;
	int		nbc;
	int		w,h;
	int		ow,oh;
	int		x,y,z;
	int		cache_idx;
	int		cache_hits;
	int		size;
	int		svbg;
	ubyte*	buf;
} RLE_SPRITE;

typedef struct
{
	int x,y,w,h;
} RECT;

typedef struct
{
	BITMAP*		bmp;
	DATAFILE*	charset;
	int			width;
} FONT;

#define PALLETE ushort*

void		gp32_initGfx();
void		gp32_error(char*);
BITMAP*		create_bitmap(int,int);
COLOR		makecol(ushort,ushort,ushort);
BITMAP*		load_pcx (const char*,PALLETE);
void		draw_sprite(BITMAP*,BITMAP*,int,int);
void		masked_blit (BITMAP*,BITMAP*,int,int,int,int,int,int);
void		rectfill(BITMAP*,int,int,int,int,COLOR);
void		textout(BITMAP*,FONT*,const char*,int,int);
void		textout_centre(BITMAP*,FONT*,const char*,int,int,COLOR);
void		clear(BITMAP*);
COLOR		getpixel(BITMAP*,int,int);
void		putpixel(BITMAP*,int,int,COLOR);
void		blit(BITMAP*,BITMAP*,int,int,int,int,int,int);
void		drawing_mode(int,BITMAP*,int,int);
void		draw_sprite_h_flip(BITMAP*,BITMAP*,int,int); 
void		rect(BITMAP*,int,int,int,int,COLOR);                
void		stretch_blit(BITMAP*,BITMAP*,int,int,int,int,int,int,int,int);
void		stretch_sprite(BITMAP*,BITMAP*,int,int,int,int); 
void		destroy_bitmap(BITMAP*);
BITMAP*		load_bitmap (const char*,int);
void		acquire_screen();
void		release_screen();
BITMAP*		clone_bitmap(BITMAP*);
void		draw_rle_sprite(BITMAP*,RLE_SPRITE*,int,int,int);
RLE_SPRITE*	get_rle_sprite(BITMAP*);
void		destroy_rle_sprite(RLE_SPRITE*);
void		enable_rle_cache();
void		disable_rle_cache();
void		restore_background(BITMAP*);
void		init_bkgd_save();
void		set_foreground(BITMAP*);
void		show_foreground(int,int,int,int);
void		clear_foreground();
FONT*		load_font(const char*);
void		destroy_font(FONT*);

#endif
