/*
 * KOF91 GP32 port
 *
 * CopyLeft 2003-2004 by THOR / Shadow Of Dawn
 *
 * All this code is unprotected: do what you want with it !
 *
 * Becareful : as it is a lazy port, implementations are often limited to the use of the game.
 *
 */

#ifndef _SYSTEM_H_
#define _SYSTEM_H_

#include "gpdef.h"
#include "gpstdio.h"

#define JOY_TYPE_AUTODETECT 0
#define JOY_TYPE_NONE 1
#define JOY_TYPE_GP32 2

#define FA_DIREC 1

enum
{
KEY_F1 = 0,
KEY_F5,
KEY_F9,
KEY_ENTER,
KEY_ESC,
KEY_SPACE
};

enum
{
SPEED_80 = 0,
SPEED_100,
SPEED_120,
SPEED_133,
SPEED_144,
SPEED_150,
SPEED_156,
SPEED_166
};

typedef struct
{
	ubyte		*dat;
	ulong		len;
	ulong		read;
	F_HANDLE	handle;
} DATAFILE;

typedef struct
{
	ubyte b;
} BUTTON;

typedef struct
{
	ubyte d1;
	ubyte d2;
} AXIS;

typedef struct
{
	AXIS axis[2];
} STICK;

typedef struct
{
	BUTTON button[4];
	STICK stick[4];
} JOYSTICK;

extern JOYSTICK joy[2];
extern ubyte key[127];

/* MISC */

void	gp32_initSystem();
void	gp32_set_speed(int);
/* INPUT */

void	clear_keybuf();
void	poll_joystick();
int		keypressed();
int		buttonpressed();
void	simulate_keypress(int);

/* FILE SYSTEM */

DATAFILE*	open_datafile(const char*,ubyte);
DATAFILE*	load_datafile(const char*);
void		unload_datafile(DATAFILE*);
void		read_datafile(DATAFILE*,ulong);
void		save_file(char*,ubyte*,ulong);
int			_al_file_isok(const char*);
void*		_al_findfirst(const char*,int,char*,int*);
void		replace_filename(char*,char*,char*,int);
int			_al_findnext(void*,char*,int*);
void		_al_findclose(void*);
void		gcvt(int,int,char*);
int			openZip(const char*);
void		closeZip();
ubyte*		readZip(const char*,ulong*);

#endif
