/*****************************************************************
	   ---------------------- KOF91 -----------------------
	    ------------ 2D Fighting Game Engine -------------
			by Nicolas Sevez , aka Moah (moah@kof91.com)
					  http://www.kof91.com
			Patches by Rick Leite (ric@asbyte.com.br)
					 http://kof.asbyte.com.br
		  ------------------------------------------------------
*****************************************************************
Have fun !
Moah (moah@online.fr) , 10/03/2000
*****************************************************************/

#include <string.h>
#include <stdio.h>

#include "gp32.h"

#define DEMO_TIME 640

#define MV_STATIC		0
#define MV_WALK_B		10
#define MV_WALK_F		11
#define MV_CROUCH		20

#define MV_FIREB		30
#define MV_FIREBX		31

#define MIN_ATTACK		39

#define MV_RUSH			40
#define MV_RUSHX		41
#define MV_SMOVE		50
#define MV_SMOVEX		51

#define MV_SPUNCH		60
#define MV_WPUNCH		61
#define MV_GPUNCH		62

#define MV_SKICK		70
#define MV_WKICK		71
#define MV_GKICK		72

#define MAX_ATTACK		79

#define MV_GUARD		80
#define MV_GGUARD		81

#define MV_HURT			90
#define MV_GHURT		91

#define MV_KO			100

#define MV_JUMP_U		110
#define MV_JUMP_B		111
#define MV_JUMP_F		112

#define AI_WALK			60
#define AI_STATIC		40

extern BITMAP* screen;
extern FONT* font;

/** MACROS **/

#define MIN(a,b) ((a)<(b)?(a):(b))
#define MAX(a,b) ((a)>(b)?(a):(b))

#define CLEAR_BM(BMP)		{ if ((BMP)!=NULL) { destroy_bitmap(BMP);	  (BMP)=NULL; } }
#define CLEAR_RLE(RLE)		{ if ((RLE)!=NULL) { destroy_rle_sprite(RLE); (RLE)=NULL; } }
#define CLEAR_SAMPLE(SMP)	{ if ((SMP)!=NULL) { destroy_sample(SMP);	  (SMP)=NULL; } }
#define CLEAR_MUSIC(MUS)	{ if ((MUS)!=NULL) { destroy_mod(MUS);		  (MUS)=NULL; } }
#define CLEAR_FONT(FNT)		{ if ((FNT)!=NULL) { destroy_font(FNT);       (FNT)=NULL; } }

#define limd(p)			(zoomwidth - (3*(Players[p].width>>2)))
#define limg(p)			(Players[p].width>>2)
#define ZMRATIO			(zoomwidth/ZOOM)

#define BLOCK0 5
#define BLOCK1 10
#define BLOCK2 20

#define JOY_B(p,n)	(joy[p].button[n].b)
#define JOY_D1(p,n)	(joy[p].stick[0].axis[n].d1)
#define JOY_D2(p,n)	(joy[p].stick[0].axis[n].d2)

#define JOY_WP(p)	JOY_B(p,0)
#define JOY_SP(p)	JOY_B(p,1)
#define JOY_WK(p)	JOY_B(p,2)
#define JOY_SK(p)	JOY_B(p,3)

#define JOY_UP(p)	JOY_D1(p,1)
#define JOY_DN(p)	JOY_D2(p,1)
#define JOY_LT(p)	JOY_D1(p,0)
#define JOY_RT(p)	JOY_D2(p,0)

/* PATCHES defines */

#define DIR_BAR "\\"
#define fill_sprite(a) rectfill(a, 0, 0,a->w,a->h, makecol(255,0,255));

/* global variables */

MUSIC *music = NULL;

SAMPLE *rd1 = NULL;
SAMPLE *rd2 = NULL;
SAMPLE *rd3 = NULL;

SAMPLE *fight = NULL;

SAMPLE *wp_alwa = NULL;
SAMPLE *wk_alwa = NULL;
SAMPLE *sp_alwa = NULL;
SAMPLE *sk_alwa = NULL;

SAMPLE *hit1 = NULL;
SAMPLE *hit2 = NULL;

SAMPLE *block_snd = NULL;

SAMPLE *done = NULL;
SAMPLE *bing = NULL;
SAMPLE *buzz = NULL;

SAMPLE *ko_snd = NULL;
SAMPLE *argh_snd = NULL;
SAMPLE *female_snd = NULL;
SAMPLE *prfct_snd = NULL;
SAMPLE *to_snd = NULL;

BITMAP *virtscreen = NULL;
BITMAP *zoomscreen = NULL;

PALLETE Pal ;

BITMAP *Title = NULL;

BITMAP *Selecteur1 = NULL;
BITMAP *Selecteur2 = NULL;

BITMAP *LBbanner = NULL;
BITMAP *Bar = NULL;
BITMAP *Bar2 = NULL;
BITMAP *Power = NULL;
BITMAP *PBar = NULL;

BITMAP *WImpact[16] ;
BITMAP *SImpact[16] ;
BITMAP *BlockImpact[16] ;

BITMAP *Carton_R1 = NULL;
BITMAP *Carton_R2 = NULL;
BITMAP *Carton_R3 = NULL;
BITMAP *Carton_FT = NULL;
BITMAP *Carton_WN = NULL;
BITMAP *Carton_KO = NULL;

BITMAP *novic0 = NULL;
BITMAP *novic1 = NULL;
BITMAP *avic0 = NULL;
BITMAP *avic1 = NULL;

BITMAP *Face1 = NULL;
BITMAP *Face2 = NULL;
BITMAP *Icon1 = NULL;
BITMAP *Icon2 = NULL;
BITMAP *Lock = NULL;

BITMAP *Bkgd = NULL;
BITMAP *Frgd = NULL;

BITMAP *B_Temp = NULL;

BITMAP *Carton_TO = NULL;
BITMAP *B_clock[10];

BITMAP *B_prfct = NULL;

/******************************************/

struct MOVE
{
	int w ;
	char nbf, spd ;
	int defx , defy ;
};

struct AMOVE
{
	int  w ;
	char nbf, spd ;
	int defx , defy ;

	char hit, dmg ;
	int offx , offy ;
};

struct SMOVE
{
	int  w ;
	char nbf, spd ;
	int defx , defy ;

	char hit, dmg ;
	int offx , offy ;

	char flg, rot, pix, end, succ, spec, sflg ;
	char *exec ;
	char seq[40] ;
	short nb ;
};

struct FBALL
{
	int x,y,dx;
	char on;
	char flg;
	int cx, cy;
	int w, h;
	int offx, offy;
};

struct PLAYER_STRUCT
{
	/* selection vars */

	int sel;
	int load_sel;
	int old_sel;

	/* in game vars */

	int x,y;

	int life;
	int spower;

	struct FBALL fballs[2];

	int rush_stop;
	int smove_stop;
	int rushx_stop;
	int smovex_stop;

	char damag;
	int jump_how;
	char last_status;
	char autho_ht;
	int tol;
	int hitfram;
	int sens;
	int sol;

	char vic;

	int  flag;
	char hflag;
	int actual;
	char ak;
	char limak;
	char apch;
	signed char limp;

	int ai_walkf , ai_walkb ;
	int ai_static ;

	char invers;

	/* sprites */

	RLE_SPRITE *Static[24] ;
	RLE_SPRITE *Walk[32] ;
	RLE_SPRITE *Single[8] ;
	RLE_SPRITE *Punch[24] ;
	RLE_SPRITE *WPunch[24] ;
	RLE_SPRITE *Kick[24] ;
	RLE_SPRITE *WKick[24] ;
	RLE_SPRITE *Jump[8] ;
	RLE_SPRITE *KO[8] ;
	RLE_SPRITE *Hurt[8] ;
	RLE_SPRITE *GHurt[8] ;
	RLE_SPRITE *AKick[16] ;
	RLE_SPRITE *APunch[16] ;
	RLE_SPRITE *GKick[16] ;
	RLE_SPRITE *GPunch[16] ;
	RLE_SPRITE *FireB[24] ;
	RLE_SPRITE *FBall[16] ;
	RLE_SPRITE *Rush[24] ;
	RLE_SPRITE *SMove[24] ;
	RLE_SPRITE *FireBX[48] ;
	RLE_SPRITE *FBallX[16] ;
	RLE_SPRITE *RushX[64] ;
	RLE_SPRITE *SMoveX[64] ;

	RLE_SPRITE *Anim[64] ;

	/* sounds */

	SAMPLE *hadoken;
	SAMPLE *copter;
	SAMPLE *dragon;
	SAMPLE *hadokenx;
	SAMPLE *copterx;
	SAMPLE *dragonx;

	/* characters infos */

	int  height, width ;

	int limoffx , limoffy ;
	int limdefx , limdefy ;

	int wimpact_ct ;
	int simpact_ct ;
	int bimpact_ct ;

	int female;

	struct MOVE statik ;
	struct MOVE walk ;
	struct MOVE crouch ;
	struct MOVE hurt ;
	struct MOVE ghurt ;
	struct MOVE jump ;
	struct MOVE intro ;
	struct MOVE outwin ;
	struct MOVE ko ;

	struct AMOVE wpunch ;
	struct AMOVE spunch ;
	struct AMOVE apunch ;
	struct AMOVE gpunch ;
	struct AMOVE wkick ;
	struct AMOVE skick ;
	struct AMOVE gkick ;
	struct AMOVE akick ;

	struct SMOVE fireb ;
	struct SMOVE fball ;
	struct SMOVE rush ;
	struct SMOVE smove ;

	struct SMOVE firebx ;
	struct SMOVE fballx ;
	struct SMOVE rushx ;
	struct SMOVE smovex ;
};

struct PLAYER_STRUCT Players[2] ;

void GStatic (int , int) ;
void GSingle (int , int) ;
void GWalk   (int , int) ;
void GPunch  (int , int) ;
void GWPunch (int , int) ;
void GKick   (int , int) ;
void GWKick  (int , int) ;
void GAKick  (int , int) ;
void GAPunch (int , int) ;
void GJump   (int , int) ;
void GGKick  (int , int) ;
void GGPunch (int , int) ;
void GFireB  (int , int) ;
void GRush   (int , int) ;
void GSMove  (int , int) ;
void GFireBX (int , int) ;
void GRushX  (int , int) ;
void GSMoveX (int , int) ;
void GHurt   (int , int) ;
void GGHurt  (int , int) ;
void GKO     (int , int) ;
void GDead   (int , int) ;
void GFBall  (int , int) ;
void GFBallX (int , int) ;
void GIntro  (int , int) ;
void GOutwin (int , int) ;

/******************************************/

int scan_files(char *name, int attrib, char what );
void blit_KOF91 (void) ;
void blit_Bkgd (void) ;
void load_background(int);
void showZoom(int) ;
void load_serie(char*,char*,int,RLE_SPRITE**);
RLE_SPRITE* load_rle_sprite(char*);
void load_char(char*,int);
void showLoading(int);
void showIntro(int);
void drawPlayer(int) ;
void drawImpact(int) ;
void playerAnim(int);
void updateFireBalls(int);
void checkInput(int);
void staticUpdating(int);
void checkAI(int);
void checkAttack(int);
void showWinner(int);
void computeZoom(int,int);

char animated ;
char foreground ;

char bkgd_counter ;
char bkgd_delay ;

int bkgdlim ;
int zoomsup ;
int zoomwidth;
int ZW,ZH;
float ZOOM;

unsigned char j ;

char gmode , diff ;

/* story variables */

char story ;

/* string and key variables */

#define MAX_CHARACTERS 250

char charname [MAX_CHARACTERS][30] ;
char charName [MAX_CHARACTERS][32] ;
char bkgdname [200][30] ;
char flcname [100][30] ;

char charzip [MAX_CHARACTERS][64] ;

#define MAX_SKINS 10

char skinname [MAX_SKINS][30] ;
char skinzip [MAX_SKINS][64] ;

int nbchar ;
int nbbkgd ;
int nbflc ;
int nbskin ;

char defeated[MAX_CHARACTERS];
char present[MAX_CHARACTERS];
char secretchar[MAX_CHARACTERS];

int num ;
char tilenum[4] ;

char charn1[40] ;
char charn2[40] ;

char bkgdnum[4] ;

char file[200] ;
char passeur[100] ;
char sectn[50] ;

char last_char ;

char get_kstatus ( char strg[] ) ;

char check_kstatus ( int, char ) ;

char wimpact_nbf ;
char simpact_nbf ;
char bimpact_nbf ;

int bar_dx,bar_dy;
int pbar_spr,pbar_dx,pbar_dy;
int tbar_dy;

/* AI variables */

int offense , defense ;

char easy_def , easy_off ;
char medium_def , medium_off ;
char hard_def , hard_off ;

/* time */

int t_clock, t_clock_ini, t_short, t_decrement;
int clock_frame ;
char s_cron[] = "99" ;
int c_dez, c_uni;

/* Sprites loading functions */

void load_sprites (int) ;
void load_intro (int) ;
void load_win (int) ;
void destroy_player(int);
void unload_win (int) ;
void destroy_bitmaps (void) ;
void unload_anim(int,int);

/* misc */

void Intro(void) ;

/* Sound Fonctions */

void loadsounds(void) ;
void freesounds(void) ;

void Buzz (void) ;
void Bing (void) ;
void Paf (char gana) ;
void Hurt (char gana) ;
void Block (void) ;
void Done (void) ;
void Round (char which) ;
void Fight (void) ;

int cx;				/* Current X position in the bkgd + misc */
int fx,fy,cy;
int s = 2;				/* Scroll speed (2 pixels per frame) */
int sel_player1 , sel_player2 ;

char skp_flag = 0;
int max_life;
int loading;

/*BITMAP _virtscreen = {320,240,NULL};*/

/* END OF GLOBAL DEFINITIONS */

void GpMain(void *arg)
{
	int  x, y;							/* Used in for loops  + misc */
	int  ok = 1;						/* Loop until ok==0			 */
	long n;								/* For calculating FPS		 */
	int checkint = 0 ;
	char vic_flag ;
	char frameskip = 0;
	int  j ;					/* Miscellaneous variables		*/
	char p2_sel ;
	int angle ;
	int bgd ;
	int tcolor , bcolor ;
	int sel_bkgd ;
	int text_color ;
	int deb ;
	char round ;
	char nbpar = 0 ;
	char vsynch = 0 ;
	int rr,gg,bb;

	char *open1 ;
	char *open2 ;

	BITMAP *b = NULL;

	/* end of definitions */

	story = 0 ;

	gm_memset(&Players[0],0,sizeof(struct PLAYER_STRUCT));
	gm_memset(&Players[1],0,sizeof(struct PLAYER_STRUCT));
	Players[0].load_sel = Players[1].load_sel = -1;

	/*virtscreen = &_virtscreen;*/
	virtscreen = create_bitmap(320,240);

	gp32_initSystem();
	gp32_initGfx();
	gp32_initSound();

	loadOptions();

	nbchar = scan_files( "sprites\\*" , FA_DIREC, 0 ) ;
	nbchar += scan_files( "sprites\\*.zip" , 0, 3 ) ;

	nbbkgd = scan_files( "bkgds\\*.pcx" , 0, 1 ) ;
	nbflc = scan_files( "bkgds\\*.flc" , 0, 2 ) ;
	for ( cx = 0 ; cx < nbflc ; cx++ )
		strcpy ( bkgdname[nbbkgd+cx], flcname[cx] );
	nbbkgd = nbbkgd + nbflc ;

	nbskin = 1;
	skinzip[0][0] = 0;
	nbskin += scan_files( "skins\\*.zip" , 0, 4 ) ;
	for ( cx = 1 ; cx < nbskin ; cx++ )
		addChoice ( OPTION_SKIN, skinname[cx] );

	if (getOptionValue(OPTION_SKIN)>=nbskin)
		setOptionValue(OPTION_SKIN,0);

	clock_frame = 0;
	t_clock = t_clock_ini;
	gm_sprintf(s_cron,"%d",t_clock);
	c_dez =  s_cron[0]-48;
	c_uni =  s_cron[1]-48;

	tcolor = makecol(255,0,255);
	bcolor = makecol(0,0,0);
	sel_bkgd = makecol(0,255,0);

	text_color = -1 ;

	/* SCAN CHARS DIRECTORY */

	for ( cx = 0 ; cx < nbchar ; cx++ )
	{
		BITMAP *b;

		openZip(charzip[cx]);

		strcpy ( passeur, "sprites\\" );
		strcat ( passeur, charname[cx] );
		strcat ( passeur, "\\static1.pcx" );

		b = load_pcx (passeur ,Pal );

		if ( b != NULL )
		{
			CLEAR_BM(b)
			present[cx] = 1 ;
		}
		else present[cx] = 0 ;

		strcpy ( passeur, "sprites\\" );
		strcat ( passeur, charname[cx] );
		strcat ( passeur, "\\char.ini" );

		override_config_file( passeur );

		secretchar[cx] = get_config_int ( charname[cx], "locked" , 0 );
		strcpy(charName[cx],get_config_string ( charname[cx] , "name" , "No name found" ));

		closeZip();
	}

	/* Intro *********************************/

	clear_keybuf() ;

	Intro();

	loadsounds();

	/* load skin */

	gm_memset(B_clock,0,sizeof(B_clock));
	gm_memset(WImpact,0,sizeof(WImpact));
	gm_memset(SImpact,0,sizeof(SImpact));
	gm_memset(BlockImpact,0,sizeof(BlockImpact));

LoadSkin:

	openZip(skinzip[getOptionValue(OPTION_SKIN)]);

	CLEAR_FONT(font)
	font = load_font("sprites\\font");

	override_config_file("game.ini");

	t_clock_ini = get_config_int("timer","t_clock",80);
	t_decrement = get_config_int("timer","t_decrement",30);
	t_short = get_config_int("timer","t_short",10);

	wimpact_nbf = get_config_int ( 0 , "wimpact_nbf" , 1 ) ;
	simpact_nbf = get_config_int ( 0 , "simpact_nbf" , 1 ) ;
	bimpact_nbf = get_config_int ( 0 , "bimpact_nbf" , 1 ) ;

	/*get AI parameters */

	easy_def = get_config_int ( 0, "easy_def" , 60 ) ;
	easy_off = get_config_int ( 0, "easy_off" , 30 ) ;

	medium_def = get_config_int ( 0, "medium_def" , 70 ) ;
	medium_off = get_config_int ( 0, "medium_off" , 50 ) ;

	hard_def = get_config_int ( 0, "hard_def" , 60 ) ;
	hard_off = get_config_int ( 0, "hard_off" , 80 ) ;

	/* colors */

	rr = get_config_int ( "colors" , "p1_r" , 255 ) ;
	gg = get_config_int ( "colors" , "p1_g" , 0 ) ;
	bb = get_config_int ( "colors" , "p1_b" , 0 ) ;
	sel_player1 = makecol(rr,gg,bb);
	rr = get_config_int ( "colors" , "p2_r" , 0 ) ;
	gg = get_config_int ( "colors" , "p2_g" , 255 ) ;
	bb = get_config_int ( "colors" , "p2_b" , 0 ) ;
	sel_player2 = makecol(rr,gg,bb);

	CLEAR_BM(Lock)
	Lock = load_pcx ( "sprites\\lock.pcx" , 0 );

	for ( num=1 ; num<(wimpact_nbf+1) ; ++num )
	{
		gcvt ( num , 1 , tilenum ) ;
		strcpy ( file, "sprites\\wimpact" );
		strcat ( file, tilenum );
		strcat ( file, ".pcx" );
		CLEAR_BM(WImpact[num])
		if((WImpact[num] = load_pcx ( file , 0 ))==NULL)
			gp32_error("can not load gfx");
	}

	for ( num=1 ; num<(simpact_nbf+1) ; ++num )
	{
		gcvt ( num , 1 , tilenum ) ;
		strcpy ( file, "sprites\\simpact" );
		strcat ( file, tilenum );
		strcat ( file, ".pcx" );
		CLEAR_BM(SImpact[num])
		SImpact[num] = load_pcx ( file , 0 ) ;
	}

	for ( num=1 ; num<(bimpact_nbf+1) ; ++num )
	{
		gcvt ( num , 1 , tilenum ) ;
		strcpy ( file, "sprites\\bimpact" );
		strcat ( file, tilenum );
		strcat ( file, ".pcx" );
		CLEAR_BM(BlockImpact[num])
		BlockImpact[num] = load_pcx ( file , 0 ) ;
	}

	CLEAR_BM(B_clock[0])
	B_clock[0] = load_pcx("sprites\\0.pcx",0);
	CLEAR_BM(B_clock[1])
	B_clock[1] = load_pcx("sprites\\1.pcx",0);
	CLEAR_BM(B_clock[2])
	B_clock[2] = load_pcx("sprites\\2.pcx",0);
	CLEAR_BM(B_clock[3])
	B_clock[3] = load_pcx("sprites\\3.pcx",0);
	CLEAR_BM(B_clock[4])
	B_clock[4] = load_pcx("sprites\\4.pcx",0);
	CLEAR_BM(B_clock[5])
	B_clock[5] = load_pcx("sprites\\5.pcx",0);
	CLEAR_BM(B_clock[6])
	B_clock[6] = load_pcx("sprites\\6.pcx",0);
	CLEAR_BM(B_clock[7])
	B_clock[7] = load_pcx("sprites\\7.pcx",0);
	CLEAR_BM(B_clock[8])
	B_clock[8] = load_pcx("sprites\\8.pcx",0);
	CLEAR_BM(B_clock[9])
	B_clock[9] = load_pcx("sprites\\9.pcx",0);

	CLEAR_BM(novic0)
	novic0 = load_pcx ( "sprites\\novic0.pcx", 0 );
	CLEAR_BM(novic1)
	novic1 = load_pcx ( "sprites\\novic1.pcx", 0 );

	CLEAR_BM(avic0)
	avic0 = load_pcx ( "sprites\\vic0.pcx", 0 );
	CLEAR_BM(avic1)
	avic1 = load_pcx ( "sprites\\vic1.pcx", 0 );

	override_config_file("sprites\\lifebars.ini");
	bar_dx	= get_config_int ( NULL , "lifebar_dx" , 20 ) ;
	bar_dy	= get_config_int ( NULL , "lifebar_dy" , 12 ) ;
	pbar_spr = get_config_int ( NULL , "powerbar_spr" , 1 ) ;
	pbar_dx  = get_config_int ( NULL , "powerbar_dx" , 7 ) ;
	pbar_dy  = get_config_int ( NULL , "powerbar_dy" , 230 ) ;
	tbar_dy  = get_config_int ( NULL , "timebar_dy" , 22 ) ;

	CLEAR_BM(LBbanner)
	LBbanner = load_pcx( "sprites\\lifebars.pcx", 0);

	CLEAR_BM(Bar)
	Bar = load_pcx( "sprites\\bar.pcx", 0);

	CLEAR_BM(Bar2)
	Bar2 = create_bitmap(Bar->w,Bar->h) ;
	draw_sprite_h_flip (Bar2, Bar, 0, 0) ;

	if (pbar_spr)
	{
		CLEAR_BM(Power)
		Power = load_pcx("sprites\\power.pcx", 0);
	}

	CLEAR_BM(PBar)
	PBar = load_pcx("sprites\\pbar.pcx", 0);

	closeZip();

 /**** MAIN MENU ****/

Demoniac:

	openZip(skinzip[getOptionValue(OPTION_SKIN)]);
	CLEAR_BM(Title)
	Title = load_pcx ( "title.pcx" , Pal ) ;
	closeZip();

	setMusicEnabled(1);
	setSFXEnabled(1);
	if (music==NULL)
	{
		gp32_set_speed(SPEED_133);
		gp32_initSound();
		if ((music = load_mod ("midi\\select.mod" ))==NULL)
			gp32_error("cant load select music");
		play_mod ( music ) ;
	}

	clear_keybuf() ;
	while(keypressed());

	GpSrand(GpTickCountGet());

	for (j=0; j < DEMO_TIME && !keypressed(); j++)
	{
		if ((j&0x1f)==0)
		{
			clear (virtscreen) ;
			draw_sprite ( virtscreen , Title , 0 , (240-Title->h)>>1 ) ;
			if (j&0x20)
				textout_centre(virtscreen,font,"PRESS START",160,200,0);
			blit_KOF91();
		}

		GpThreadSleep(40);

		poll_joystick() ;
		if ( key[KEY_ESC] )
		{
			CLEAR_MUSIC (music)
			freesounds();
			GpAppExit();
		}
	}
	while(buttonpressed());
	gmode = j==DEMO_TIME ? 3 : 2;

	clear_keybuf() ;

	story = 0 ;
	p2_sel = 0 ;

	if (gmode<3)
	{
		for ( cx = 0 ; cx < nbchar ; cx++ )
			defeated[cx] = 0 ;

		cx = 1 ;
		cy = 27 ;

		openZip(skinzip[getOptionValue(OPTION_SKIN)]);

		CLEAR_BM(Carton_KO)
		Carton_KO = load_pcx( "sprites\\mode.pcx", Pal);
	
		CLEAR_BM(Carton_WN)
		Carton_WN = load_pcx( "sprites\\pick.pcx", Pal);

		closeZip();
	
		clear_keybuf() ;
	
		clear (virtscreen) ;
		for (j=0;j<DEMO_TIME && cx;j++)
		{
			draw_sprite( virtscreen , Title, 0 , (240-Title->h)>>1 ) ;
			masked_blit ( Carton_KO , virtscreen , 0 , 0, (320-Carton_KO->w)/2, (3*240/4) - (Carton_KO->h/2), Carton_KO->w ,Carton_KO->h) ;
			masked_blit ( Carton_WN , virtscreen , 0 , 0, (320-Carton_KO->w)/2 + 12, (3*240/4) - (Carton_KO->h/2) + cy, Carton_WN->w ,Carton_WN->h) ;
	
			if (getOptionValue(OPTION_SHOWCFG)==0)
				textout(virtscreen,font,"R:config",4,220);
	
			blit_KOF91() ;
	
			poll_joystick() ;
	
			if ( keypressed()==KEY_F5 )
			{
				while(buttonpressed());
				j = getOptionValue(OPTION_SKIN);
				configMenu();
				if (getOptionValue(OPTION_SKIN)!=j)
					goto LoadSkin;
				j = 0;
			}
			else if ( key[KEY_ENTER] || JOY_WK(0) || JOY_SK(0) || JOY_WP(0) || JOY_SP(0) )
			{
				Done();
				cx = 0 ;
			}
	
			if ( JOY_UP(0) )
			{
				j = 0;
				if (gmode<2)
					gmode++ ;
				else
					gmode = 0 ;
				Bing();
				GpThreadSleep(200);
			}
	
			if ( JOY_DN(0)  )
			{
				j = 0;
				if (gmode>0)
					gmode-- ;
				else
					gmode = 2 ;
				Bing();
				GpThreadSleep(200);
			}
	
			GpThreadSleep(20);
	
			switch (gmode)
			{
				case 0 :
					p2_sel = 1 ;
					cy = 57 ;
					break ;
				case 1 :
					p2_sel = 0 ;
					cy = 42 ;
					break ;
				case 2 :
					p2_sel = 0 ;
					cy = 27 ;
					break ;
			}
	
			if ( key[KEY_ESC] )
			{
				goto Demoniac;
			}
		}
	
		if (j == DEMO_TIME)
			gmode = 3;
	}

	if (gmode < 3)
	{
		cx = 1 ;
		cy = 42 ;

		diff = 1 ;

		openZip(skinzip[getOptionValue(OPTION_SKIN)]);
		CLEAR_BM(Carton_KO)
		Carton_KO = load_pcx( "sprites\\diff.pcx", Pal);
		closeZip();

		while (buttonpressed());
		clear_keybuf() ;

		clear (virtscreen) ;
		while (cx)
		{
			draw_sprite( virtscreen , Title, 0 , (240-Title->h)>>1 ) ;
			masked_blit ( Carton_KO , virtscreen , 0 , 0, (320-Carton_KO->w)/2, (3*240/4) - (Carton_KO->h/2), Carton_KO->w ,Carton_KO->h) ;
			masked_blit ( Carton_WN , virtscreen , 0 , 0, (320-Carton_KO->w)/2 + 12, (3*240/4) - (Carton_KO->h/2) + cy, Carton_WN->w ,Carton_WN->h) ;
			blit_KOF91() ;

			poll_joystick() ;

			if ( key[KEY_ENTER] || JOY_WK(0) || JOY_SK(0) || JOY_WP(0) || JOY_SP(0) )
			{
				Done();
				cx = 0 ;
			}

			if ( JOY_UP(0) )
			{
				if (diff>0)
					diff-- ;
				else
					diff = 2 ;
				Bing();
				GpThreadSleep(200);
			}

			if ( JOY_DN(0)  )
			{
				if (diff<2)
					diff++ ;
				else
					diff = 0 ;
				Bing();
				GpThreadSleep(200);
			}

			GpThreadSleep(20);

			switch (diff)
			{
				case 0 :
					cy = 27 ;
					break ;
				case 1 :
					cy = 42 ;
					break ;
				case 2 :
					cy = 57 ;
					break ;
			}
		}
	}
	else
		diff = 2 ;

	clear (screen) ;

/* Selection Menu */

	CLEAR_BM(Title)
	CLEAR_BM(Carton_KO)
	CLEAR_BM(Carton_WN)

StartMenu:

	CLEAR_MUSIC(music)
	gp32_set_speed(SPEED_133);
	gp32_initSound();
	setMusicEnabled(1);
	setSFXEnabled(1);
	CLEAR_BM(Selecteur1)
	Selecteur1 = create_bitmap(400, 28);
	CLEAR_BM(Selecteur2)
	Selecteur2 = create_bitmap(400, 28);

	rectfill(Selecteur1, 0, 0,Selecteur1->w,Selecteur1->h, makecol(255,0,255));
	rectfill(Selecteur2, 0, 0,Selecteur2->w,Selecteur2->h, makecol(255,0,255));

	if (gmode)
		p2_sel = 0 ;

	CLEAR_MUSIC(music)
	if ( (music = load_mod ("midi\\select.mod" ))==NULL)
		gp32_error("can not load select.mod");
	play_mod ( music ) ;

 /**** initialisations ****/

	switch (gmode)
	{
		case 0:
		case 1:
			Players[0].sel = 1 ;
			Players[1].sel = 1 ;
			break;
		case 2:
			Players[0].sel = 1 ;
			if (!story)
			{
				Players[1].sel = 1;
				while(Players[1].sel==Players[0].sel)
					Players[1].sel = GpRandN(nbchar) ;
			}
			openZip(charzip[Players[1].sel]);
			strcpy ( file, "sprites\\" );
			strcat ( file, charname[Players[1].sel] );
			strcat ( file, "\\selbig.pcx" );
			CLEAR_BM(Face2)
			Face2 = load_pcx( file , Pal ) ;
			closeZip();
			break;
		case 3:
			n = GpRandN(2);
			Players[n].sel = GpRandN(nbchar) ;
			while (Players[0].sel==Players[1].sel)
				Players[n].sel = GpRandN(nbchar) ;
			break;
	}

	Players[0].old_sel = 2 ;
	Players[1].old_sel = 2 ;

	Players[0].flag  = 0 ;
	Players[1].flag = 0 ;
	Players[0].sens = 0 ;
	Players[1].sens = 0 ;

	frameskip = 0 ;

	round = 0 ;
	Players[0].vic = Players[1].vic = 0 ;

	Players[0].actual  = Players[1].actual = MV_STATIC ;

	last_char = 0 ;

	Players[0].ak = Players[1].ak = 0 ;
	Players[0].apch = Players[1].apch = 0 ;

	Players[0].limak = Players[1].limak = 1 ;

	Players[0].limp = 1 ;
	Players[1].limp = 1 ;

	if (gmode<3)
	{
		clear (virtscreen) ;
	
		for (cx=-4 ; cx<7 ; cx++)
		{
			fx = cx ;
	
			while ( fx<0 )
				fx = fx + nbchar ;
			while ( fx>(nbchar-1) )
				fx = fx - nbchar ;
	
			openZip(charzip[fx]);
	
			strcpy ( file, "sprites\\" );
			strcat ( file, charname[fx] );
			strcat ( file, "\\selsmall.pcx" );
	
			CLEAR_BM(Icon2)
			Icon2 = load_pcx ( file , Pal);
	
			closeZip();
	
			if ( Icon2 == NULL )
			{
				openZip(skinzip[getOptionValue(OPTION_SKIN)]);
				Icon2 = load_pcx ( "sprites\\selmiss.pcx", Pal);
				closeZip();
			}
			if (Icon2!=NULL)
			{
				if(secretchar[fx])
				{
					for (x = 0 ; x < Icon2->w ; x++)
					for (y = 0 ; y < Icon2->h ; y++)
					{
						if ( getpixel(Icon2, x, y) != tcolor )
							putpixel(Icon2, x, y, bcolor);
					}
				}
	
				blit ( Icon2, Selecteur2,  0 , 0, ((cx+4)*36)+4, 1, 26, 26) ;
				blit ( Icon2, Selecteur1,  0 , 0, ((cx+4)*36)+4, 1, 26, 26) ;
	
				if (secretchar[fx])
				{
					masked_blit ( Lock, Selecteur2,  0 , 0, ((cx+4)*36)+4, 1, 26, 26) ;
					masked_blit ( Lock, Selecteur1,  0 , 0, ((cx+4)*36)+4, 1, 26, 26) ;
				}
	
			}
			else
				gp32_error("can not load selmiss.pcx");
			CLEAR_BM(Icon2)
		}
	
		blit_KOF91() ;
	
		clear_keybuf() ;
	
		bgd = 0 ;
		j = 0 ;
	
		cx = 1;
		cy = fx = fy = 1 ;
	
		openZip(skinzip[getOptionValue(OPTION_SKIN)]);
		CLEAR_BM(Carton_KO)
		Carton_KO = load_pcx( "sprites\\back.pcx", Pal);
		CLEAR_BM(Carton_TO)
		Carton_TO = load_pcx( story ? "sprites\\versus.pcx":"sprites\\select.pcx", Pal);
		CLEAR_BM(B_Temp)
		if (Carton_KO==NULL)
		{
			Carton_KO = load_pcx( "sprites\\pattern.pcx", Pal);
			B_Temp = create_bitmap(320+Carton_KO->w,240+Carton_KO->h);
			drawing_mode(DRAW_MODE_COPY_PATTERN, Carton_KO, 0, 0 );
			rectfill(B_Temp, 0, 0,B_Temp->w,B_Temp->h, 12);
			drawing_mode(DRAW_MODE_SOLID , 0, 0, 0);
		}
		closeZip();
	
		clear (virtscreen) ;
		clear_keybuf();
	
		if (!story)
		{
			while ( cy || cx )
			{
				if (B_Temp!=NULL)
				{
					if ( bgd < Carton_KO->w-1 )
						bgd++ ;
					else
						bgd = 0 ;
					if ( j > 0)
						j-- ;
					else
						j = Carton_KO->h-1 ;
					blit(B_Temp,virtscreen,Carton_KO->w-bgd,Carton_KO->h-j,0,0,320,240);
				}
				else
					blit(Carton_KO,virtscreen,0,0,(320-Carton_KO->w)>>1,(240-Carton_KO->h)>>1,Carton_KO->w,Carton_KO->h);

				if (Carton_TO!=NULL)
					draw_sprite(virtscreen,Carton_TO,(320-Carton_TO->w)>>1,(240-Carton_TO->h)>>1);

				/* update character images if necessary */
				if ( (Players[0].old_sel != Players[0].sel) || (Players[1].old_sel != Players[1].sel) )
				{
					/*** load the face2 ***/
					if ( p2_sel && (Players[1].old_sel != Players[1].sel) )
					{
						openZip(charzip[Players[1].sel]);
						strcpy ( passeur, "sprites\\" );
						strcat ( passeur, charname[Players[1].sel] );
						strcat ( passeur, "\\selbig.pcx" );
						CLEAR_BM(Face2)
						Face2 = load_pcx (passeur ,Pal );
						textout_centre ( virtscreen , font , secretchar[Players[1].sel] ? (open2="LOCKED") : ( open2=charName[Players[1].sel] ) , 160 , 180 , sel_player2 ) ;
						strcpy ( charn2, open2 );
						if ( Face2 != NULL )
						{
							if(secretchar[Players[1].sel])
							{
								for (x = 0 ; x < Face2->w ; x++)
									for (y = 0 ; y < Face2->h ; y++)
									{
										if ( getpixel(Face2, x, y) != tcolor )
											putpixel(Face2, x, y, bcolor);
									}
							}
						}
						else
						{
							openZip(skinzip[getOptionValue(OPTION_SKIN)]);
							Face2 = load_pcx ( "sprites\\miss.pcx", Pal);
							closeZip();
						}

						draw_sprite_h_flip ( virtscreen, Face2, 220, 65 ) ;
						masked_blit ( Selecteur2, virtscreen , 39, 0, 0, 202, 320, 27);
						rect ( virtscreen , 144 , 202 , 171 , 229 , sel_player2 ) ;

						closeZip();
					}
	
					/*** load the face1 ***/
					if (Players[0].old_sel != Players[0].sel)
					{
						openZip(charzip[Players[0].sel]);
						strcpy ( passeur, "sprites\\" );
						strcat ( passeur, charname[Players[0].sel] );
						strcat ( passeur, "\\selbig.pcx" );
						CLEAR_BM(Face1)
						Face1 = load_pcx (passeur ,Pal );
						closeZip();
						textout_centre ( virtscreen , font , secretchar[Players[0].sel] ? (open1="LOCKED") : ( open1=charName[Players[0].sel] ) , 160 , 60 , sel_player1 ) ;
						strcpy ( charn1, open1 );
						if ( Face1 != NULL )
						{
							if (secretchar[Players[0].sel])
							{
								for (x = 0 ; x < Face1->w ; x++)
									for (y = 0 ; y < Face1->h ; y++)
									{
										if ( getpixel(Face1, x, y) != tcolor )
											putpixel(Face1, x, y, bcolor);
									}
							}
						}
						else
						{
							openZip(skinzip[getOptionValue(OPTION_SKIN)]);
							Face1 = load_pcx ( "sprites\\miss.pcx", Pal);
							closeZip();
						}

						draw_sprite( virtscreen , Face1, 0 , 65 ) ;
						masked_blit ( Selecteur1, virtscreen , 39, 0, 0, 10, 320, 27);
						rect ( virtscreen , 144 , 10 , 171 , 37 , sel_player1 ) ;
					}
				}
	
				if ( (Players[0].old_sel == Players[0].sel) || (Players[1].old_sel == Players[1].sel) )
				{
					if (Players[0].old_sel == Players[0].sel)
					{
						if (Face1 != NULL)
							draw_sprite( virtscreen , Face1, 0 , 65 ) ;
						textout_centre ( virtscreen , font ,(charn1)?charn1:"problem" , 160 , 60 , sel_player1 ) ;
						masked_blit ( Selecteur1, virtscreen , 39, 0, 0, 10, 320, 27);
						rect ( virtscreen , 144 , 10 , 171 , 37 , sel_player1 ) ;
					}
					if (Players[1].old_sel == Players[1].sel)
					{
						if ( p2_sel && (Face2 != NULL) )
						{
							draw_sprite_h_flip( virtscreen , Face2, 220 , 65 ) ;
							textout_centre ( virtscreen , font ,(charn2)?charn2:"problem", 160 , 180 , sel_player2 ) ;
							masked_blit ( Selecteur2, virtscreen , 39, 0, 0, 202, 320, 27);
							rect ( virtscreen , 144 , 202 , 171 , 229 , sel_player2 ) ;
						}
					}
				}
	
				blit_KOF91();
	
				if ( key[KEY_ESC] )
				{
					while (buttonpressed());
					CLEAR_BM(B_Temp)
					goto Demoniac ;
				}
	
				if (fy<1)
					fy++ ;
				else
					fy = 0 ;
	
				if (fy<1)
				{
					if (cy && p2_sel)
					{
						Players[1].old_sel = Players[1].sel ;
						poll_joystick() ;
						if ( gmode && ( JOY_SP(0) || JOY_WP(0) || JOY_SK(0) || JOY_WK(0) ) )
						{
							if ( secretchar[Players[1].sel] || Players[0].sel==Players[1].sel)
								Buzz() ;
							else
							{
								Done() ;
								cy = 0 ;
							}
						}
	
						if (gmode && (JOY_LT(0) || JOY_RT(0)))
						{
							Bing();
	
							if (JOY_LT(0))
							{
								Players[1].sel-- ;
								if ( Players[1].sel == -1 )
									Players[1].sel = nbchar-1 ;
								fx = Players[1].sel-5 ;
								while ( fx<0 )
									fx = fx + nbchar ;
							}
							else
							{
								Players[1].sel++ ;
								if ( Players[1].sel == nbchar )
									Players[1].sel = 0 ;
								fx = Players[1].sel+5 ;
								while ( fx>(nbchar-1) )
									fx = fx - nbchar ;
							}
	
							openZip(charzip[fx]);

							strcpy ( file, "sprites\\" );
							strcat ( file, charname[fx] );
							strcat ( file, "\\selsmall.pcx" );
	
							CLEAR_BM(Icon2)
							Icon2 = load_pcx ( file , Pal);

							closeZip();

							if ( Icon2 == NULL )
							{
								openZip(skinzip[getOptionValue(OPTION_SKIN)]);
								Icon2 = load_pcx ( "sprites\\selmiss.pcx", Pal);
								closeZip();
							}
							else if (secretchar[fx])
							{
								for (x = 0 ; x < Icon2->w ; x++)
									for (y = 0 ; y < Icon2->h ; y++)
									{
										if ( getpixel(Icon2, x, y) != tcolor )
											putpixel(Icon2, x, y, bcolor);
									}
							}

							if (JOY_LT(0))
							{
								blit ( Selecteur2 , Selecteur2 , 0 , 0, 36, 0, 360, 27 ) ;
								blit ( Icon2, Selecteur2,  0 , 0, 4, 1, 26, 26) ;
								if (secretchar[fx])
									masked_blit ( Lock, Selecteur2,  0 , 0, 4, 1, 26, 26) ;
							}
							else
							{
								blit ( Selecteur2 , Selecteur2 , 36 , 0, 0, 0, 360, 27 ) ;
								blit ( Icon2, Selecteur2,  0 , 0, 364, 1, 26, 26) ;
								if (secretchar[fx])
									masked_blit ( Lock, Selecteur2,  0 , 0, 364, 1, 26, 26) ;
							}
						}
					}
	
					if (cx)
					{
						Players[0].old_sel = Players[0].sel ;
						poll_joystick() ;
						if ( JOY_WK(0) || JOY_SK(0) || JOY_WP(0) || JOY_SP(0) )
						{
							if ( secretchar[Players[0].sel] )
								Buzz() ;
							else
							{
								Done() ;
								if (gmode==2)
								{
									story=1 ;
									cy=0 ;
									defeated[Players[0].sel] = 1;
								}
								p2_sel = 1 ;
								Players[1].old_sel = 2 ;
								cx = 0 ;
							}
							while(buttonpressed());
						}
	
						if ( JOY_LT(0) || JOY_RT(0))
						{
							Bing();
	
							if (JOY_LT(0))
							{
								Players[0].sel-- ;
								if ( Players[0].sel == -1 )
									Players[0].sel = nbchar-1 ;
								fx = Players[0].sel-5 ;
								while ( fx<0 )
									fx = fx + nbchar ;
							}
							else
							{
								Players[0].sel++ ;
								if ( Players[0].sel == nbchar )
									Players[0].sel = 0 ;
								fx = Players[0].sel+5 ;
								while ( fx>(nbchar-1) )
									fx = fx - nbchar ;
							}
	
							openZip(charzip[fx]);
	
							strcpy ( file, "sprites\\" );
							strcat ( file, charname[fx] );
							strcat ( file, "\\selsmall.pcx" );
	
							CLEAR_BM(Icon1)
							Icon1 = load_pcx ( file , Pal);

							closeZip();

							if ( Icon1 == NULL )
							{
								openZip(skinzip[getOptionValue(OPTION_SKIN)]);
								Icon1 = load_pcx ( "sprites\\selmiss.pcx", Pal);
								closeZip();
							}
							else if(secretchar[fx])
							{
								for (x = 0 ; x < Icon1->w ; x++)
									for (y = 0 ; y < Icon1->h ; y++)
									{
										if ( getpixel(Icon1, x, y) != tcolor )
											putpixel(Icon1, x, y, bcolor);
									}
							}

							if (JOY_LT(0))
							{
								blit ( Selecteur1 , Selecteur1 , 0 , 0, 36, 0, 360, 27 ) ;
								blit ( Icon1, Selecteur1,  0 , 0, 4, 1, 26, 26) ;
								if (secretchar[fx])
									masked_blit ( Lock, Selecteur1,  0 , 0, 4, 1, 26, 26) ;
							}
							else
							{
								blit ( Selecteur1 , Selecteur1 , 36 , 0, 0, 0, 360, 27 ) ;
								blit ( Icon1, Selecteur1,  0 , 0, 364, 1, 26, 26) ;
								if (secretchar[fx])
									masked_blit ( Lock, Selecteur1,  0 , 0, 364, 1, 26, 26) ;
							}
						}
					}
				}
			}
		}
		else /* story */
		{
			Players[0].sel = Players[0].load_sel ;
			cy = cx = 1 ;
			for ( x = 0 ; x < nbchar && cy ; x++ )
			{
				if (!defeated[x] && !secretchar[x] && present[x])
					cy = 0 ;
			}
	
			if (cy) /* end of game */
			{
				for ( x = 0 ; x < nbchar ; x++ )
					secretchar[x] = 0 ;
	
				openZip(skinzip[getOptionValue(OPTION_SKIN)]);
				CLEAR_BM(Selecteur1)
				if((Selecteur1 = load_pcx ( "sprites\\end.pcx" , 0 ))==NULL)
				{
					gp32_error("can not load end.pcx");
				}
				closeZip();
				while (buttonpressed());
				cx=1 ;
				while (cx)
				{
					if (B_Temp!=NULL)
					{
						if ( bgd < Carton_KO->w-1 )
							bgd++ ;
						else
							bgd = 0 ;
						if ( j > 0)
							j-- ;
						else
							j = Carton_KO->h-1 ;
						blit(B_Temp,virtscreen,Carton_KO->w-bgd,Carton_KO->h-j,0,0,320,240);
					}
					else
						blit(Carton_KO,virtscreen,0,0,(320-Carton_KO->w)>>1,(240-Carton_KO->h)>>1,Carton_KO->w,Carton_KO->h);

					if (Carton_TO!=NULL)
						draw_sprite(virtscreen,Carton_TO,(320-Carton_TO->w)>>1,(240-Carton_TO->h)>>1);

					masked_blit ( Selecteur1, virtscreen , 0, 0, 0, 0, 320, 240);
	
					if (cx==2)
					{
						textout_centre ( virtscreen , font ,"GAME" , 240 , 90 , sel_player1 ) ;
						textout_centre ( virtscreen , font ,"OVER" , 240 , 110 , sel_player1 ) ;
					}
	
					blit_KOF91();
	
					poll_joystick();
	
					if (  key[KEY_ENTER] || JOY_WK(0) || JOY_SK(0) || JOY_WP(0) || JOY_SP(0) )
					{
						if (cx==1)
						{
							openZip(charzip[Players[0].sel]);
	
							strcpy ( passeur, "sprites\\" );
							strcat ( passeur, charname[Players[0].sel] );
							strcat ( passeur, "\\endimg.pcx" );
	
							CLEAR_BM(b)
							if((b = load_pcx ( passeur , 0 ))!=NULL)
							{
								Selecteur1 = b ;
								b = NULL;
								cx = 2 ;
								clear_keybuf();
							}
							else
								cx = 0 ;
							closeZip();
						}
						else
							cx = 0 ;
					}
				}
	
				while (buttonpressed());
				CLEAR_MUSIC (music)
				CLEAR_BM(B_Temp)
	
				goto Demoniac ;
			}
	
			cy = defeated[Players[1].sel];
	
			while (cy)
			{
				Players[1].sel = GpRandN(nbchar) ;
				if (!defeated[Players[1].sel] && !secretchar[Players[1].sel] & present[Players[1].sel])
					cy = 0 ;
			}
	
			openZip(charzip[Players[1].sel]);
	
			strcpy ( file, "sprites\\" );
			strcat ( file, charname[Players[1].sel] );
			strcat ( file, "\\selbig.pcx" );
	
			CLEAR_BM(Face2)
			Face2 = load_pcx( file , Pal ) ;
	
			closeZip();
	
			openZip(charzip[Players[0].sel]);
	
			strcpy ( passeur, "sprites\\" );
			strcat ( passeur, charname[Players[0].sel] );
			strcat ( passeur, "\\selbig.pcx" );
	
			CLEAR_BM(Face1)
			Face1 = load_pcx ( passeur , Pal);
	
			closeZip();
	
			bgd = 0 ;
			j = 0 ;
	
			cx = 1 ;
	
			while (cx)
			{
				poll_joystick();
	
				if ( key[KEY_ESC] )
				{
					while (buttonpressed());
					CLEAR_BM(B_Temp)
					goto Demoniac ;
				}
				if (B_Temp!=NULL)
				{
					if ( bgd < Carton_KO->w-1 )
						bgd++ ;
					else
						bgd = 0 ;
					if ( j > 0)
						j-- ;
					else
						j = Carton_KO->h-1 ;
					blit(B_Temp,virtscreen,Carton_KO->w-bgd,Carton_KO->h-j,0,0,320,240);
				}
				else
					blit(Carton_KO,virtscreen,0,0,(320-Carton_KO->w)>>1,(240-Carton_KO->h)>>1,Carton_KO->w,Carton_KO->h);
	
				if (Face2 != NULL)
					draw_sprite_h_flip( virtscreen , Face2, 220 , 65 ) ;
				if (Face1 != NULL)
					draw_sprite( virtscreen , Face1, 0 , 65 ) ;

				if (B_Temp!=NULL && Carton_TO==NULL)
				{
					textout_centre ( virtscreen , font ,"NEXT OPPONENT" , 160 , 90 , sel_player1 ) ;
					textout_centre ( virtscreen , font , (open2=charName[Players[1].sel]) , 160 , 140 , sel_player2 ) ;
				}
				if (Carton_TO!=NULL)
					draw_sprite(virtscreen,Carton_TO,(320-Carton_TO->w)>>1,(240-Carton_TO->h)>>1);
	
				blit_KOF91();
	
				if ( key[KEY_ENTER] || JOY_WK(0) || JOY_SK(0) || JOY_WP(0) || JOY_SP(0) )
				{
					Done();
					cx = 0 ;
				}
			}
		}
	}

	clear( virtscreen );
	blit_KOF91();

	clear_keybuf();

	override_config_file( "sprites\\bkgd.ini" );

	open1 = get_config_string ( NULL , charname[Players[1].sel] , NULL ) ;

	if (open1!=NULL)
	{
		for (bgd=0;bgd<nbbkgd;bgd++)
		{
			if (strcasecmp(bkgdname[bgd],open1)==0)
				break;
		}
		if (bgd==nbbkgd)
			bgd = GpRandN(nbbkgd) ;
	}
	else if (gmode==3 || (gmode==2 && getOptionValue(OPTION_RNDSTORY)==0))
		bgd = GpRandN(nbbkgd) ;
	else
	{
		cx = 1 ;
		bgd = 1 ;
		CLEAR_BM(Carton_R1)
		Carton_R1 = create_bitmap((180*320)/240, 180);
		load_background(bgd);
		fx =1 ;
		poll_joystick();
		while ( cx )
		{
			if (B_Temp!=NULL)
			{
				if ( Players[1].sol < Carton_KO->w-1 )
					Players[1].sol++ ;
				else
					Players[1].sol = 0 ;
				if ( j > 0)
					j-- ;
				else
					j = Carton_KO->h-1 ;
				blit(B_Temp,virtscreen,Carton_KO->w-Players[1].sol,Carton_KO->h-j,0,0,320,240);
			}
			else
				blit(Carton_KO,virtscreen,0,0,(320-Carton_KO->w)>>1,(240-Carton_KO->h)>>1,Carton_KO->w,Carton_KO->h);

			if (Carton_TO!=NULL)
				draw_sprite(virtscreen,Carton_TO,(320-Carton_TO->w)>>1,(240-Carton_TO->h)>>1);

			draw_sprite( virtscreen , Carton_R1 , (320-Carton_R1->w)>>1 , 30 );
			textout_centre ( virtscreen , font ,"< select background >" , 160 , 220 , sel_player1 ) ;
			blit_KOF91();
			poll_joystick();
	
			if (fx<2) fx++ ;
			else fx = 0 ;
	
			if (fx<1)
			{
				if ( key[KEY_ENTER] || JOY_WK(0) || JOY_SK(0) || JOY_WP(0) || JOY_SP(0) )
				{
					Done();
					cx = 0 ;
				}
	
				if ( JOY_LT(0) )
				{
					bgd-- ;
					while ( bgd<0 ) bgd = bgd + nbbkgd ;
					load_background(bgd);
					Bing();
				}
	
				if( JOY_RT(0) )
				{
					bgd++ ;
					while ( bgd>(nbbkgd-1) ) bgd = bgd - nbbkgd ;
					load_background(bgd);
					Bing();
				}
			}
		}
	}
	CLEAR_BM(Carton_KO)
	CLEAR_BM(Carton_TO)
	CLEAR_BM(B_Temp)
	CLEAR_BM(Icon1)
	CLEAR_BM(Icon2)
	CLEAR_BM(Selecteur1)
	CLEAR_BM(Selecteur2)
	CLEAR_BM(Carton_R1)
	CLEAR_BM(Carton_R2)
	CLEAR_MUSIC(music)

	clear (screen) ;
	clear (virtscreen) ;

	setMusicEnabled(getOptionValue(OPTION_MUSIC)==0);
	setSFXEnabled(getOptionValue(OPTION_SFX)==0);

	loading = 0;
	openZip(skinzip[getOptionValue(OPTION_SKIN)]);
	CLEAR_BM(Title)
	Title = load_pcx ( "title.pcx" , Pal ) ;
	closeZip();
	showLoading(0);

	/******* GET CHARACTER 1 INFO *********************/

	if (Players[0].load_sel!=Players[0].sel)
	{
		openZip(charzip[Players[0].sel]);
		strcpy ( sectn, charname[Players[0].sel] );
		strcpy ( passeur, "sprites\\" );
		strcat ( passeur, sectn );
		strcat ( passeur, "\\char.ini" );
		load_char(passeur,0);
		Players[0].tol = Players[0].width -  Players[0].statik.defx ;
		showLoading(5);
		load_sprites (0) ;
		closeZip();
	}

	showLoading(-50);

	/******* GET CHARACTER 2 INFO *********************/

	if (Players[1].load_sel!=Players[1].sel)
	{
		openZip(charzip[Players[1].sel]);
		strcpy ( sectn, charname[Players[1].sel] );
		strcpy ( passeur, "sprites\\" );
		strcat ( passeur, sectn );
		strcat ( passeur, "\\char.ini" );
		load_char(passeur,1);
		if (gmode)
		{
			switch (diff)
			{
				case 0 :
					offense = get_config_int ( sectn , "easy_off" , easy_off) ;
					defense = get_config_int ( sectn , "easy_def" , easy_def) ;
					break ;
				case 2 :
					offense = get_config_int ( sectn , "hard_off" , hard_off) ;
					defense = get_config_int ( sectn , "hard_def" , hard_def) ;
					break ;
				case 1 :
				default:
					offense = get_config_int ( sectn , "medium_off" , medium_off) ;
					defense = get_config_int ( sectn , "medium_def" , medium_def) ;
					break ;
			}
			defense = 50 + (defense>>1);
/*			offense = 50 + (offense>>1);*/
		}
		Players[1].tol = Players[1].width - Players[1].statik.defx ;
		showLoading(5);
		load_sprites (1) ;
		closeZip();
	}

	showLoading(-95);

/*********** ALL SPRITES ARE NOW IN MEMORY ********/

	/* LOADING THE BACKGROUND NOW */

	foreground = animated = 0 ;

	strcpy ( file , "bkgds\\" );
	strcat ( file , bkgdname[bgd] );

	CLEAR_BM(Bkgd)
	if ((Bkgd = load_pcx( file , 0 ))==NULL)
	{
		if ( (open_fli ( file ) != FLI_OK) )
		{
			gp32_error("can not load Bkgd");
		}
		else
		{
			reset_fli_variables() ;
			next_fli_frame(1) ;
			if (getOptionValue(OPTION_BKGDANIM)==0)
			{
				Bkgd = fli_bitmap ;
				animated = 1 ;
			}
			else
			{
				Bkgd = clone_bitmap(fli_bitmap);
				animated = 0 ;
				close_fli();
			}
			foreground = 0 ;
		}
	}
	else
	{
		animated = 0 ;

		strcpy ( file , "bkgds\\frgds\\" );
		strcat ( file , bkgdname[bgd] );

		CLEAR_BM(Frgd)
		if (getOptionValue(OPTION_FRGD)==1 || (Frgd = load_pcx( file , 0 ))==NULL)
			foreground = 0 ;
		else
		{
			foreground = 1 ;
			set_foreground(Frgd);
			CLEAR_BM(Frgd)
		}
	}

	if (Bkgd->h>=240)
	{
		ZW = zoomwidth = 320;
		zoomsup = Bkgd->h - 240 ;
	}
	else
	{
		ZW = zoomwidth = ((320*Bkgd->h)/240);
		zoomsup = 0;
	}
	bkgdlim = Bkgd->w - ZW ;
	ZOOM = (ZW*1.0f)/240;
	ZH = (240+zoomsup)*ZOOM;
	bkgd_delay = 15 ;

	CLEAR_BM(zoomscreen)
	zoomscreen = clone_bitmap(Bkgd);
	init_bkgd_save();
	if (animated)
		fli_screen(zoomscreen);
	skp_flag = getOptionValue(OPTION_FSKIP);

	/* BACKGROUND LOADED */

	y = ustrlen( bkgdname[bgd] );
	strcpy ( file , "midi\\" );
	ustrncat( file , bkgdname[bgd], y-4 );
	strcat ( file , ".mod" );
	CLEAR_MUSIC(music)
	if ( (music = load_mod ( file ))==NULL)
	{
		gp32_error("can not load background song");
	}

	/* MUSIC FILE LOADED */

	if (getOptionValue(OPTION_FIGHTANIM)==0)
	{
		load_intro(0);
		load_intro(1);
	}

	showLoading(-100);
	CLEAR_BM(Title)

	/* some more character info that depends from zoomsup */

	Players[1].sol = Bkgd->h - 15 - Players[1].height ;
	Players[1].jump_how = Bkgd->h - 75 - Players[1].height ;
	Players[0].sol = Bkgd->h - 15 - Players[0].height ;
	Players[0].jump_how = Bkgd->h - 75 - Players[0].height ;

	/******/

	cx = (int)(bkgdlim/2) ;
	cy = zoomsup ;
	Players[0].x = ((cx+(zoomwidth/4)) - (Players[0].width/2)) ;
	Players[0].y = Players[0].sol ;
	Players[1].x = ((cx+((3*zoomwidth)/4)) - (Players[1].width/2));
	Players[1].y = Players[1].sol ;
	Players[0].flag = Players[1].flag = 1 ;
	Players[0].spower = Players[1].spower = 0 ;
	Players[0].fireb.succ = Players[1].fireb.succ = 0 ;
	Players[0].rush.succ = Players[1].rush.succ = 0 ;
	Players[0].rush_stop = Players[1].rush_stop = 0 ;
	Players[0].smove_stop = Players[1].smove_stop = 0 ;
	Players[0].firebx.succ = Players[1].firebx.succ = 0 ;
	Players[0].rushx.succ = Players[1].rushx.succ = 0 ;
	Players[0].rushx_stop = Players[1].rushx_stop = 0 ;
	Players[0].smovex_stop = Players[1].smovex_stop = 0 ;
	Players[0].wimpact_ct = Players[1].wimpact_ct = 0 ;
	Players[0].simpact_ct = Players[1].simpact_ct = 0 ;
	Players[0].bimpact_ct = Players[1].bimpact_ct = 0 ;

	Players[0].damag = Players[1].damag = 1 ;
	Players[0].autho_ht = Players[1].autho_ht = 0 ;
	Players[0].life = Players[1].life = max_life = Bar->w*4+1 ;

	Players[0].fballs[0].on = Players[0].fballs[1].on = 0;
	Players[1].fballs[0].on = Players[1].fballs[1].on = 0;

	Players[0].invers = 0;
	Players[1].invers = 1;

	clock_frame = 0;
	t_clock = t_clock_ini;
	gm_sprintf(s_cron,"%d",t_clock);
	c_dez =s_cron[0]-48;
	c_uni =s_cron[1]-48;

	deb = 1 ;
	round = 1 ;
	Players[0].vic = Players[1].vic = 0 ;
	vsynch = 1 ;
	ok = 1 ;
	vic_flag = 1 ;

	clear(screen);

	gp32_set_speed(getOptionValue(OPTION_SPEED));
	gp32_initSound();

	play_mod (music ) ;

	/********* THE REAL GAME STARTS HERE ***********************/

	/* Loop until we're asked to exit */
	while( ok )
	{
		/* Round beginning Loop */
		while ( deb )
		{
			if (getOptionValue(OPTION_FIGHTANIM)==0)
			{
				if ( (round == 1) && (!checkint) )
				{

					if (Players[0].intro.nbf<Players[1].intro.nbf)
						showIntro(0);
					else
						showIntro(1);
					checkint = 1 ;
				}
			}

			deb++;

			if ( deb == 2 )
			{
				enable_rle_cache();
				if ((round == 1) && (getOptionValue(OPTION_FIGHTANIM)==0))
				{
					unload_anim(0,Players[0].intro.nbf);
					unload_anim(1,Players[1].intro.nbf);
				}
			}

			if ( deb == 25 )
				Round (round) ;

			if ( deb == 140 )
				Fight() ;

			/* Update the real screen */

			if (animated)
				bkgd_counter++;

			blit_KOF91();
			blit_Bkgd() ;
			GStatic(1, (int)(Players[1].flag/Players[1].statik.spd) ) ;
			GStatic(0, (int)(Players[0].flag/Players[0].statik.spd) ) ;
			showZoom(cx);

			Players[0].flag++;
			Players[1].flag++;
			if (Players[0].flag > ((Players[0].statik.spd*Players[0].statik.nbf)-1) )
				Players[0].flag = 0 ;
			if (Players[1].flag > ((Players[1].statik.spd*Players[1].statik.nbf)-1) )
				Players[1].flag = 0 ;

			if ( (deb > 25) && (deb < 125) )
			{
				switch ( round )
				{
					case 2 : b = Carton_R2; break;
					case 3 : b = Carton_R3; break;
					default:
					case 1 : b = Carton_R1; break;
				}
				if (deb <51)
					angle = (deb - 25) * (b->w/25) ;
				else if (deb > 99)
					angle = (25-(deb - 100)) * (b->w/25) ;
				else
					angle = b->w ;

 				stretch_sprite (virtscreen ,b, (320-angle)/2, (240-b->h)/2, angle , b->h);
				b = NULL;
			}
			else if ( (deb > 140) && (deb < 170) )
			{
				masked_blit ( Carton_FT , virtscreen , 0 , 0, (320-Carton_FT->w)/2, (240-Carton_FT->h)/2, Carton_FT->w ,Carton_FT->h) ;
			}
			else if ( deb == 170 )
			{
				CLEAR_SAMPLE(fight)
				CLEAR_BM(Carton_FT)
			}
			else if ( deb > 170 )
			{
				if (!nbpar)
				{
					/* Frame count starts at 0 */
					n = 0;
					clear_keybuf();
					poll_joystick();
				}
				deb = 0 ;
			}
		}

		if (frameskip<skp_flag)
			frameskip++;
		else
			frameskip = 0 ;

		if (animated)
			bkgd_counter++;

		if (!frameskip)
		{
			/* Increment the frame count */
			if (!nbpar)
				n++;
			vic_flag++;
			if (vic_flag>40)
				vic_flag = 1 ;

			blit_KOF91();
			blit_Bkgd() ;

			/* Draw the sprites */
			if ( Players[0].actual <= MV_CROUCH || Players[0].actual >= MV_GUARD || Players[1].actual == MV_SMOVEX || Players[1].actual == MV_FIREBX)
				x = 0;
			else
				x = 1;
			y = 1-x;

			drawPlayer(x);
			drawPlayer(y);

			if (Players[x].fballs[0].on) GFBall (x, (Players[x].fballs[0].flg/Players[x].fball.spd)) ;
			if (Players[y].fballs[0].on) GFBall (y, (Players[y].fballs[0].flg/Players[y].fball.spd)) ;
			if (Players[x].fballs[1].on) GFBallX (x, (Players[x].fballs[1].flg/Players[x].fballx.spd)) ;
			if (Players[y].fballs[1].on) GFBallX (y, (Players[y].fballs[1].flg/Players[y].fballx.spd)) ;

			/* impacts */
			drawImpact(x);
			drawImpact(y);

			showZoom(cx);

			/* If a key is hit, check it out */
			if( keypressed() )
			{
				if (gmode==3)
					ok = 0;
				else if ( key[KEY_ESC] )
				{
					x=1 ;
					y=1 ;

					while (x)
					{
						blit_KOF91() ;
						rectfill(virtscreen, 60, 70,260,130, 0);
						textout_centre ( virtscreen , font ,(y) ? "> CONTINUE <":"CONTINUE",160 , 90 , 0) ;
						textout_centre ( virtscreen , font ,(y) ? "QUIT TO MAIN MENU":"> QUIT TO MAIN MENU <", 160 , 110 , 0) ;
						poll_joystick();

						if ( key[KEY_ENTER] || JOY_WK(0) || JOY_SK(0) || JOY_WP(0) || JOY_SP(0) )
						{
							if (y)
								x = 0 ;
							else
							{
								ok = 0 ;
								x = 0 ;
							}
						}
						if ( JOY_UP(0) || JOY_DN(0) || JOY_RT(0) || JOY_LT(0) )
						{
							Bing() ;
							GpThreadSleep(200+50*getOptionValue(OPTION_SPEED));
							if (y)
								y=0 ;
							else
								y = 1 ;
						}
						GpThreadSleep(70);
					}
					clear_keybuf();
				}
			}
		}

		if (gmode==3)
			checkAI(0);
		else
			checkInput(0);

		if (!gmode)
			checkInput(1);
		else
			checkAI(1);

		checkAttack(0);
		checkAttack(1);

		staticUpdating(0);
		staticUpdating(1);
		playerAnim(0);
		playerAnim(1);
		updateFireBalls(0);
		updateFireBalls(1);

		/***** CHECK AND UPDATE LIFEBARS **********/

		draw_sprite( virtscreen , LBbanner ,0 ,0 ) ;
		blit ( Bar, virtscreen, (Bar->w-(Players[0].life/4)), 0, bar_dx+(Bar->w-(Players[0].life/4)), bar_dy,(Players[0].life/4)+2, Bar->h ) ;
		blit ( Bar2, virtscreen, 0, 0, 319-Bar2->w-bar_dx, bar_dy,(Players[1].life/4)+1, Bar2->h ) ;

		if (Players[0].spower>=PBar->w)
		{
			Players[0].spower = PBar->w ;
			Players[0].firebx.sflg = Players[0].rushx.sflg = Players[0].smovex.sflg = 1 ;
		}
		if (Players[1].spower>=PBar->w)
		{
			Players[1].spower = PBar->w ;
			Players[1].firebx.sflg = Players[1].rushx.sflg = Players[1].smovex.sflg = 1 ;
		}
		if (pbar_spr)
		{
			draw_sprite( virtscreen , Power , 4,212 ) ;
			draw_sprite( virtscreen , Power , 249,212 ) ;
		}

		blit ( PBar, virtscreen, 0, 0, pbar_dx, pbar_dy,Players[0].spower, PBar->h ) ;
		blit ( PBar, virtscreen, 0, 0, 319-pbar_dx-Players[1].spower, pbar_dy,Players[1].spower, PBar->h ) ;

		/*** TIME OVER ***/

		if (clock_frame++ >= t_decrement*(skp_flag+1))
		{
			clock_frame = 0;
			if (t_clock-- <= 1)
			{
				if (Players[0].life < Players[1].life)
					Players[0].life = 0;
				else
					Players[1].life = 0;
			}
			gm_sprintf(s_cron, "%d", t_clock);
			c_dez = s_cron[0] - 48;
			c_uni = s_cron[1] - 48;
		}
 		if (s_cron[1] != 0)
		{
			draw_sprite(virtscreen, B_clock[c_dez], 160-B_clock[c_dez]->w-1, tbar_dy);
			draw_sprite(virtscreen, B_clock[c_uni], 161, tbar_dy);
		}
		else
			draw_sprite(virtscreen, B_clock[c_dez], 160-(B_clock[c_dez]->w>>1), tbar_dy);

		/**** VICTORY FLAGS ***/
	
		if (vic_flag>20)
		{
			if (Players[0].vic)
				draw_sprite( virtscreen , avic1 ,10 ,24 ) ;
			else
				draw_sprite( virtscreen , novic1 ,10 ,24 ) ;
			if (Players[1].vic)
				draw_sprite( virtscreen , avic1 ,294 ,24 ) ;
			else
				draw_sprite( virtscreen , novic1 ,294 ,24 ) ;
		}
		else
		{
			if (Players[0].vic)
				draw_sprite( virtscreen , avic0 ,10 ,24 ) ;
			else
				draw_sprite( virtscreen , novic0 ,10 ,24 ) ;
			if (Players[1].vic)
				draw_sprite( virtscreen , avic0 ,294 ,24 ) ;
			else
				draw_sprite( virtscreen , novic0 ,294 ,24 ) ;
		}
	
		/**** END OF ROUND ****/
	
		if ( ( Players[0].life <= 0 ) || ( Players[1].life <= 0 ) )
		{
			disable_rle_cache();
			nbpar++ ;
			checkint = 0 ;
			Players[0].flag = Players[1].flag = 1 ;

			openZip(skinzip[getOptionValue(OPTION_SKIN)]);
			CLEAR_BM(Carton_WN)
			Carton_WN = load_pcx("sprites\\winner.pcx", 0);
			closeZip();

			showWinner(Players[0].life <= 0 ? 1 : 0);

			if (Players[0].vic > 1)
			{
				if (gmode==3)
				{
					destroy_bitmaps();
					goto Demoniac;
				}
				blit_KOF91();
				clear ( virtscreen ) ;
				draw_sprite (virtscreen ,Carton_WN , (320-Carton_WN->w)/2, 20 );
				if ( Face1 != NULL )
					draw_sprite( virtscreen , Face1,(320-Face1->w)/2, 30+Carton_WN->h ) ;
				blit_KOF91();

				while(!buttonpressed());
	
				destroy_bitmaps();
	
				if (gmode==2)
				{
					defeated[Players[1].load_sel] = 1 ;
					story = 1 ;
				}
	
				goto StartMenu;
			}
			else if (Players[1].vic > 1)
			{
				if (gmode==3)
				{
					destroy_bitmaps();
					goto Demoniac;
				}
				if (gmode)
				{
					CLEAR_BM(Carton_WN)
					Carton_WN = load_bitmap ( "sprites\\lose.pcx" , 0 ) ;
				}
				blit_KOF91();
				clear ( virtscreen ) ;
				draw_sprite (virtscreen ,Carton_WN , (320-Carton_WN->w)/2, 20 );
				if ( Face2 != NULL )
					draw_sprite( virtscreen , Face2,(320-Face1->w)/2, 30+Carton_WN->h ) ;
				blit_KOF91();
	
				while(!buttonpressed());
	
				destroy_bitmaps();
	
				if (gmode==2)
					story = 1 ;
	
				goto StartMenu;
			}
	
			round++;
	
			CLEAR_BM(Carton_WN)
	
			Players[0].life = Players[1].life = max_life;
			Players[0].actual = Players[1].actual = MV_STATIC ;
	
			clock_frame = 0;
			t_clock = t_clock_ini;
			gm_sprintf(s_cron, "%d", t_clock);
			c_dez = s_cron[0] - 48;
			c_uni = s_cron[1] - 48;
	
			Players[0].wimpact_ct = Players[1].wimpact_ct = 0 ;
			Players[0].simpact_ct = Players[1].simpact_ct = 0 ;
			Players[0].bimpact_ct = Players[1].bimpact_ct = 0 ;
	
			Players[0].flag = Players[1].flag = 1 ;
	
			Players[0].fballs[0].on = Players[1].fballs[0].on = 0 ;
	
			Players[0].fireb.succ = Players[1].fireb.succ = 0 ;
			Players[0].rush.succ = Players[1].rush.succ = 0 ;
			Players[0].rush_stop = Players[1].rush_stop = 0 ;
			Players[0].smove_stop = Players[1].smove_stop = 0 ;
	
			Players[0].x = (cx + 75 - (Players[0].width/2)) ;
			Players[0].y = Players[0].sol ;
			Players[1].x = (cx + 250 -(Players[1].width/2));
			Players[1].y = Players[1].sol ;

			zoomwidth = ZW;

			Players[0].invers = 0;
			Players[1].invers = 1;

			deb = 1 ;
		}
	}
	/****** END OF THE 'REAL GAME' LOOP ******/

	/******** SMALL ENDING STUFF *****************/

	disable_rle_cache();
	destroy_bitmaps();
	checkint = 0 ;
	goto Demoniac;
}

/*
 * Loading progress bar
 */

void showLoading(int i)
{
	loading = i<0 ? -i : loading+i;
	clear(virtscreen);
	blit(Title,virtscreen,0,0,(320-Title->w)>>1,(240-Title->h)>>1,Title->w,Title->h);
	textout_centre ( virtscreen , font , "Loading..."  ,160 , 212 , sel_player1 ) ;
	rect(virtscreen, 40, 170,280,200, sel_player1);
	if (loading>0)
		rectfill(virtscreen, 40, 170,40+(240*loading)/100,200, sel_player1);
	blit_KOF91();
}

/*
 * Show intro animations
 */

void Intro(void)
{
	char bab ; /* dumb variables*/
	int mvb = 20;
	bab = 1 ;
	clear (virtscreen) ;
	clear (screen);

	if ( open_fli ("open.flc") != FLI_OK )
		gp32_error("can not load open.flc");

	do
	{
		if(mvb++>1)
			mvb = 0 ;
		if(!mvb)
		{
			reset_fli_variables() ;
			if ( next_fli_frame ( 0 ) != FLI_OK )
				bab = 0 ;
			if (keypressed())
				bab = 0 ;
			blit ( fli_bitmap , virtscreen , 0 , 0 , 0 , 20 , 320 , 240 ) ;
			blit_KOF91();
			GpThreadSleep(30);
		}
	}
	while ( bab ) ;

	while(buttonpressed());

	close_fli () ;
	clear_keybuf () ;
	clear (virtscreen) ;
	mvb = 20 ;

	CLEAR_MUSIC(music)
	play_mod(music = load_mod ("midi\\intro.mod" ));

	if ( open_fli ("intro.flc") != FLI_OK )
		gp32_error("can not load intro.flc");

	do
	{
		if(mvb++>0)
			mvb = 0 ;
		if(mvb)
		{
			if ( next_fli_frame ( 1 ) != FLI_OK )
				simulate_keypress (KEY_SPACE) ;
			blit ( fli_bitmap , virtscreen , 0 , 0 , 0 , 20 , 320 , 240 ) ;
			blit_KOF91();
			reset_fli_variables() ;
			GpThreadSleep(22);
		}
	}
	while ( !keypressed() ) ;

	while(buttonpressed());

	close_fli () ;
}

/*
 * Display current frame
 */

void blit_KOF91 (void)
{
	acquire_screen();
	blit ( virtscreen , screen , 0, 0, 0, 0, 320, 240 ) ;
	release_screen();
}

/*
 * Restore erased background areas on zoom screen
 */

void blit_Bkgd (void)
{
	if (animated)
	{
		if (bkgd_counter>bkgd_delay)
		{
			reset_fli_variables() ;
			next_fli_frame(1) ;
			bkgd_counter = 0 ;
		}
	}
	restore_background(Bkgd);
}


void loadsounds(void)
{
	CLEAR_SAMPLE(wp_alwa)
	wp_alwa = load_sample ("wav\\wp_alwa.wav") ;
	CLEAR_SAMPLE(wk_alwa)
	wk_alwa = load_sample ("wav\\wk_alwa.wav") ;
	CLEAR_SAMPLE(sp_alwa)
	sp_alwa = load_sample ("wav\\sp_alwa.wav") ;
	CLEAR_SAMPLE(sk_alwa)
	sk_alwa = load_sample ("wav\\sk_alwa.wav") ;

	CLEAR_SAMPLE(hit1)
	hit1 = load_sample ("wav\\hit1.wav") ;
	CLEAR_SAMPLE(hit2)
	hit2 = load_sample ("wav\\hit2.wav") ;

	CLEAR_SAMPLE(block_snd)
	block_snd = load_sample ("wav\\block.wav") ;

	CLEAR_SAMPLE(done)
	done = load_sample ("wav\\done.wav") ;
	CLEAR_SAMPLE(buzz)
	buzz = load_sample ("wav\\buzz.wav") ;
	CLEAR_SAMPLE(bing)
	bing = load_sample ("wav\\bing.wav") ;
}

void freesounds(void)
{
	CLEAR_SAMPLE ( rd1 )
	CLEAR_SAMPLE ( rd2 )
	CLEAR_SAMPLE ( rd3 )

	CLEAR_SAMPLE ( fight )

	CLEAR_SAMPLE ( wp_alwa )
	CLEAR_SAMPLE ( wk_alwa )
	CLEAR_SAMPLE ( sp_alwa )
	CLEAR_SAMPLE ( sk_alwa )

	CLEAR_SAMPLE ( ko_snd )
	CLEAR_SAMPLE ( argh_snd )
	CLEAR_SAMPLE ( female_snd )
	CLEAR_SAMPLE ( done )
	CLEAR_SAMPLE ( bing )
	CLEAR_SAMPLE ( buzz )
	CLEAR_SAMPLE ( to_snd )
	CLEAR_SAMPLE ( prfct_snd )
}

void Buzz (void)
{
	play_sample( buzz );
}

void Bing (void)
{
	play_sample( bing );
}

void Done (void)
{
	play_sample( done );
}

void Block (void)
{
	play_sample( block_snd );
}

void Paf (char gana)
{
	switch (gana)
	{
		case 1 : play_sample( wp_alwa ); break ;
		case 2 : play_sample( sp_alwa ); break ;
		case 3 : play_sample( wk_alwa ); break ;
		case 4 : play_sample( sk_alwa ); break ;
	}
}

void Hurt (char gana)
{
	switch (gana)
	{
		case 1 : play_sample( hit2 ); break ;
		case 2 : play_sample( hit1 ); break ;
		default: play_sample( hit1 ); break ;
	}
}


void Round (char which)
{
	switch ( which )
	{
		case 2 :
			openZip(skinzip[getOptionValue(OPTION_SKIN)]);
			CLEAR_BM(Carton_R2)
			Carton_R2 = load_pcx("sprites\\round2.pcx", 0);
			closeZip();
			CLEAR_SAMPLE(rd2)
			rd2 = load_sample ("wav\\rd2.wav") ;
			play_sample( rd2 );
			break ;
		case 3 :
			openZip(skinzip[getOptionValue(OPTION_SKIN)]);
			CLEAR_BM(Carton_R3)
			Carton_R3 = load_pcx("sprites\\round3.pcx", 0);
			closeZip();
			CLEAR_SAMPLE(rd3)
			rd3 = load_sample ("wav\\rd3.wav") ;
			play_sample( rd3 );
			break ;
		case 1 :
		default :
			openZip(skinzip[getOptionValue(OPTION_SKIN)]);
			CLEAR_BM(Carton_R1)
			Carton_R1 = load_pcx("sprites\\round1.pcx", 0);
			closeZip();
			CLEAR_SAMPLE(rd1)
			rd1 = load_sample ("wav\\rd1.wav");
			play_sample( rd1 );
			break ;
	}
}

void Fight (void)
{
	CLEAR_BM(Carton_R1)
	CLEAR_BM(Carton_R2)
	CLEAR_BM(Carton_R3)
	CLEAR_SAMPLE(rd1)
	CLEAR_SAMPLE(rd2)
	CLEAR_SAMPLE(rd3)
	openZip(skinzip[getOptionValue(OPTION_SKIN)]);
	CLEAR_BM(Carton_FT)
	Carton_FT = load_pcx("sprites\\fight.pcx", 0);
	closeZip();
	CLEAR_SAMPLE(fight)
	fight = load_sample ("wav\\fight.wav") ;
	play_sample( fight );
}

void GStatic ( int p, int gueu )
{
	if ( ((gueu+1) > Players[p].statik.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].statik.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].Static[gueu+1] ,Players[p].x , Players[p].y, Players[p].invers ) ;
}

void GSingle ( int p, int gueu )
{
	draw_rle_sprite( zoomscreen, Players[p].Single[gueu] ,Players[p].x ,Players[p].y, Players[p].invers ) ;
}

void GKO ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x-20 : Players[p].x - (Players[p].ko.w - Players[p].width) + 20;
	if (gueu>0&&gueu<5)
		draw_rle_sprite( zoomscreen, Players[p].KO[gueu] ,x ,Players[p].y, Players[p].invers ) ;
	else
		draw_rle_sprite( zoomscreen, Players[p].Single[1] ,x ,Players[p].y, Players[p].invers ) ;
}

void GDead ( int p, int gueu )
{
	int dead[8] = {1,1,2,3,4,3,4,5};
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x - (Players[p].ko.w - Players[p].width);
	draw_rle_sprite( zoomscreen, Players[p].KO[dead[gueu>7?7:gueu]] ,x ,Players[p].y, Players[p].invers ) ;
}

void GJump ( int p, int gueu )
{
	draw_rle_sprite( zoomscreen, Players[p].Jump[gueu] ,Players[p].x ,Players[p].y, Players[p].invers ) ;
}

void GHurt ( int p, int gueu )
{
	if ( ((gueu+1) > Players[p].hurt.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].hurt.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].Hurt[gueu+1] ,Players[p].x , Players[p].y, Players[p].invers ) ;
}

void GGHurt ( int p, int gueu )
{
	if ( ((gueu+1) > Players[p].ghurt.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].ghurt.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].GHurt[gueu+1] ,Players[p].x , Players[p].y, Players[p].invers ) ;
}

void GWalk ( int p, int gueu )
{
	if ( ((gueu+1) > Players[p].walk.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].walk.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].Walk[gueu+1] ,Players[p].x , Players[p].y, Players[p].invers ) ;
}

void GKick ( int p, int gueu )
{
	int x;
	if ( ((gueu+1) > Players[p].skick.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].skick.nbf - 1 ;
	x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].skick.w-Players[p].width);
	draw_rle_sprite( zoomscreen, Players[p].Kick[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GIntro ( int p, int gueu )
{
	int x;
	if ( ((gueu+1) > Players[p].intro.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].intro.nbf - 1 ;
	x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].intro.w-Players[p].width);
	draw_rle_sprite( zoomscreen, Players[p].Anim[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GOutwin ( int p, int gueu )
{
	int x;
	if ( ((gueu+1) > Players[p].outwin.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].outwin.nbf - 1 ;
	x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].outwin.w-Players[p].width);
	draw_rle_sprite( zoomscreen, Players[p].Anim[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GGKick ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].gkick.w-Players[p].width);
	if ( ((gueu+1) > Players[p].gkick.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].gkick.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].GKick[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GWKick ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].wkick.w-Players[p].width);
	if ( ((gueu+1) > Players[p].wkick.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].wkick.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].WKick[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GPunch ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].spunch.w-Players[p].width);
	if ( ((gueu+1) > Players[p].spunch.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].spunch.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].Punch[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GWPunch ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].wpunch.w-Players[p].width);
	if ( ((gueu+1) > Players[p].wpunch.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].wpunch.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].WPunch[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GAKick ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].akick.w-Players[p].width);
	if ( ((gueu+1) > Players[p].akick.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].akick.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].AKick[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GAPunch ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].apunch.w-Players[p].width);
	if ( ((gueu+1) > Players[p].apunch.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].apunch.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].APunch[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GGPunch ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].gpunch.w-Players[p].width);
	if ( ((gueu+1) > Players[p].gpunch.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].gpunch.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].GPunch[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GFireB ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].fireb.w-Players[p].width);
	if ( ((gueu+1) > Players[p].fireb.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].fireb.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].FireB[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GFBall ( int p, int gueu )
{
	if ( ((gueu+1) > Players[p].fball.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].fball.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].FBall[gueu+1] ,Players[p].fballs[0].x , Players[p].fballs[0].y, Players[p].invers ) ;
}

void GRush ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].rush.w-Players[p].width);
	if ( ((gueu+1) > Players[p].rush.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].rush.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].Rush[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GSMove ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].smove.w-Players[p].width);
	if ( ((gueu+1) > Players[p].smove.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].smove.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].SMove[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

/* SPECIALS */

void GFireBX ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].firebx.w-Players[p].width);
	if ( ((gueu+1) > Players[p].firebx.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].firebx.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].FireBX[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GFBallX ( int p, int gueu )
{
	if ( ((gueu+1) > Players[p].fballx.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].fballx.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].FBallX[gueu+1] ,Players[p].fballs[1].x , Players[p].fballs[1].y, Players[p].invers ) ;
}

void GRushX ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].rushx.w-Players[p].width);
	if ( ((gueu+1) > Players[p].rushx.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].rushx.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].RushX[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

void GSMoveX ( int p, int gueu )
{
	int x = Players[p].invers==0 ? Players[p].x : Players[p].x-(Players[p].smovex.w-Players[p].width);
	if ( ((gueu+1) > Players[p].smovex.nbf ) || ((gueu+1)< 1) )
		gueu = Players[p].smovex.nbf - 1 ;
	draw_rle_sprite( zoomscreen, Players[p].SMoveX[gueu+1] ,x , Players[p].y, Players[p].invers ) ;
}

/* END OF SPECIALS */

void load_sprites (int p)
{
	destroy_player(p);
	strcpy ( passeur, "sprites\\" );
	strcat ( passeur, charname[Players[p].sel] );
	strcat ( passeur, "\\" );

	Players[p].load_sel = Players[p].sel;

	load_serie(passeur,"static",Players[p].statik.nbf,Players[p].Static);
	load_serie(passeur,"walk",Players[p].walk.nbf,Players[p].Walk);
	load_serie(passeur,"spunch",Players[p].spunch.nbf,Players[p].Punch);
	load_serie(passeur,"wpunch",Players[p].wpunch.nbf,Players[p].WPunch);
	showLoading(5);
	load_serie(passeur,"gpunch",Players[p].gpunch.nbf,Players[p].GPunch);
	load_serie(passeur,"apunch",Players[p].apunch.nbf,Players[p].APunch);
	load_serie(passeur,"gkick",Players[p].gkick.nbf,Players[p].GKick);
	load_serie(passeur,"wkick",Players[p].wkick.nbf,Players[p].WKick);
	showLoading(5);
	load_serie(passeur,"akick",Players[p].akick.nbf,Players[p].AKick);
	load_serie(passeur,"hurt",Players[p].hurt.nbf,Players[p].Hurt);
	load_serie(passeur,"ghurt",Players[p].ghurt.nbf,Players[p].GHurt);
	load_serie(passeur,"jump",5,Players[p].Jump);
	showLoading(5);

	load_serie(passeur,"ko",5,Players[p].KO);
	load_serie(passeur,"skick",Players[p].skick.nbf,Players[p].Kick);

	showLoading(5);

	strcpy ( file, passeur );
	strcat ( file, "block1.pcx" );
	CLEAR_RLE(Players[p].Single[0])
	Players[p].Single[0] = load_rle_sprite(file);

	strcpy ( file, passeur );
	strcat ( file, "crouch1.pcx" );
	CLEAR_RLE(Players[p].Single[1])
	Players[p].Single[1] = load_rle_sprite(file);

	strcpy ( file, passeur );
	strcat ( file, "gblock1.pcx" );
	CLEAR_RLE(Players[p].Single[2])
	Players[p].Single[2] = load_rle_sprite(file);

	strcpy ( file, passeur );
	strcat ( file, "hurt1.pcx" );
	CLEAR_RLE(Players[p].Single[3])
	Players[p].Single[3] = load_rle_sprite(file);

	showLoading(5);

	if ( Players[p].fireb.flg )
	{
		load_serie(passeur,"fireb",Players[p].fireb.nbf,Players[p].FireB);
		load_serie(passeur,"fball",Players[p].fball.nbf,Players[p].FBall);
		strcpy ( file, passeur );
		strcat ( file, "fireb.wav" );
		CLEAR_SAMPLE(Players[p].hadoken)
		Players[p].hadoken = load_sample (file) ;
	}

	if ( Players[p].rush.flg )
	{
		load_serie(passeur,"rush",Players[p].rush.nbf,Players[p].Rush);
		strcpy ( file, passeur );
		strcat ( file, "rush.wav" );
		CLEAR_SAMPLE(Players[p].copter)
		Players[p].copter = load_sample (file) ;
	}

	if ( Players[p].smove.flg )
	{
		load_serie(passeur,"smove",Players[p].smove.nbf,Players[p].SMove);
		strcpy ( file, passeur );
		strcat ( file, "smove.wav" );
		CLEAR_SAMPLE(Players[p].dragon)
		Players[p].dragon = load_sample (file) ;
	}

	showLoading(5);

	/* SPECIALS */

	if ( Players[p].firebx.flg )
	{
		load_serie(passeur,"firebx",Players[p].firebx.nbf,Players[p].FireBX);
		load_serie(passeur,"fballx",Players[p].fballx.nbf,Players[p].FBallX);
		strcpy ( file, passeur );
		strcat ( file, "firebx.wav" );
		CLEAR_SAMPLE(Players[p].hadokenx)
		Players[p].hadokenx = load_sample (file) ;
	}

	if ( Players[p].rushx.flg )
	{
		load_serie(passeur,"rushx",Players[p].rushx.nbf,Players[p].RushX);
		strcpy ( file, passeur );
		strcat ( file, "rushx.wav" );
		CLEAR_SAMPLE(Players[p].copterx)
		Players[p].copterx = load_sample (file) ;
	}

	if ( Players[p].smovex.flg )
	{
		load_serie(passeur,"smovex",Players[p].smovex.nbf,Players[p].SMoveX);
		strcpy ( file, passeur );
		strcat ( file, "smovex.wav" );
		CLEAR_SAMPLE(Players[p].dragonx)
		Players[p].dragonx = load_sample (file) ;
	}

	showLoading(5);
}

void unload_anim (int p,int nbf)
{
	for ( num=1 ; num<nbf+1 ; ++num )
		CLEAR_RLE(Players[p].Anim[num])
}

void load_intro (int p)
{
	strcpy ( passeur, "sprites"DIR_BAR );
	strcat ( passeur, charname[Players[p].sel] );
	strcat ( passeur,DIR_BAR);
	openZip(charzip[Players[p].sel]);
	load_serie(passeur,"intro",Players[p].intro.nbf,Players[p].Anim);
	closeZip();
}

void load_win (int p)
{
	strcpy ( passeur, "sprites"DIR_BAR );
	strcat ( passeur, charname[Players[p].sel] );
	strcat ( passeur,DIR_BAR);
	openZip(charzip[Players[p].sel]);
	load_serie(passeur,"outwin",Players[p].outwin.nbf,Players[p].Anim);
	closeZip();
}

void destroy_bitmaps (void)
{
	if (animated)
	{
		close_fli() ;
		Bkgd = NULL;
	}
	else
		CLEAR_BM(Bkgd)
	CLEAR_BM(Carton_WN)
	CLEAR_BM(zoomscreen)
	clear_foreground();
}

void destroy_player (int p)
{
	for ( num=1 ; num<6 ; ++num )
		CLEAR_RLE (Players[p].Jump[num])

	for ( num=1 ; num<6 ; ++num )
		CLEAR_RLE (Players[p].KO[num])

	for ( num=1 ; num<(Players[p].statik.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].Static[num])

	for ( num=1 ; num<(Players[p].walk.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].Walk[num])

	for ( num=1 ; num<(Players[p].spunch.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].Punch[num])

	for ( num=1 ; num<(Players[p].wpunch.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].WPunch[num])

	for ( num=1 ; num<(Players[p].gpunch.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].GPunch[num])

	for ( num=1 ; num<(Players[p].apunch.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].APunch[num])

	for ( num=1 ; num<(Players[p].skick.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].Kick[num])

	for ( num=1 ; num<(Players[p].wkick.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].WKick[num])

	for ( num=1 ; num<(Players[p].gkick.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].GKick[num])

	for ( num=1 ; num<(Players[p].akick.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].AKick[num])

	for ( num=1 ; num<(Players[p].hurt.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].Hurt[num])

	for ( num=1 ; num<(Players[p].ghurt.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].GHurt[num])

	for ( num=1 ; num<(Players[p].fireb.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].FireB[num])

	for ( num=1 ; num<(Players[p].fball.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].FBall[num])

	for ( num=1 ; num<(Players[p].rush.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].Rush[num])

	for ( num=1 ; num<(Players[p].smove.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].SMove[num])

	for ( num=1 ; num<(Players[p].firebx.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].FireBX[num])

	for ( num=1 ; num<(Players[p].fballx.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].FBallX[num])

	for ( num=1 ; num<(Players[p].rushx.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].RushX[num])

	for ( num=1 ; num<(Players[p].smovex.nbf+1) ; ++num )
		CLEAR_RLE (Players[p].SMoveX[num])

	CLEAR_RLE(Players[p].Single[0])
	CLEAR_RLE(Players[p].Single[1])
	CLEAR_RLE(Players[p].Single[2])
	CLEAR_RLE(Players[p].Single[3])

	CLEAR_SAMPLE(Players[p].hadoken)
	CLEAR_SAMPLE(Players[p].copter)
	CLEAR_SAMPLE(Players[p].dragon)

	CLEAR_SAMPLE(Players[p].hadokenx)
	CLEAR_SAMPLE(Players[p].copterx)
	CLEAR_SAMPLE(Players[p].dragonx)
}

char get_kstatus ( char strg[] )
{
	char rtn_value = 10;
	char c ;
	c = strg[0] ;
	switch ( c )
	{
		case 'U' :
			if ( (c = strg[1])!=0 )
			{
				if (c == 'L')
					rtn_value = 7 ;
				else if (c == 'R')
					rtn_value = 8 ;
			}
			else
				rtn_value = 1 ;
			break ;
		case 'D' :
			if ( (c = strg[1])!=0 )
			{
				if (c == 'L')
					rtn_value = 5 ;
				else if (c == 'R')
					rtn_value = 6 ;
			}
			else
				rtn_value = 2 ;
			break ;
		case 'L' :
			rtn_value = 3 ;
			break ;
		case 'R' :
			rtn_value = 4 ;
			break ;
		case 'P' :
			rtn_value = 9 ;
			break ;
		case 'K' :
			rtn_value = 10 ;
			break ;
		case 'N' :
			rtn_value = 0 ;
			break ;
		default	:
			rtn_value = 10 ;
			break ;
	}
	return rtn_value ;
}

char check_kstatus ( int p, char ctrl_key )
{
	char rtnv = 0;
	int joy_lt = Players[p].invers?JOY_RT(p):JOY_LT(p);
	int joy_rt = Players[p].invers?JOY_LT(p):JOY_RT(p);

	poll_joystick() ;

	switch(ctrl_key)
	{
		case 0 :
			if ( !JOY_UP(p) && !JOY_DN(p) && !joy_lt && !joy_rt && !JOY_WP(p) && !JOY_SP(p) && !JOY_WK(p) && !JOY_SK(p) )
				rtnv = 1 ;
			else
				rtnv = 0 ;
			break ;
		case 1 :
			if ( JOY_UP(p) && !JOY_DN(p) && !joy_lt && !joy_rt && !JOY_WP(p) && !JOY_SP(p) && !JOY_WK(p) && !JOY_SK(p))
				rtnv = 1 ;
			else
				rtnv = 0 ;
			break ;
		case 2 :
			if ( JOY_DN(p) && !JOY_UP(p) && !joy_lt && !joy_rt && !JOY_WP(p) && !JOY_SP(p) && !JOY_WK(p) && !JOY_SK(p))
				rtnv = 1 ;
			else
				rtnv = 0 ;
			break ;
		case 3 :
			if ( joy_lt && !JOY_UP(p) && !JOY_DN(p) && !joy_rt && !JOY_WP(p) && !JOY_SP(p) && !JOY_WK(p) && !JOY_SK(p))
				rtnv = 1 ;
			else
				rtnv = 0 ;
			break ;

		case 4 :
			if ( joy_rt && !JOY_UP(p) && !JOY_DN(p) && !joy_lt && !JOY_WP(p) && !JOY_SP(p) && !JOY_WK(p) && !JOY_SK(p))
				rtnv = 1 ;
			else
				rtnv = 0 ;
			break ;
		case 5 :
			if ( JOY_DN(p) && !JOY_UP(p) && !joy_rt && joy_lt && !JOY_WP(p) && !JOY_SP(p) && !JOY_WK(p) && !JOY_SK(p))
				rtnv = 1 ;
			else
				rtnv = 0 ;
			break ;
		case 6 :
			if ( JOY_DN(p) && !JOY_UP(p) && joy_rt && !joy_lt && !JOY_WP(p) && !JOY_SP(p) && !JOY_WK(p) && !JOY_SK(p))
				rtnv = 1 ;
			else
				rtnv = 0 ;
			break ;
		case 7 :
			if ( !JOY_DN(p) && JOY_UP(p) && !joy_rt && joy_lt && !JOY_WP(p) && !JOY_SP(p) && !JOY_WK(p) && !JOY_SK(p))
				rtnv = 1 ;
			else
				rtnv = 0 ;
			break ;
		case 8 :
			if ( !JOY_DN(p) && JOY_UP(p) && joy_rt && !joy_lt && !JOY_WP(p) && !JOY_SP(p) && !JOY_WK(p) && !JOY_SK(p))
				rtnv = 1 ;
			else
				rtnv = 0 ;
			break ;
		case 9 :
			if ( (JOY_WP(p) || JOY_SP(p)) && (!JOY_WK(p) && !JOY_SK(p)) )
				rtnv = 1 ;
			else
				rtnv = 0 ;
			break ;
		case 10:
			if ( (!JOY_WP(p) && !JOY_SP(p)) && (JOY_WK(p) || JOY_SK(p)) )
				rtnv = 1 ;
			else
				rtnv = 0 ;
			break ;
		default:
			gp32_error("problem in check_kstatus1");
	}
	if (rtnv)
		Players[p].last_status = ctrl_key ;
	return rtnv ;
}

int scan_files(char *name, int attrib, char what )
{
	char dta_name[512], buf[512];
	void *dta;
	int dta_attrib;
	int c = 0;

	if (ustrchr(name, '#'))
		return 0;

	if (!_al_file_isok(name))
		return 0;

	dta = _al_findfirst(name, attrib, dta_name, &dta_attrib);

	if (!dta)
		return 0;

	do
	{
		replace_filename(buf, name, dta_name, sizeof(buf));
		/* get the filename buffer here !!!! */
		if (what==0)
		{
			if (!ustrchr(buf, '.'))
			{
				ustrncpy( charname[c], buf+8, 30 );
				charzip[c][0] = 0;
				c++ ;
			}
		}
		else if (what==3)
		{
			strcpy(charzip[nbchar+c],buf);
			buf[strlen(buf)-4] = 0;
			ustrncpy( charname[nbchar+c], buf+8, 30 );
			c++ ;
		}
		else if (what==1)
		{
			ustrncpy( bkgdname[c], buf+6, 30 );
			c++ ;
		}
		else if (what==2)
		{
			ustrncpy( flcname[c], buf+6, 30 );
			c++ ;
		}
		else if (what==4)
		{
			strcpy(skinzip[nbskin+c],buf);
			buf[strlen(buf)-4] = 0;
			ustrncpy( skinname[nbskin+c], buf+6, 30 );
			c++ ;
		}
	} while (_al_findnext(dta, dta_name, &dta_attrib) == 0);

	_al_findclose(dta);

	return c;
}

void load_background(int num)
{
	int h,w,y;
	strcpy ( passeur, "bkgds\\" );
	strcat ( passeur, bkgdname[num] );

	CLEAR_BM(Carton_R2)
	if ( (Carton_R2 = load_pcx (passeur ,Pal )) == NULL )
	{
		if ( (open_fli ( passeur ) == FLI_OK) )
		{
			reset_fli_variables() ;
			next_fli_frame(1) ;
			CLEAR_BM(Carton_R2)
			Carton_R2 = clone_bitmap(fli_bitmap);
			close_fli();
		}
		else
		{
			gp32_error("can not load flc background");
		}
	}
	if (Carton_R2->h>=240)
	{
		y = Carton_R2->h-240;
		w = 320;
		h = 240;
	}
	else
	{
		y = 0;
		h = Carton_R2->h;
		w = (320*h)/240;
	}
	stretch_blit ( Carton_R2 , Carton_R1 , (Carton_R2->w-w)>>1, y, w, h, 0, 0,Carton_R1->w, Carton_R1->h) ;
}

void showZoom(int cx)
{
	int cy = (240+zoomsup) - ZMRATIO ;
	if (cy<1)
		cy = 0;
	if (ZW<320 || cy<zoomsup)
	{
		if (foreground)
			show_foreground(cx,cy,zoomwidth,ZMRATIO);
		stretch_blit ( zoomscreen , virtscreen , cx , cy, zoomwidth, ZMRATIO , 0, 0, 320, 240 ) ;
	}
	else
	{
		if (foreground)
			show_foreground(cx,zoomsup,320,240);
		blit ( zoomscreen , virtscreen , cx , zoomsup, 0, 0, 320, 240 ) ;
	}
}

RLE_SPRITE* load_rle_sprite(char* path)
{
	RLE_SPRITE* rle = NULL;
	BITMAP *B_Tmp;
	B_Tmp = load_pcx ( path , 0 ) ;
	rle = get_rle_sprite(B_Tmp) ;
	CLEAR_BM(B_Tmp)
	return rle;
}

void load_serie(char* path, char* prefix, int nbf, RLE_SPRITE** serie)
{
	for ( num=1 ; num<(nbf+1) ; ++num )
	{
		gcvt ( num , (num < 10 ? 1 : 2) , tilenum ) ;
		strcpy ( file, path );
		strcat ( file, prefix );
		strcat ( file, tilenum );
		strcat ( file, ".pcx" );
		CLEAR_RLE(serie[num])
		serie[num] = load_rle_sprite( file) ;
	}
}

void decodeSeq(struct SMOVE *move)
{
	int cx = 1, nb = 0,i = 0,y = 0;
	char temp_strg[2] = {0,0};
	char c;

	while ( cx )
	{
		c = move->exec[i] ;
		if ( c != ' ' )
		{
			if ( c == '*' )
			{
				move->end = nb ;
				cx = 0 ;
			}
			temp_strg[y] = c  ;
			y++;
		}
		else
		{
			move->seq[nb] = get_kstatus ( temp_strg ) ;
			nb++ ;
			y = 0 ;
		}
		i++ ;
	}
}

/*
 * Load character data in char.ini
 */
void load_char(char* path,int p)
{
	override_config_file( path );

	Players[p].width = get_config_int ( sectn , "static_w" , 100 ) ;
	Players[p].spunch.w = get_config_int ( sectn , "spunch_w" , 150 ) ;
	Players[p].wpunch.w = get_config_int ( sectn , "wpunch_w" , 150 ) ;
	Players[p].skick.w = get_config_int ( sectn , "skick_w" , 150 ) ;
	Players[p].wkick.w = get_config_int ( sectn , "wkick_w" , 150 ) ;
	Players[p].apunch.w = get_config_int ( sectn , "apunch_w" , 150 ) ;
	Players[p].gpunch.w = get_config_int ( sectn , "gpunch_w" , 150 ) ;
	Players[p].akick.w = get_config_int ( sectn , "akick_w" , 150 ) ;
	Players[p].gkick.w = get_config_int ( sectn , "gkick_w" , 150 ) ;
	Players[p].intro.w = get_config_int ( sectn , "intro_w" , 150 ) ;
	Players[p].ko.w = get_config_int ( sectn , "ko_w" , 150 ) ;
	Players[p].outwin.w = get_config_int ( sectn , "outwin_w" , 150 ) ;

	Players[p].height = get_config_int ( sectn , "height" , 130 ) ;

	Players[p].statik.nbf = get_config_int ( sectn , "static_nbf" , 4 ) ;
	Players[p].walk.nbf = get_config_int ( sectn , "walk_nbf" , 5 ) ;
	Players[p].spunch.nbf = get_config_int ( sectn , "spunch_nbf" , 3 ) ;
	Players[p].wpunch.nbf = get_config_int ( sectn , "wpunch_nbf" , 3 ) ;
	Players[p].skick.nbf = get_config_int ( sectn , "skick_nbf" , 4 ) ;
	Players[p].wkick.nbf = get_config_int ( sectn , "wkick_nbf" , 4 ) ;
	Players[p].apunch.nbf = get_config_int ( sectn , "apunch_nbf" , 1 ) ;
	Players[p].gpunch.nbf = get_config_int ( sectn , "gpunch_nbf" , 4 ) ;
	Players[p].akick.nbf = get_config_int ( sectn , "akick_nbf" , 1 ) ;
	Players[p].gkick.nbf = get_config_int ( sectn , "gkick_nbf" , 4 ) ;

	Players[p].hurt.nbf = get_config_int ( sectn , "hurt_nbf" , 1 ) ;
	Players[p].ghurt.nbf = get_config_int ( sectn , "ghurt_nbf" , 1 ) ;

	Players[p].intro.nbf = get_config_int ( sectn , "intro_nbf" , 1 ) ;
	Players[p].outwin.nbf = get_config_int ( sectn , "outwin_nbf" , 1 ) ;

	Players[p].statik.spd = get_config_int ( sectn , "static_spd" , 8 ) ;
	Players[p].walk.spd = get_config_int ( sectn , "walk_spd" , 8 ) ;
	Players[p].spunch.spd = get_config_int ( sectn , "spunch_spd" , 8 ) ;
	Players[p].wpunch.spd = get_config_int ( sectn , "wpunch_spd" , 8 ) ;
	Players[p].skick.spd = get_config_int ( sectn , "skick_spd" , 8 ) ;
	Players[p].wkick.spd = get_config_int ( sectn , "wkick_spd" , 8 ) ;
	Players[p].apunch.spd = get_config_int ( sectn , "apunch_spd" , 8 ) ;
	Players[p].gpunch.spd = get_config_int ( sectn , "gpunch_spd" , 8 ) ;
	Players[p].akick.spd = get_config_int ( sectn , "akick_spd" , 8 ) ;
	Players[p].gkick.spd = get_config_int ( sectn , "gkick_spd" , 8 ) ;
	Players[p].outwin.spd = get_config_int ( sectn , "outwin_spd" , 10 ) ;

	Players[p].spunch.hit = get_config_int ( sectn , "spunch_hit" , 2 ) ;
	Players[p].wpunch.hit = get_config_int ( sectn , "wpunch_hit" , 2 ) ;
	Players[p].skick.hit = get_config_int ( sectn , "skick_hit" , 2 ) ;
	Players[p].wkick.hit = get_config_int ( sectn , "wkick_hit" , 2 ) ;
	Players[p].apunch.hit = get_config_int ( sectn , "apunch_hit" , 2 ) ;
	Players[p].gpunch.hit = get_config_int ( sectn , "gpunch_hit" , 2 ) ;
	Players[p].akick.hit = get_config_int ( sectn , "akick_hit" , 2 ) ;
	Players[p].gkick.hit = get_config_int ( sectn , "gkick_hit" , 2 ) ;

	Players[p].spunch.dmg = get_config_int ( sectn , "spunch_dmg" , 2 ) ;
	Players[p].wpunch.dmg = get_config_int ( sectn , "wpunch_dmg" , 1 ) ;
	Players[p].skick.dmg = get_config_int ( sectn , "skick_dmg" , 2 ) ;
	Players[p].wkick.dmg = get_config_int ( sectn , "wkick_dmg" , 1 ) ;
	Players[p].apunch.dmg = get_config_int ( sectn , "apunch_dmg" , 1 ) ;
	Players[p].gpunch.dmg = get_config_int ( sectn , "gpunch_dmg" , 1 ) ;
	Players[p].akick.dmg = get_config_int ( sectn , "akick_dmg" , 2 ) ;
	Players[p].gkick.dmg = get_config_int ( sectn , "gkick_dmg" , 2 ) ;

	Players[p].spunch.offx = get_config_int ( sectn , "spunch_offx" , Players[p].spunch.w ) ;
	Players[p].wpunch.offx = get_config_int ( sectn , "wpunch_offx" , Players[p].wpunch.w ) ;
	Players[p].skick.offx = get_config_int ( sectn , "skick_offx" , Players[p].skick.w ) ;
	Players[p].wkick.offx = get_config_int ( sectn , "wkick_offx" , Players[p].wkick.w ) ;
	Players[p].apunch.offx = get_config_int ( sectn , "apunch_offx" , Players[p].apunch.w ) ;
	Players[p].gpunch.offx = get_config_int ( sectn , "gpunch_offx" , Players[p].gpunch.w ) ;
	Players[p].akick.offx = get_config_int ( sectn , "akick_offx" , Players[p].akick.w ) ;
	Players[p].gkick.offx = get_config_int ( sectn , "gkick_offx" , Players[p].gkick.w ) ;

	Players[p].spunch.offy = get_config_int ( sectn , "spunch_offy" , Players[p].height-50 ) ;
	Players[p].wpunch.offy = get_config_int ( sectn , "wpunch_offy" , Players[p].height-50 ) ;
	Players[p].skick.offy = get_config_int ( sectn , "skick_offy" , Players[p].height-50 ) ;
	Players[p].wkick.offy = get_config_int ( sectn , "wkick_offy" , Players[p].height-50 ) ;
	Players[p].apunch.offy = get_config_int ( sectn , "apunch_offy" , Players[p].height-50 ) ;
	Players[p].gpunch.offy = get_config_int ( sectn , "gpunch_offy" , Players[p].height-50 ) ;
	Players[p].akick.offy = get_config_int ( sectn , "akick_offy" , Players[p].height-50 ) ;
	Players[p].gkick.offy = get_config_int ( sectn , "gkick_offy" , Players[p].height-50 ) ;

	Players[p].statik.defx = get_config_int ( sectn , "static_defx" , Players[p].width ) ;
	Players[p].walk.defx = get_config_int ( sectn , "walk_defx" , Players[p].width ) ;
	Players[p].jump.defx = get_config_int ( sectn , "jump_defx" , Players[p].width ) ;
	Players[p].crouch.defx = get_config_int ( sectn , "crouch_defx" , Players[p].width ) ;
	Players[p].spunch.defx = get_config_int ( sectn , "spunch_defx" , Players[p].width ) ;
	Players[p].wpunch.defx = get_config_int ( sectn , "wpunch_defx" , Players[p].width ) ;
	Players[p].skick.defx = get_config_int ( sectn , "skick_defx" , Players[p].width ) ;
	Players[p].wkick.defx = get_config_int ( sectn , "wkick_defx" , Players[p].width ) ;
	Players[p].apunch.defx = get_config_int ( sectn , "apunch_defx" , Players[p].width ) ;
	Players[p].gpunch.defx = get_config_int ( sectn , "gpunch_defx" , Players[p].width ) ;
	Players[p].akick.defx = get_config_int ( sectn , "akick_defx" , Players[p].width ) ;
	Players[p].gkick.defx = get_config_int ( sectn , "gkick_defx" , Players[p].width ) ;

	Players[p].statik.defy = get_config_int ( sectn , "static_defy" , Players[p].height-50 ) ;
	Players[p].walk.defy = get_config_int ( sectn , "walk_defy" , Players[p].height-50 ) ;
	Players[p].jump.defy = get_config_int ( sectn , "jump_defy" , Players[p].height-50 ) ;
	Players[p].crouch.defy = get_config_int ( sectn , "crouch_defy" , Players[p].height-50 ) ;
	Players[p].spunch.defy = get_config_int ( sectn , "spunch_defy" , Players[p].height-50 ) ;
	Players[p].wpunch.defy = get_config_int ( sectn , "wpunch_defy" , Players[p].height-50 ) ;
	Players[p].skick.defy = get_config_int ( sectn , "skick_defy" , Players[p].height-50 ) ;
	Players[p].wkick.defy = get_config_int ( sectn , "wkick_defy" , Players[p].height-50 ) ;
	Players[p].apunch.defy = get_config_int ( sectn , "apunch_defy" , Players[p].height-50 ) ;
	Players[p].gpunch.defy = get_config_int ( sectn , "gpunch_defy" , Players[p].height-50 ) ;
	Players[p].akick.defy = get_config_int ( sectn , "akick_defy" , Players[p].height-50 ) ;
	Players[p].gkick.defy = get_config_int ( sectn , "gkick_defy" , Players[p].height-50 ) ;

	Players[p].female = get_config_int ( sectn , "female" , 0 ) ;

	Players[p].fireb.flg = get_config_int ( sectn , "fireb" , 0 ) ;

	if ( Players[p].fireb.flg )
	{
		Players[p].fballs[0].w = get_config_int ( sectn , "fball_w" , 1 ) ;
		Players[p].fball.nbf = get_config_int ( sectn , "fball_nbf" , 1 ) ;
		Players[p].fball.spd = get_config_int ( sectn , "fball_spd" , 1 ) ;
		Players[p].fball.pix = get_config_int ( sectn , "fball_pix" , 1 ) ;
		Players[p].fballs[0].offx = get_config_int ( sectn , "fball_offx" , Players[p].fballs[0].w ) ;
		Players[p].fballs[0].offy = get_config_int ( sectn , "fball_offy" , 10 ) ;

		Players[p].fballs[0].h = get_config_int ( sectn , "fball_h" , 1 ) ;
		Players[p].fballs[0].cx = get_config_int ( sectn , "fball_cx" , 1 ) ;
		Players[p].fballs[0].cy = get_config_int ( sectn , "fball_cy" , 1 ) ;

		Players[p].fireb.w = get_config_int ( sectn , "fireb_w" , 1 ) ;
		Players[p].fireb.nbf = get_config_int ( sectn , "fireb_nbf" , 1 ) ;
		Players[p].fireb.spd = get_config_int ( sectn , "fireb_spd" , 1 ) ;
		Players[p].fireb.hit = get_config_int ( sectn , "fireb_hit" , 1 ) ;
		Players[p].fireb.exec = get_config_string ( sectn , "fireb_exec" , "" ) ;
		Players[p].fireb.dmg = get_config_int ( sectn , "fireb_dmg" , 3 ) ;

		decodeSeq(&Players[p].fireb);
	}

	Players[p].rush.flg = get_config_int ( sectn , "rush" , 0 ) ;

	if ( Players[p].rush.flg )
	{
		Players[p].rush.w = get_config_int ( sectn , "rush_w" , 1 ) ;
		Players[p].rush.nbf = get_config_int ( sectn , "rush_nbf" , 1 ) ;
		Players[p].rush.spd = get_config_int ( sectn , "rush_spd" , 1 ) ;
		Players[p].rush.hit = get_config_int ( sectn , "rush_hit" , 1 ) ;
		Players[p].rush.rot = get_config_int ( sectn , "rush_rot" , 1 ) ;
		Players[p].rush.pix = get_config_int ( sectn , "rush_pix" , 1 ) ;
		Players[p].rush.exec = get_config_string ( sectn , "rush_exec" , "" ) ;
		Players[p].rush.dmg = get_config_int ( sectn , "rush_dmg" , 3 ) ;
		Players[p].rush.offx = get_config_int ( sectn , "rush_offx" , Players[p].rush.w ) ;
		Players[p].rush.offy = get_config_int ( sectn , "rush_offy" , 10 ) ;

		decodeSeq(&Players[p].rush);
	}

	Players[p].smove.flg = get_config_int ( sectn , "smove" , 0 ) ;

	if ( Players[p].smove.flg )
	{
		Players[p].smove.w = get_config_int ( sectn , "smove_w" , 1 ) ;
		Players[p].smove.nbf = get_config_int ( sectn , "smove_nbf" , 1 ) ;
		Players[p].smove.spd = get_config_int ( sectn , "smove_spd" , 1 ) ;
		Players[p].smove.hit = get_config_int ( sectn , "smove_hit" , 1 ) ;
		Players[p].smove.rot = get_config_int ( sectn , "smove_rot" , 1 ) ;
		Players[p].smove.exec = get_config_string ( sectn , "smove_exec" , "" ) ;
		Players[p].smove.dmg = get_config_int ( sectn , "smove_dmg" , 3 ) ;
		Players[p].smove.offx = get_config_int ( sectn , "smove_offx" , Players[p].smove.w ) ;
		Players[p].smove.offy = get_config_int ( sectn , "smove_offy" , 10 ) ;

		decodeSeq(&Players[p].smove);
	}

	Players[p].firebx.flg = get_config_int ( sectn , "firebx" , 0 ) ;

	if ( Players[p].firebx.flg )
	{
		Players[p].fballs[1].w = get_config_int ( sectn , "fballx_w" , 1 ) ;
		Players[p].fballx.nbf = get_config_int ( sectn , "fballx_nbf" , 1 ) ;
		Players[p].fballx.spd = get_config_int ( sectn , "fballx_spd" , 1 ) ;
		Players[p].fballx.pix = get_config_int ( sectn , "fballx_pix" , 1 ) ;
		Players[p].fballs[1].offx = get_config_int ( sectn , "fballx_offx" , Players[p].fballs[1].w ) ;
		Players[p].fballs[1].offy = get_config_int ( sectn , "fballx_offy" , 10 ) ;

		Players[p].fballs[1].h = get_config_int ( sectn , "fballx_h" , 1 ) ;
		Players[p].fballs[1].cx = get_config_int ( sectn , "fballx_cx" , 1 ) ;
		Players[p].fballs[1].cy = get_config_int ( sectn , "fballx_cy" , 1 ) ;

		Players[p].firebx.w = get_config_int ( sectn , "firebx_w" , 1 ) ;
		Players[p].firebx.nbf = get_config_int ( sectn , "firebx_nbf" , 1 ) ;
		Players[p].firebx.spd = get_config_int ( sectn , "firebx_spd" , 1 ) ;
		Players[p].firebx.hit = get_config_int ( sectn , "firebx_hit" , 1 ) ;
		Players[p].firebx.exec = get_config_string ( sectn , "firebx_exec" , "" ) ;
		Players[p].firebx.spec = get_config_int ( sectn , "firebx_spec" , 0 ) ;
		Players[p].firebx.dmg = get_config_int ( sectn , "firebx_dmg", Players[p].firebx.spec ? 5 : 3 ) ;

		if (!Players[p].firebx.spec )
			Players[p].firebx.sflg = 1 ;
		else
			Players[p].firebx.sflg = 0 ;

		decodeSeq(&Players[p].firebx);
	}

	Players[p].rushx.flg = get_config_int ( sectn , "rushx" , 0 ) ;

	if ( Players[p].rushx.flg )
	{
		Players[p].rushx.w = get_config_int ( sectn , "rushx_w" , 1 ) ;
		Players[p].rushx.nbf = get_config_int ( sectn , "rushx_nbf" , 1 ) ;
		Players[p].rushx.spd = get_config_int ( sectn , "rushx_spd" , 1 ) ;
		Players[p].rushx.hit = get_config_int ( sectn , "rushx_hit" , 1 ) ;
		Players[p].rushx.rot = get_config_int ( sectn , "rushx_rot" , 1 ) ;
		Players[p].rushx.pix = get_config_int ( sectn , "rushx_pix" , 1 ) ;
		Players[p].rushx.exec = get_config_string ( sectn , "rushx_exec" , "" ) ;
		Players[p].rushx.spec = get_config_int ( sectn , "rushx_spec" , 0 ) ;
		Players[p].rushx.dmg = get_config_int ( sectn , "rushx_dmg" ,Players[p].rushx.spec ? 5 : 3 ) ;
		Players[p].rushx.offx = get_config_int ( sectn , "rushx_offx" , Players[p].rushx.w ) ;
		Players[p].rushx.offy = get_config_int ( sectn , "rushx_offy" , 10 ) ;

		if (!Players[p].rushx.spec )
			Players[p].rushx.sflg = 1 ;
		else
			Players[p].rushx.sflg = 0 ;

		decodeSeq(&Players[p].rushx);
	}

	Players[p].smovex.flg = get_config_int ( sectn , "smovex" , 0 ) ;

	if ( Players[p].smovex.flg )
	{
		Players[p].smovex.w = get_config_int ( sectn , "smovex_w" , 1 ) ;
		Players[p].smovex.nbf = get_config_int ( sectn , "smovex_nbf" , 1 ) ;
		Players[p].smovex.spd = get_config_int ( sectn , "smovex_spd" , 1 ) ;
		Players[p].smovex.hit = get_config_int ( sectn , "smovex_hit" , 1 ) ;
		Players[p].smovex.rot = get_config_int ( sectn , "smovex_rot" , 1 ) ;
		Players[p].smovex.exec = get_config_string ( sectn , "smovex_exec" , "" ) ;
		Players[p].smovex.spec = get_config_int ( sectn , "smovex_spec" , 0 ) ;
		Players[p].smovex.dmg = get_config_int ( sectn , "smovex_dmg" , Players[p].smovex.spec ? 5 : 3 ) ;
		Players[p].smovex.offx = get_config_int ( sectn , "smovex_offx" , Players[p].smovex.w ) ;
		Players[p].smovex.offy = get_config_int ( sectn , "smovex_offy" , 10 ) ;

		if (!Players[p].smovex.spec )
			Players[p].smovex.sflg = 1 ;
		else
			Players[p].smovex.sflg = 0 ;

		decodeSeq(&Players[p].smovex);
	}
}

/*
 * Draw current sprite animation sprite for player p
 */

void drawPlayer(int p)
{
	if (Players[p].ak)
	{
		GAKick (p, (Players[p].ak/Players[p].akick.spd) ) ;
		Players[p].limdefx = Players[p].akick.defx ;
		Players[p].limdefy = Players[p].akick.defy ;
	}

	else
	{
		if (Players[p].apch)
		{
			GAPunch (p, (Players[p].apch/Players[p].apunch.spd) ) ;
			Players[p].limdefx = Players[p].apunch.defx ;
			Players[p].limdefy = Players[p].apunch.defy ;
		}
		else
		{
			switch ( Players[p].actual )
			{
				case  MV_STATIC:
					GStatic(p, (Players[p].flag/Players[p].statik.spd) ) ;
					Players[p].limdefx = Players[p].statik.defx ;
					Players[p].limdefy = Players[p].statik.defy ;
					break;
				case MV_WALK_F:
				case MV_WALK_B:
					GWalk(p, (Players[p].flag/Players[p].walk.spd) ) ;
					Players[p].limdefx = Players[p].walk.defx ;
					Players[p].limdefy = Players[p].walk.defy ;
					break;
				case MV_CROUCH:
					GSingle(p, 1 );
					Players[p].limdefx = Players[p].crouch.defx ;
					Players[p].limdefy = Players[p].crouch.defy ;
					break;
				case MV_JUMP_U:
				case MV_JUMP_B:
				case MV_JUMP_F:
					if (Players[p].y < (Players[p].sol-50) )
						GJump(p, 3 );
					else
					{
						if (Players[p].sens)
						{
							if (Players[p].y < (Players[p].sol-20) )
								GJump(p, 4 );
							else
								GJump(p, 5 );
						}
						else
						{
							if (Players[p].y < (Players[p].sol-20) )
								GJump(p, 2 );
							else
								GJump(p, 1 );
						}
					}
					Players[p].limdefx = Players[p].jump.defx ;
					Players[p].limdefy = Players[p].jump.defy ;
					break;
				case MV_FIREB:
					GFireB(p, (Players[p].flag/Players[p].fireb.spd) );
					break;
				case MV_RUSH:
					GRush(p, (Players[p].flag/Players[p].rush.spd) );
					break;
				case MV_SMOVE:
					GSMove(p, (Players[p].flag/Players[p].smove.spd) );
					break;
				case MV_FIREBX:
					GFireBX(p, (Players[p].flag/Players[p].firebx.spd) );
					break;
				case MV_RUSHX:
					GRushX(p, (Players[p].flag/Players[p].rushx.spd) );
					break;
				case MV_SMOVEX:
					GSMoveX(p, (Players[p].flag/Players[p].smovex.spd) );
					break;
				case MV_SPUNCH:
					GPunch(p, (Players[p].flag/Players[p].spunch.spd) );
					Players[p].limdefx = Players[p].spunch.defx ;
					Players[p].limdefy = Players[p].spunch.defy ;
					break;
				case MV_WPUNCH:
					GWPunch(p, (Players[p].flag/Players[p].wpunch.spd) );
					Players[p].limdefx = Players[p].wpunch.defx ;
					Players[p].limdefy = Players[p].wpunch.defy ;
					break;
				case MV_SKICK:
					GKick(p, (Players[p].flag/Players[p].skick.spd) );
					Players[p].limdefx = Players[p].skick.defx ;
					Players[p].limdefy = Players[p].skick.defy ;
					break;
				case MV_WKICK:
					GWKick(p, (Players[p].flag/Players[p].wkick.spd) );
					Players[p].limdefx = Players[p].wkick.defx ;
					Players[p].limdefy = Players[p].wkick.defy ;
					break;
				case MV_GKICK:
					GGKick(p, (Players[p].flag/Players[p].gkick.spd) );
					Players[p].limdefx = Players[p].gkick.defx ;
					Players[p].limdefy = Players[p].gkick.defy ;
					break;
				case MV_GPUNCH:
					GGPunch(p, (Players[p].flag/Players[p].gpunch.spd) );
					Players[p].limdefx = Players[p].gpunch.defx ;
					Players[p].limdefy = Players[p].gpunch.defy ;
					break;
				case MV_GUARD:
					GSingle (p, 0 );
					break;
				case MV_GGUARD:
					GSingle (p, 2 );
					break;
				case MV_HURT:
					GHurt (p, (Players[p].hflag/(25/Players[p].hurt.nbf))  );
					break;
				case MV_GHURT:
					GGHurt (p, (Players[p].hflag/(25/Players[p].ghurt.nbf))  );
					break;
				case MV_KO:
					GKO (p, (Players[p].hflag/7) );
					break;
			}
		}
	}
}

/*
 * Draw impact sprite
 */

void drawImpact(int p)
{
	int misc = 0;
	BITMAP** impact;

	if (Players[p].wimpact_ct)
	{
		Players[p].wimpact_ct-- ;
		misc = (11 - Players[p].wimpact_ct) / ( 10 / wimpact_nbf ) ;
		if (misc > wimpact_nbf)
		{
			misc = wimpact_nbf ;
			Players[p].wimpact_ct = 0 ;
		}
		impact = WImpact;
	}
	else if (Players[p].simpact_ct)
	{
		Players[p].simpact_ct-- ;
		misc = (11 - Players[p].simpact_ct) / ( 10 / simpact_nbf ) ;
		if (misc > simpact_nbf)
		{
			misc = simpact_nbf ;
			Players[p].simpact_ct = 0 ;
		}
		impact = SImpact;
	}
	else if (Players[p].bimpact_ct)
	{
		Players[p].bimpact_ct-- ;
		misc = (11 - Players[p].bimpact_ct) / ( 10 / bimpact_nbf ) ;
		if (misc > bimpact_nbf)
		{
			misc = bimpact_nbf ;
			Players[p].bimpact_ct = 0 ;
		}
		impact = BlockImpact;
	}
	else
		return;

	if (misc == 0)
		misc = 1 ;
	if (Players[p].invers==0)
		draw_sprite(zoomscreen, impact[misc], Players[p].limoffx - (impact[misc]->w>>1),	Players[p].limoffy - (impact[misc]->h>>1));
	else
		draw_sprite_h_flip(zoomscreen, impact[misc], Players[p].limoffx - (impact[misc]->w>>1),	Players[p].limoffy - (impact[misc]->h>>1));
}

/*
 * Test impact on simple attack (punch or kick)
 */

unsigned char testImpact(int p0,int p1,struct AMOVE* mv)
{
	return
		(	(	(  Players[p0].invers == 0 && Players[p1].x >= Players[p0].x+(Players[p0].width>>2)
				&& (Players[p0].x+mv->offx) > (Players[p1].x + Players[p1].width - Players[p1].limdefx))
			||
				(  Players[p0].invers == 1 && Players[p0].x >= Players[p1].x+(Players[p1].width>>2)
				&& (Players[p0].x+Players[p0].width-mv->offx) < (Players[p1].x + Players[p1].limdefx))
			)
		&&
			(Players[p0].y+mv->offy) > (Players[p1].y+Players[p1].limdefy)
		&&
			(Players[p0].y+mv->offy) < (Players[p1].y+Players[p1].height)
		);
}

/*
 * Init impact on simple attack
 */

void doImpact(int p0,int p1,struct AMOVE* mv)
{
	int a;
	Players[p1].damag = mv->dmg ;
	Players[p0].limoffx = Players[p0].x + (Players[p0].invers == 0 ? mv->offx : Players[p0].width-mv->offx) ;
	a = Players[p1].x + (Players[p1].width>>2);
	if (Players[p1].invers==0 && Players[p0].limoffx < a)
		Players[p0].limoffx = a;
	else
	{
		a = Players[p1].x + 3*(Players[p1].width>>2);
		if (Players[p1].invers==1 && Players[p0].limoffx > a)
			Players[p0].limoffx = a;
	}
	Players[p0].limoffy = Players[p0].y + mv->offy ;
	if (Players[p0].limoffy < Players[p1].y)
		Players[p0].limoffy = Players[p1].y;
}

/*
 * Test impact on special moves
 */

unsigned char testImpactS(int p0,int p1,struct SMOVE* mv)
{
	return
		(	(  Players[p0].invers == 0 && Players[p1].x >= Players[p0].x+(Players[p0].width>>2)
			&& (Players[p0].x+mv->offx) > (Players[p1].x + Players[p1].width - Players[p1].limdefx))
		||
			(  Players[p0].invers == 1 && Players[p0].x >= Players[p1].x+(Players[p1].width>>2)
			&& (Players[p0].x+Players[p0].width-mv->offx) < (Players[p1].x + Players[p1].limdefx))
		);
}

/*
 * Init impact on special moves
 */

void doImpactS(int p0,int p1,struct SMOVE* mv)
{
	Players[p1].damag = mv->dmg ;
	Players[p0].limoffx = Players[p0].x + (Players[p0].invers == 0 ? mv->offx : Players[p0].width-mv->offx) ;
	Players[p0].limoffy = Players[p0].y + mv->offy ;
}

/*
 * Update current player animation
 */

void playerAnim(int p0)
{
	int p1 = 1-p0;
	int delayer = 2;
	int oldx0 = Players[p0].x;
	int oldx1 = Players[p1].x;
	int joy_rt = Players[p1].invers==0 ? JOY_LT(p1) : JOY_RT(p1);

	if ( Players[p0].actual >= MV_JUMP_U)
	{
		if (Players[p0].y < Players[p0].jump_how)
			Players[p0].sens = 1 ;
		if ( Players[p0].sens )
		{
			if ( Players[p0].y < (Players[p0].jump_how+4) )
				Players[p0].y++ ;
			else if ( Players[p0].y < (Players[p0].jump_how+17) )
				Players[p0].y += 2 ;
			else
				Players[p0].y += 3 ;
			if (Players[p0].y >= Players[p0].sol)
			{
				Players[p0].actual = MV_STATIC ;
				Players[p0].y = Players[p0].sol ;
				Players[p0].sens = 0 ;
				Players[p0].limak = 1;
			}
		}
		else
		{
			if ( Players[p0].y < (Players[p0].jump_how+4) )
				Players[p0].y-- ;
			else if ( Players[p0].y < (Players[p0].jump_how+17) )
				Players[p0].y -= 2 ;
			else
				Players[p0].y -= 3 ;
		}
		if ( (Players[p0].invers==0 && Players[p0].actual == MV_JUMP_B ) || (Players[p0].invers==1 && Players[p0].actual == MV_JUMP_F ))	/* JUMP LEFT */
			Players[p0].x -= 2 ;
		else if ( (Players[p0].invers==0 && Players[p0].actual == MV_JUMP_F ) || (Players[p0].invers==1 && Players[p0].actual == MV_JUMP_B )) /* JUMP RIGHT */
			Players[p0].x += 2;
	}
	else if ( (Players[p0].actual == MV_RUSH) && (Players[p0].limp>0) ) /* RUSH */
	{
		Players[p0].flag++ ;
		if ( Players[p0].flag > ( (Players[p0].rush.hit-1)*Players[p0].rush.spd ) )
		{
			if (Players[p0].invers==0)
			{
				if ( (Players[p0].x+Players[p0].tol) < (Players[p1].x+Players[p1].tol) )
					Players[p0].x += Players[p0].rush.pix ;
			}
			else
			{
				if ( (Players[p0].x+Players[p0].width-Players[p0].tol) > (Players[p1].x+Players[p1].width-Players[p1].tol) )
					Players[p0].x -= Players[p0].rush.pix ;
			}
			if ( Players[p0].flag > Players[p0].rush.spd*(Players[p0].rush.hit + (Players[p0].rush.nbf-Players[p0].rush.hit)/2) )
			{
				if ( testImpactS(p0,p1,&Players[p0].rush) )
				{
					doImpactS(p0,p1,&Players[p0].rush);
					if ( Players[p1].y<(Players[p1].sol-5) )
					{
						Players[p0].simpact_ct = 10 ;
						Players[p1].actual = MV_KO ;
						Hurt(2);
					}
					else if (joy_rt)
					{
						Players[p0].bimpact_ct = 10 ;
						Players[p1].actual = JOY_DN(p1) ? MV_GGUARD : MV_GUARD ;
						Players[p1].life = Players[p1].life - BLOCK1 ;
						Block();
					}
					else
					{
						Players[p0].simpact_ct = 10 ;
						Players[p1].actual = JOY_DN(p1) ? MV_GHURT : MV_HURT;
						Hurt(1);
					}
					Players[p1].flag = 0 ;
					Players[p0].fballs[0].on = 0 ;
					Players[p0].autho_ht = 0 ;
					Players[p0].rush_stop = 0 ;
					Players[p0].flag = 0 ;
					Players[p0].actual = MV_STATIC ;
					Players[p0].limp = -delayer ;
				}
			}
		}
		if ( Players[p0].flag > (Players[p0].rush.spd*Players[p0].rush.nbf) )
		{
			Players[p0].flag = (Players[p0].rush.hit-1)*Players[p0].rush.spd ;
			Players[p0].rush_stop++ ;
			if ( Players[p0].rush_stop+1 > Players[p0].rush.rot )
			{
				Players[p0].fballs[0].on = 0 ;
				Players[p0].autho_ht = 0 ;
				Players[p0].rush_stop = 0 ;
				Players[p0].flag = 0 ;
				Players[p0].actual = MV_STATIC ;
				Players[p0].limp = -delayer ;
			}
		}
	}
	else if ( (Players[p0].actual == MV_SMOVE) && (Players[p0].limp>0) )/* SMOVE */
	{
		Players[p0].flag++ ;
		if ( Players[p0].flag > ( (Players[p0].smove.hit-1)*Players[p0].smove.spd ) )
		{
			if ( Players[p0].flag > Players[p0].smove.spd*(Players[p0].smove.hit + (Players[p0].smove.nbf-Players[p0].smove.hit)/2) )
			{
				if ( testImpactS(p0,p1,&Players[p0].smove) )
				{
					doImpactS(p0,p1,&Players[p0].smove);
					if ( Players[p1].y<(Players[p1].sol-5) )
					{
						Players[p0].simpact_ct = 10 ;
						Players[p1].actual = MV_KO ;
						Hurt(1);
					}
					else
					{
						if(joy_rt)
						{
							Players[p0].bimpact_ct = 10 ;
							Players[p1].actual = JOY_DN(p1) ? MV_GGUARD : MV_GUARD ;
							Players[p1].life = Players[p1].life - BLOCK1 ;
							Block() ;
						}
						else
						{
							Players[p0].simpact_ct = 10 ;
							Players[p1].actual = JOY_DN(p1) ? MV_GHURT : MV_HURT ;
							Hurt(1);
						}
					}
					Players[p1].flag = 0 ;
					Players[p0].fballs[0].on = 0 ;
					Players[p0].autho_ht = 0 ;
					Players[p0].smove_stop = 0 ;
					Players[p0].flag = 0 ;
					Players[p0].actual = MV_STATIC ;
					Players[p0].limp = -delayer ;
				}
			}
			if ( Players[p0].flag > (Players[p0].smove.spd*Players[p0].smove.nbf) )
			{
				Players[p0].flag = (Players[p0].smove.hit-1)*Players[p0].smove.spd ;
				Players[p0].smove_stop++ ;
				if ( Players[p0].smove_stop+1 > Players[p0].smove.rot )
				{
					Players[p0].fballs[0].on = 0 ;
					Players[p0].autho_ht = 0 ;
					Players[p0].smove_stop = 0 ;
					Players[p0].flag = 0 ;
					Players[p0].actual = MV_STATIC ;
					Players[p0].limp = -delayer ;
				}
			}
		}
	}
	else if ( (Players[p0].actual == MV_FIREB) && (Players[p0].limp>0) ) /* FIREB */
	{
		Players[p0].flag++ ;
		if ( Players[p0].flag == ( (Players[p0].fireb.hit-1)*Players[p0].fireb.spd ) )
		{
			Players[p0].fballs[0].dx = Players[p0].invers==0 ? 1 : -1 ;
			Players[p0].fballs[0].on = 1 ;
			Players[p0].fballs[0].flg = 0 ;
			Players[p0].fballs[0].x = Players[p0].x + (Players[p0].invers==0 ? Players[p0].fballs[0].cx : (Players[p0].width - Players[p0].fballs[0].cx - Players[p0].fballs[0].w));
			Players[p0].fballs[0].y = Players[p0].y + Players[p0].fballs[0].cy - (Players[p0].fballs[0].h>>1) ;
		}
		if ( Players[p0].flag > ((Players[p0].fireb.spd*Players[p0].fireb.nbf)+10) )
		{
			Players[p0].flag = 0 ;
			Players[p0].actual = MV_STATIC ;
			Players[p0].limp = -delayer ;
		}
	}
	/* SPECIALS */
	else if ( (Players[p0].actual == MV_RUSHX) && (Players[p0].limp>0) )
	{
		Players[p0].flag++ ;
		if ( Players[p0].flag > ( (Players[p0].rushx.hit-1)*Players[p0].rushx.spd ) )
		{
			if (Players[p0].invers==0)
			{
				if ( (Players[p0].x+Players[p0].tol) < (Players[p1].x+Players[p1].tol) )
					Players[p0].x += Players[p0].rushx.pix ;
			}
			else
			{
				if ( (Players[p0].x+Players[p0].tol) > (Players[p1].x+Players[p1].tol) )
					Players[p0].x -= Players[p0].rushx.pix ;
			}
			if ( Players[p0].flag > Players[p0].rushx.spd*(Players[p0].rushx.hit + (Players[p0].rushx.nbf-Players[p0].rushx.hit)/2) )
			{
				if ( testImpactS(p0,p1,&Players[p0].rushx) )
				{
					doImpactS(p0,p1,&Players[p0].rushx);
					if ( Players[p1].y<(Players[p1].sol-5) )
					{
						Players[p0].simpact_ct = 10 ;
						Players[p1].actual = MV_KO ;
						Hurt(1);
					}
					else if (joy_rt)
					{
						Players[p0].bimpact_ct = 10 ;
						Players[p1].actual = JOY_DN(p1) ? MV_GGUARD : MV_GUARD ;
						Players[p1].life = Players[p1].life - BLOCK2 ;
						Block() ;
					}
					else
					{
						Players[p0].simpact_ct = 10 ;
						Players[p1].actual = JOY_DN(p1) ? MV_GHURT : MV_HURT;
						Hurt(1);
					}
					Players[p1].flag = 0 ;
					Players[p0].fballs[1].on = 0 ;
					Players[p0].fballs[0].on = 0 ;
					Players[p0].autho_ht = 0 ;
					Players[p0].rushx_stop = 0 ;
					Players[p0].flag = 0 ;
					Players[p0].actual = MV_STATIC ;
					Players[p0].limp = -delayer ;
				}
			}
			if ( Players[p0].flag > (Players[p0].rushx.spd*Players[p0].rushx.nbf) )
			{
				Players[p0].flag = (Players[p0].rushx.hit-1)*Players[p0].rushx.spd ;
				Players[p0].rushx_stop++ ;
				if ( Players[p0].rushx_stop+1 > Players[p0].rushx.rot )
				{
					Players[p0].fballs[0].on = 0 ;
					Players[p0].fballs[1].on = 0 ;
					Players[p0].autho_ht = 0 ;
					Players[p0].rushx_stop = 0 ;
					Players[p0].flag = 0 ;
					Players[p0].actual = MV_STATIC ;
					Players[p0].limp = -delayer ;
				}
			}
		}
	}
	else if ( (Players[p0].actual == MV_SMOVEX) && (Players[p0].limp>0) )
	{
		Players[p0].flag++ ;
		if ( Players[p0].flag > ( (Players[p0].smovex.hit-1)*Players[p0].smovex.spd ) )
		{
			if ( Players[p0].flag > Players[p0].smovex.spd*(Players[p0].smovex.hit + (Players[p0].smovex.nbf-Players[p0].smovex.hit)/2) )
			{
				if ( testImpactS(p0,p1,&Players[p0].smovex) )
				{
					doImpactS(p0,p1,&Players[p0].smovex);
					if ( Players[p1].y<(Players[p1].sol-5) )
					{
						Players[p0].simpact_ct = 10 ;
						Players[p1].actual = MV_KO ;
						Hurt(1);
					}
					else if (joy_rt)
					{
						Players[p0].bimpact_ct = 10 ;
						Players[p1].actual = JOY_DN(p1) ? MV_GGUARD : MV_GUARD ;
						Players[p1].life = Players[p1].life - BLOCK2 ;
						Block() ;
					}
					else
					{
						Players[p0].simpact_ct = 10 ;
						Players[p1].actual = JOY_DN(p1) ? MV_GHURT : MV_HURT ;
						Hurt(1);
					}
					Players[p1].flag = 0 ;
					Players[p0].fballs[1].on = 0 ;
					Players[p0].fballs[0].on = 0 ;
					Players[p0].autho_ht = 0 ;
					Players[p0].smovex_stop = 0 ;
					Players[p0].flag = 0 ;
					Players[p0].actual = MV_STATIC ;
					Players[p0].limp = -delayer ;
				}
			}
			if ( Players[p0].flag > (Players[p0].smovex.spd*Players[p0].smovex.nbf) )
			{
				Players[p0].flag = (Players[p0].smovex.hit-1)*Players[p0].smovex.spd ;
				Players[p0].smovex_stop++ ;
				if ( Players[p0].smovex_stop+1 > Players[p0].smovex.rot )
				{
					Players[p0].fballs[1].on = 0 ;
					Players[p0].fballs[0].on = 0 ;
					Players[p0].autho_ht = 0 ;
					Players[p0].smovex_stop = 0 ;
					Players[p0].flag = 0 ;
					Players[p0].actual = MV_STATIC ;
					Players[p0].limp = -delayer ;
				}
			}
		}
	}
	else if ( (Players[p0].actual == MV_FIREBX) && (Players[p0].limp>0) )
	{
		Players[p0].flag++ ;
		if ( Players[p0].flag == ( (Players[p0].firebx.hit-1)*Players[p0].firebx.spd ) )
		{
			Players[p0].fballs[1].dx = Players[p0].invers==0 ? 1 : -1 ;
			Players[p0].fballs[1].on = 1 ;
			Players[p0].fballs[1].flg = 0 ;
			Players[p0].fballs[1].x = Players[p0].x + (Players[p0].invers==0 ? Players[p0].fballs[0].cx : (Players[p0].width - Players[p0].fballs[0].cx - Players[p0].fballs[1].w));
			Players[p0].fballs[1].y = Players[p0].y + Players[p0].fballs[1].cy - (Players[p0].fballs[1].h/2) ;
		}
		if ( Players[p0].flag > ((Players[p0].firebx.spd*Players[p0].firebx.nbf)+10) )
		{
			Players[p0].flag = 0 ;
			Players[p0].actual = MV_STATIC ;
			Players[p0].limp = -delayer ;
		}
 	}
 	/* END OF SPECIALS */
	else if ( (Players[p0].actual == MV_SPUNCH) && (Players[p0].limp>0) )
	{
		Players[p0].flag++ ;
		if ( Players[p0].flag > ((Players[p0].spunch.spd*Players[p0].spunch.nbf)-1) )
		{
			Players[p0].flag = 0 ;
			Players[p0].actual = MV_STATIC ;
			Players[p0].limp = -delayer ;
		}
	}
	else if ( (Players[p0].actual == MV_WPUNCH) && (Players[p0].limp>0) )
	{
		Players[p0].flag++ ;
		if ( Players[p0].flag > ((Players[p0].wpunch.spd*Players[p0].wpunch.nbf)-1) )
		{
			Players[p0].flag = 0 ;
			Players[p0].actual = MV_STATIC ;
			Players[p0].limp = -delayer ;
		}
	}
	else if ( (Players[p0].actual == MV_SKICK) && (Players[p0].limp>0) )
	{
		Players[p0].flag++ ;
		if ( Players[p0].flag > ((Players[p0].skick.spd*Players[p0].skick.nbf)-1) )
		{
			Players[p0].flag = 0 ;
			Players[p0].actual = MV_STATIC ;
			Players[p0].limp = -delayer ;
		}
	}
	else if ( (Players[p0].actual == MV_WKICK) && (Players[p0].limp>0) )
	{
		Players[p0].flag++ ;
		if ( Players[p0].flag > ((Players[p0].wkick.spd*Players[p0].wkick.nbf)-1) )
		{
			Players[p0].flag = 0 ;
			Players[p0].actual = MV_STATIC ;
			Players[p0].limp = -delayer ;
		}
	}
	else if ( (Players[p0].actual == MV_GKICK) && (Players[p0].limp>0) )
	{
		Players[p0].flag++ ;
		if ( Players[p0].flag > ((Players[p0].gkick.spd*Players[p0].gkick.nbf)-1) )
		{
			Players[p0].flag = 0 ;
			Players[p0].actual = MV_STATIC ;
			Players[p0].limp = -delayer ;
		}
	}
	else if ( (Players[p0].actual == MV_GPUNCH) && (Players[p0].limp>0) )
	{
		Players[p0].flag++ ;
		if ( Players[p0].flag > ((Players[p0].gpunch.spd*Players[p0].gpunch.nbf)-1) )
		{
			Players[p0].flag = 0 ;
			Players[p0].actual = MV_STATIC ;
			Players[p0].limp = -delayer ;
		}
 	}
	else if ( Players[p0].actual == MV_GUARD)
	{
		if ( Players[p0].y < (Players[p0].sol-1) )
			Players[p0].y = Players[p0].y + 3 ;
		Players[p0].flag++ ;
		if ( (Players[p0].flag > (Players[p0].damag*10) ) && (Players[p0].y>(Players[p0].sol-2)) )
			Players[p0].actual = MV_STATIC ;
	}
	else if ( Players[p0].actual == MV_GGUARD )
	{
		if ( Players[p0].y < (Players[p0].sol-1) )
			Players[p0].y = Players[p0].y + 3 ;
		Players[p0].flag++ ;
		if ( (Players[p0].flag > (Players[p0].damag*10) ) && (Players[p0].y>(Players[p0].sol-2)) )
			Players[p0].actual = MV_CROUCH ;
	}
	else if ( Players[p0].actual == MV_HURT )
	{
		if ( Players[p0].y < (Players[p0].sol-1) )
			Players[p0].y = Players[p0].y + 3 ;
		Players[p0].hflag++ ;
		if ( Players[p0].hflag < 17 )
			Players[p0].life = Players[p0].life - Players[p0].damag ;
		if ( Players[p0].hflag > 25 )
		{
			Players[p0].actual = MV_STATIC ;
			Players[p0].hflag = 0 ;
		}
		if ( Players[p0].hflag < 7 )
		{
			Players[p0].x += Players[p0].invers==0 ? -1:1 ;
			Players[p1].x += Players[p0].invers==0 ? 2:-2;
		}
	}
	else if ( Players[p0].actual == MV_GHURT )
	{
		if ( Players[p0].y < (Players[p0].sol-1) )
			Players[p0].y = Players[p0].y + 3 ;
		Players[p0].hflag++ ;
		if ( Players[p0].hflag < 17 )
			Players[p0].life = Players[p0].life - Players[p0].damag ;
		if ( Players[p0].hflag > 25 )
		{
			Players[p0].actual = MV_CROUCH ;
			Players[p0].hflag = 0 ;
		}
		if ( Players[p0].hflag < 7 )
		{
			Players[p0].x += Players[p0].invers==0 ? -1:1 ;
			Players[p1].x += Players[p0].invers==0 ? 2:-2;
		}
	}
	else if ( Players[p0].actual == MV_KO )
	{
		if ( Players[p0].y < (Players[p0].sol-1) )
			Players[p0].y = Players[p0].y + 2 ;
		Players[p0].hflag++ ;
		if ( Players[p0].hflag < 25 )
			Players[p0].life = Players[p0].life - Players[p0].damag ;
		if ( Players[p0].hflag > 42 )
		{
			Players[p0].actual = MV_STATIC ;
			Players[p0].hflag = 0 ;
		}
		if ( Players[p0].hflag < 15 )
		{
			Players[p0].x += Players[p0].invers==0 ? -1:1 ;
			Players[p1].x += Players[p0].invers==0 ? 2:-2;
		}
	}
	computeZoom(p0,oldx0);
	computeZoom(p1,oldx1);
}

/*
 * Check input from human player
 */

void checkInput(int p)
{
	int oldx = Players[p].x;
	if (Players[p].actual <= MV_CROUCH)
	{
		Players[p].actual = MV_STATIC ;
		poll_joystick();
		if ( JOY_LT(p) && JOY_UP(p) )
			Players[p].actual = Players[p].invers == 0 ? MV_JUMP_B : MV_JUMP_F ;
		else if ( JOY_RT(p) && JOY_UP(p) )
			Players[p].actual = Players[p].invers == 0 ? MV_JUMP_F : MV_JUMP_B ;
		else if ( JOY_UP(p) )
			Players[p].actual = MV_JUMP_U ;
		else if ( JOY_DN(p) )
			Players[p].actual = MV_CROUCH ;
		else if( JOY_LT(p) )
		{
			Players[p].x -= 2 ;
			Players[p].flag-- ;
			if ( Players[p].flag < 0 )
				Players[p].flag = ((Players[p].walk.spd*Players[p].walk.nbf)-1) ;
			Players[p].actual = Players[p].invers == 0 ? MV_WALK_F : MV_WALK_B;
		}
		else if( JOY_RT(p) )
		{
			Players[p].x += 2 ;
			Players[p].flag++ ;
			if ( Players[p].flag > ((Players[p].walk.spd*Players[p].walk.nbf)-1) )
				Players[p].flag = 0 ;
			Players[p].actual = Players[p].invers == 0 ? MV_WALK_B : MV_WALK_F;
		}

		if ( (Players[p].actual < MV_CROUCH) && (Players[p].limp>0)
			&& !Players[p].fireb.succ && !Players[p].rush.succ && !Players[p].smove.succ
			&& !Players[p].firebx.succ && !Players[p].rushx.succ && !Players[p].smovex.succ )
		{
			if ( JOY_SP(p) )
			{
				Paf(2);
				Players[p].actual = MV_SPUNCH ;
				Players[p].flag = 0 ;
				fy = 1 ;
			}
			else if ( JOY_WP(p) )
			{
				Paf(1);
				Players[p].actual = MV_WPUNCH ;
				Players[p].flag = 0 ;
				fy = 1 ;
			}
			else if ( JOY_SK(p) )
			{
				Paf(4) ;
				Players[p].actual = MV_SKICK ;
				Players[p].flag = 0 ;
				fy = 1 ;
			}
			else if ( JOY_WK(p) )
			{
				Paf(3) ;
				Players[p].actual = MV_WKICK ;
				Players[p].flag = 0 ;
				fy = 1 ;
			}
		}

		if ( (Players[p].actual == MV_CROUCH) && (Players[p].limp>0) )
		{
			if ( JOY_WK(p) || JOY_SK(p) )
			{
				Paf(1);
				Players[p].actual = MV_GKICK ;
				Players[p].flag = 0 ;
				fy = 1 ;
			}
			else if ( JOY_SP(p) || JOY_WP(p) )
			{
				Paf(4);
				Players[p].actual = MV_GPUNCH ;
				Players[p].flag = 0 ;
				fy = 1 ;
			}
		}

		if ( Players[p].fireb.flg )
		{
			if ( check_kstatus(p, Players[p].fireb.seq[0] ) && !Players[p].fireb.succ )
			{
				Players[p].fireb.succ = 1 ;
				Players[p].fireb.nb = 0 ;
			}
			else if (Players[p].fireb.succ)
			{
				if ( (Players[p].last_status == Players[p].fireb.seq[Players[p].fireb.nb]) ||(Players[p].last_status == Players[p].fireb.seq[Players[p].fireb.nb+1]) )
				{
					if (check_kstatus(p,Players[p].fireb.seq[Players[p].fireb.nb+1]) )
					{
						Players[p].fireb.nb++ ;
						Players[p].fireb.succ = Players[p].fireb.nb + 1 ;
						if (Players[p].fireb.succ == Players[p].fireb.end)
						{
							play_sample( Players[p].hadoken );
							Players[p].fireb.succ = 0;
							Players[p].actual = MV_FIREB ;
							Players[p].flag = 0 ;
							Players[p].autho_ht = 1 ;
							Players[p].spower += 10 ;
						}
					}
					else if ( !check_kstatus(p,Players[p].last_status) )
						Players[p].fireb.succ = 0 ;
				}
				else
					Players[p].fireb.succ = 0 ;
			}
			else
				Players[p].fireb.succ = 0 ;
		}
		else
			Players[p].fireb.succ = 0 ;

		if ( Players[p].rush.flg )
		{
			if ( check_kstatus(p, Players[p].rush.seq[0] ) && !Players[p].rush.succ )
			{
				Players[p].rush.succ = 1 ;
				Players[p].rush.nb = 0 ;
			}
			else if (Players[p].rush.succ)
			{
				if ( (Players[p].last_status == Players[p].rush.seq[Players[p].rush.nb]) ||(Players[p].last_status == Players[p].rush.seq[Players[p].rush.nb+1]) )
				{
					if (check_kstatus(p,Players[p].rush.seq[Players[p].rush.nb+1]) )
					{
						Players[p].rush.nb++ ;
						Players[p].rush.succ = Players[p].rush.nb + 1 ;
						if (Players[p].rush.succ == Players[p].rush.end)
						{
							play_sample( Players[p].copter );
							Players[p].rush.succ = 0;
							Players[p].actual = MV_RUSH ;
							Players[p].flag = 0 ;
							Players[p].autho_ht = 1 ;
							Players[p].spower += 10 ;
						}
					}
					else if ( !check_kstatus(p,Players[p].last_status) )
						Players[p].rush.succ = 0 ;
				}
				else
					Players[p].rush.succ = 0 ;
			}
			else
				Players[p].rush.succ = 0 ;
		}
		else
			Players[p].rush.succ = 0 ;

		if ( Players[p].smove.flg )
		{
			if ( check_kstatus(p, Players[p].smove.seq[0] ) && !Players[p].smove.succ )
			{
				Players[p].smove.succ = 1 ;
				Players[p].smove.nb = 0 ;
			}
			else if (Players[p].smove.succ)
			{
				if ( (Players[p].last_status == Players[p].smove.seq[Players[p].smove.nb]) ||(Players[p].last_status == Players[p].smove.seq[Players[p].smove.nb+1]) )
				{
					if (check_kstatus(p,Players[p].smove.seq[Players[p].smove.nb+1]) )
					{
						Players[p].smove.nb++ ;
						Players[p].smove.succ = Players[p].smove.nb + 1 ;
						if (Players[p].smove.succ == Players[p].smove.end)
						{
							play_sample( Players[p].dragon );
							Players[p].smove.succ = 0;
							Players[p].actual = MV_SMOVE ;
							Players[p].flag = 0 ;
							Players[p].autho_ht = 1 ;
							Players[p].spower += 10 ;
						}
					}
					else if ( !check_kstatus(p,Players[p].last_status) )
						Players[p].smove.succ = 0 ;
				}
				else
					Players[p].smove.succ = 0 ;
			}
			else
				Players[p].smove.succ = 0 ;
		}
		else
			Players[p].smove.succ = 0 ;

		/* NOW FOR SPECIALS */

		if ( Players[p].firebx.flg && Players[p].firebx.sflg)
		{
			if ( check_kstatus(p, Players[p].firebx.seq[0] ) && !Players[p].firebx.succ )
			{
				Players[p].firebx.succ = 1 ;
				Players[p].firebx.nb = 0 ;
			}
			else if (Players[p].firebx.succ)
			{
				if ( (Players[p].last_status == Players[p].firebx.seq[Players[p].firebx.nb]) ||(Players[p].last_status == Players[p].firebx.seq[Players[p].firebx.nb+1]) )
				{
					if (check_kstatus(p,Players[p].firebx.seq[Players[p].firebx.nb+1]) )
					{
						Players[p].firebx.nb++ ;
						Players[p].firebx.succ = Players[p].firebx.nb + 1 ;
						if (Players[p].firebx.succ == Players[p].firebx.end)
						{
							if (Players[p].firebx.spec)
							{
								Players[p].firebx.sflg = 0 ;
								Players[p].spower = 0 ;
							}
							play_sample( Players[p].hadokenx );
							Players[p].firebx.succ = 0;
							Players[p].actual = MV_FIREBX ;
							Players[p].flag = 0 ;
							Players[p].autho_ht = 1 ;
							Players[p].spower += 10 ;
						}
					}
					else if ( !check_kstatus(p,Players[p].last_status) )
						Players[p].firebx.succ = 0 ;
				}
				else
					Players[p].firebx.succ = 0 ;
			}
			else
				Players[p].firebx.succ = 0 ;
		}
		else
			Players[p].firebx.succ = 0 ;

		if ( Players[p].rushx.flg && Players[p].rushx.sflg)
		{
			if ( check_kstatus(p, Players[p].rushx.seq[0] ) && !Players[p].rushx.succ )
			{
				Players[p].rushx.succ = 1 ;
				Players[p].rushx.nb = 0 ;
			}
			else if (Players[p].rushx.succ)
			{
				if ( (Players[p].last_status == Players[p].rushx.seq[Players[p].rushx.nb]) ||(Players[p].last_status == Players[p].rushx.seq[Players[p].rushx.nb+1]) )
				{
					if (check_kstatus(p,Players[p].rushx.seq[Players[p].rushx.nb+1]) )
					{
						Players[p].rushx.nb++ ;
						Players[p].rushx.succ = Players[p].rushx.nb + 1 ;
						if (Players[p].rushx.succ == Players[p].rushx.end)
						{
							if (Players[p].rushx.spec)
							{
								Players[p].rushx.sflg = 0 ;
								Players[p].spower = 0 ;
							}
							play_sample( Players[p].copterx );
							Players[p].rushx.succ = 0;
							Players[p].actual = MV_RUSHX ;
							Players[p].flag = 0 ;
							Players[p].autho_ht = 1 ;
							Players[p].spower += 10 ;
						}
					}
					else if ( !check_kstatus(p,Players[p].last_status) )
						Players[p].rushx.succ = 0 ;
				}
				else
					Players[p].rushx.succ = 0 ;
			}
			else
				Players[p].rushx.succ = 0 ;
		}
		else
			Players[p].rushx.succ = 0 ;

		if ( Players[p].smovex.flg && Players[p].smovex.sflg )
		{
			if ( check_kstatus(p, Players[p].smovex.seq[0] ) && !Players[p].smovex.succ )
			{
				Players[p].smovex.succ = 1 ;
				Players[p].smovex.nb = 0 ;
			}
			else if (Players[p].smovex.succ)
			{
				if ( (Players[p].last_status == Players[p].smovex.seq[Players[p].smovex.nb]) || (Players[p].last_status == Players[p].smovex.seq[Players[p].smovex.nb+1]) )
				{
					if (check_kstatus(p,Players[p].smovex.seq[Players[p].smovex.nb+1]) )
					{
						Players[p].smovex.nb++ ;
						Players[p].smovex.succ = Players[p].smovex.nb + 1 ;
						if (Players[p].smovex.succ == Players[p].smovex.end)
						{
							if (Players[p].smovex.spec)
							{
								Players[p].smovex.sflg = 0 ;
								Players[p].spower = 0 ;
							}
							play_sample( Players[p].dragonx );
							Players[p].smovex.succ = 0;
							Players[p].actual = MV_SMOVEX ;
							Players[p].flag = 0 ;
							Players[p].autho_ht = 1 ;
							Players[p].spower += 10 ;
						}
					}
					else if ( !check_kstatus(p,Players[p].last_status) )
						Players[p].smovex.succ = 0 ;
				}
				else
					Players[p].smovex.succ = 0 ;
			}
			else
				Players[p].smovex.succ = 0 ;
		}
		else
			Players[p].smovex.succ = 0 ;
	}
	computeZoom(p,oldx);
}

/*
 * Compute new zoom area according to the new player coordinates
 */

void computeZoom(int p0,int oldx)
{
	int i, min, max, p1 = 1-p0;

	if (oldx!=Players[p0].x)
	{
		i = Players[p0].x + limg(p0) - cx ;
		if ( i < 0)
		{
			if ( cx > 0 )
				cx = cx+i < 0 ? 0 : cx+i ;
			else
				Players[p0].x -= i;	
		}
		i = Players[p0].x - limd(p0) - cx;
		if ( i > 0 )
		{
			if ( zoomwidth < ZH  && (cx+zoomwidth+i) < Bkgd->w)
				zoomwidth = zoomwidth+i<ZH ? zoomwidth+i : ZH ;
			else
				Players[p0].x -= i;	
		}
	}

	if ((Players[p0].actual <= MV_CROUCH || (Players[p0].actual >= MV_GUARD && Players[p0].actual <= MV_JUMP_U)) && Players[p1].actual <= MV_JUMP_U)
	{
		if ((Players[p0].x > 0) && (Players[p0].x < Players[p1].x) && ((Players[p0].x+(Players[p0].width>>1))>Players[p1].x))
			Players[p0].x--;
		else if ((Players[p0].x+Players[p0].width < Bkgd->w) && (Players[p0].x > Players[p1].x) && ((Players[p1].x+(Players[p1].width>>1))>Players[p0].x))
			Players[p0].x++;
	}

	min = MIN(Players[0].x,Players[1].x);
	max = MAX(Players[0].x+Players[0].width,Players[1].x+Players[1].width);
	if ((max-min)<zoomwidth)
	{
		if (zoomwidth>ZW)
		{
			zoomwidth--;
			if (min > cx)
				cx++;
		}
		else
		{
			if ((min>cx+(zoomwidth>>2)) && (cx+zoomwidth+1<Bkgd->w))
				cx++;
			else if ((max<cx+3*(zoomwidth>>2)) && (cx>0))
				cx--;
		}
	}
	else
	{
		i = Players[0].x - limd(0) - cx;
		max = Players[1].x - limd(1) - cx;
		i = MAX(i,max);
 		if (i>0)
		{
			if (zoomwidth<ZH && (cx+zoomwidth+i) < Bkgd->w && zoomwidth+i<ZH)
				zoomwidth += i ;
			else
				Players[p0].x = oldx;
		}
	}
}

void staticUpdating(int p)
{
	if (Players[p].actual <= MV_CROUCH)
	{
		if (   (Players[p].invers==0 && Players[p].x > Players[1-p].x)
			|| (Players[p].invers==1 && Players[p].x < Players[1-p].x))
			Players[p].invers = 1-Players[p].invers;
	}

	/* static updating*/
	if (Players[p].actual == MV_STATIC)
	{
		Players[p].flag++;
		if (Players[p].flag > ((Players[p].statik.spd*Players[p].statik.nbf)-1) )
			Players[p].flag = 0 ;
		if ( Players[p].y < (Players[p].sol-1) )
			Players[p].y = Players[p].y + 3 ;
	}

	if ( !JOY_WK(p) && !JOY_SK(p) && !JOY_SP(p) && !JOY_WP(p) && (Players[p].limp<1) )
		Players[p].limp++;

	/* UPDATE AIR-KICK ***********/

	if ( (Players[p].actual >= MV_JUMP_U) && (Players[p].apch==0) )
	{
		if (Players[p].ak && Players[p].limak)
		{
			Players[p].ak++ ;
			if (Players[p].ak>25)
			{
				Players[p].ak = 0 ;
				Players[p].limak = 0 ;
			}
		}
		else if (Players[p].limak)
		{
			poll_joystick();
			if ( JOY_WK(p) || JOY_SK(p) )
			{
				Players[p].ak = 1 ;
				Paf(3) ;
				fy = 1 ;
			}
		}
	}
	else
		Players[p].ak = 0 ;

	/* UPDATE AIR-PUNCH ***********/

	if ( ( Players[p].actual >= MV_JUMP_U ) && (Players[p].ak==0) )
	{
		if (Players[p].apch && Players[p].limak)
		{
			Players[p].apch++ ;
			if (Players[p].apch>25)
			{
				Players[p].apch = 0 ;
				Players[p].limak = 0 ;
			}
		}
		else if (Players[p].limak)
		{
			poll_joystick();
			if ( JOY_SP(p) || JOY_WP(p) )
			{
				Players[p].apch = 1 ;
				Paf(1) ;
				fy = 1 ;
			}
		}
	}
	else
		Players[p].apch = 0 ;
}

/*
 * Computer player management (AI)
 */

void checkAI(int p0)
{
	int g, h, i;
	int oldx = Players[p0].x;
	int p1 = 1-p0;
	int a = Players[p0].x + (Players[p0].invers==0 ? Players[p0].limdefx : Players[p0].width-Players[p0].limdefx);
	int b = Players[p1].x + (Players[p1].invers==0 ? Players[p1].width-Players[p1].limoffx : Players[p1].limoffx);
	unsigned char ti0,ti1,ti2,ti3,ti4,ti5;

	if (Players[p0].actual < MV_JUMP_U)
	{
		g = 1 ;
		h = GpRandN(100) ;

		/* Guard on crouch position */
		if ((Players[p0].actual == MV_CROUCH) && ( Players[p1].invers==0 ? a > b : a < b ))
		{
			if ( Players[p0].y < (Players[p0].sol-1) )
				Players[p0].y = Players[p0].y + 3 ;
			if (   ((Players[p1].actual > MIN_ATTACK) && (Players[p1].actual < MAX_ATTACK))
				|| Players[p1].ak
				|| Players[p1].apch
				|| ((Players[p1].fballs[0].on==1) && 
						(
						   (Players[p0].invers==0 && Players[p1].invers==1 && ((Players[p1].fballs[0].x + Players[p1].fballs[0].w)>Players[p0].x))
						|| (Players[p0].invers==1 && Players[p1].invers==0 && (Players[p1].fballs[0].x < (Players[p0].x+Players[p0].width)))
						)
				))
			{
				if ( h < defense )
				{
					JOY_DN(p0) = 1;
					if (Players[p0].invers==0)
						JOY_LT(p0) = 1;
					else
						JOY_RT(p0) = 1;
					g = 0;
				}
				else
					JOY_LT(p0) = JOY_RT(p0) = 0;
			}
		}

		/* Check attack on crouch position */
		if	(	g && (Players[p0].actual == MV_CROUCH)
			 && (Players[p0].limp>0)
			 && ((Players[p0].invers==0 && JOY_LT(p0)==0) || (Players[p0].invers==1 && JOY_RT(p0)==0))
			)
		{
			if ( Players[p0].y < (Players[p0].sol-1) )
				Players[p0].y = Players[p0].y + 3 ;
			if (h < offense)
			{
				if (testImpact(p0,p1,&Players[p0].gpunch))
				{
					doImpact(p0,p1,&Players[p0].gpunch);
					Paf(4) ;
					Players[p0].actual = MV_GPUNCH ;
					Players[p0].flag = 0 ;
					g = 0;
				}
				else if (testImpact(p0,p1,&Players[p0].gkick))
				{
					doImpact(p0,p1,&Players[p0].gkick);
					Paf(1) ;
					Players[p0].actual = MV_GKICK ;
					Players[p0].flag = 0 ;
					g = 0;
				}
			}
		}
		else if (Players[p0].actual == MV_CROUCH)
			Players[p0].actual = MV_STATIC ;

		if ( g && Players[p0].actual < MV_CROUCH )
		{
			/* Guard on static position */
			if ((Players[p1].invers==0) ? a > b : a < b )
			{
				if 	(  ((Players[p1].actual > MIN_ATTACK) && (Players[p1].actual < MAX_ATTACK))
					|| Players[p1].ak
					|| Players[p1].apch
					|| ((Players[p1].fballs[0].on==1) && 
						(
						   (Players[p0].invers==0 && Players[p1].invers==1 && ((Players[p1].fballs[0].x + Players[p1].fballs[0].w)>Players[p0].x))
						|| (Players[p0].invers==1 && Players[p1].invers==0 && (Players[p1].fballs[0].x < (Players[p0].x+Players[p0].width)))
						))
					)
				{
					if ( h < defense )
					{
						if (Players[p1].actual == MV_RUSH)
							JOY_DN(p0) = 1;
						if (Players[p0].invers==0)
							JOY_LT(p0) = 1;
						else
							JOY_RT(p0) = 1;
						g = 0;
					}
					else
						JOY_LT(p0) = JOY_RT(p0) = 0;
				}
				else if ( (Players[p1].actual == MV_GKICK) || (Players[p1].actual == MV_GPUNCH) )
				{
					if ( h < defense )
					{
						JOY_DN(p0) = 1;
						if (Players[p0].invers==0)
							JOY_LT(p0) = 1;
						else
							JOY_RT(p0) = 1;
						g = 0;
					}
					else
						JOY_LT(p0) = JOY_RT(p0) = 0;
				}
			}
			/* Check possible attacks */
			if (g)
			{
				ti0 = testImpact(p0,p1,&Players[p0].spunch);
				ti1 = testImpact(p0,p1,&Players[p0].wpunch);
				ti2 = testImpact(p0,p1,&Players[p0].skick);
				ti3 = testImpact(p0,p1,&Players[p0].wkick);
				ti4 = testImpactS(p0,p1,&Players[p0].smovex);
				ti5 = testImpactS(p0,p1,&Players[p0].smove);
			}
			if ( g && ( ti0 || ti1 || ti2 || ti3 || ti4 || ti5 ) )
			{
				g = 0;

				if (h < offense)
				{
					if (   (Players[p0].limp>0) && !Players[p0].fireb.succ && !Players[p0].rush.succ
						&& !Players[p0].smove.succ && !Players[p0].firebx.succ && !Players[p0].rushx.succ
						&& !Players[p0].smovex.succ )
					{
						i = GpRandN(100) ;

						if ( i < 5 )
						{
							Players[p0].actual = MV_STATIC ;
							Players[p0].ai_static = AI_STATIC;
							g = 1;
						}
						else if ( ( i < 20 ) && ti0 )
						{
							doImpact(p0,p1,&Players[p0].spunch);
							Paf(2) ;
							Players[p0].actual = MV_SPUNCH ;
							Players[p0].flag = 0 ;
						}
						else if ( ( i > 19 ) && ( i < 35 ) && ti1 )
						{
							doImpact(p0,p1,&Players[p0].wpunch);
							Paf(1) ;
							Players[p0].actual = MV_WPUNCH ;
							Players[p0].flag = 0 ;
						}
						else if ( ( i > 34 ) && ( i < 60 ) && ti2 )
						{
							doImpact(p0,p1,&Players[p0].skick);
							Paf(4) ;
							Players[p0].actual = MV_SKICK ;
							Players[p0].flag = 0 ;
						}
						else if ( ( i > 59 ) && ( i < 75 ) && ti3 )
						{
							doImpact(p0,p1,&Players[p0].wkick);
							Paf(3) ;
							Players[p0].actual = MV_WKICK ;
							Players[p0].flag = 0 ;
						}
						else if ( ( i > 74 ) && ( i < 85 ) && Players[p0].smovex.flg && Players[p0].smovex.sflg && ti4 )
						{
							doImpactS(p0,p1,&Players[p0].smovex);
							if (Players[p0].smovex.spec)
							{
								Players[p0].smovex.sflg = 0 ;
								Players[p0].spower = 0 ;
							}
							play_sample( Players[p0].dragonx );
							Players[p0].smovex.succ = 0;
							Players[p0].actual = MV_SMOVEX ;
							Players[p0].flag = 0 ;
							Players[p0].autho_ht = 1 ;
							Players[p0].spower += 10 ;
						}
						else if ( ( i > 84 ) && ( i < 95 ) && Players[p0].smove.flg && ti5 )
						{
							doImpactS(p0,p1,&Players[p0].smove);
							play_sample( Players[p0].dragon );
							Players[p0].smove.succ = 0;
							Players[p0].actual = MV_SMOVE ;
							Players[p0].flag = 0 ;
							Players[p0].autho_ht = 1 ;
							Players[p0].spower += 10 ;
						}
						else
						{
							g = 1;
							Players[p0].ai_walkb = AI_WALK ;
						}
					}
					else if ( Players[p1].actual == MV_WALK_F )
					{
						Players[p0].actual = MV_CROUCH ;
						g = 1 ;
					}
				}
				else
				{
					i = GpRandN(100) ;

					if ( i < 97 )
					{
						Players[p0].ai_walkb = AI_WALK ;
						Players[p0].actual = MV_WALK_F ;
						g = 1 ;
					}
					else
						Players[p0].actual = MV_JUMP_F ;
				}
			}
			else
				g = 1 ;

			if (g)
			{
				if ( Players[p0].ai_static )
				{
					Players[p0].ai_static-- ;
					Players[p0].actual = MV_STATIC ;
				}
				else if ( Players[p0].ai_walkf )
				{
					Players[p0].ai_walkf-- ;
					Players[p0].x += Players[p0].invers == 0 ? 2 : -2 ;
					Players[p0].flag++ ;
					if ( Players[p0].flag > ((Players[p0].walk.spd*Players[p0].walk.nbf)-1) )
						Players[p0].flag = 0 ;
					Players[p0].actual = MV_WALK_B ;
				}
				else if ( Players[p0].ai_walkb )
				{
					Players[p0].ai_walkb-- ;
					Players[p0].x += Players[p0].invers == 0 ? -2 : 2 ;
					Players[p0].flag-- ;
					if ( Players[p0].flag < 0 )
						Players[p0].flag = ((Players[p0].walk.spd*Players[p0].walk.nbf)-1) ;
					Players[p0].actual = MV_WALK_F ;
				}
				else
				{
					h = GpRandN(100) ;
					if (h < offense )
					{
						i = GpRandN(100) ;
						if ( i < 25)
						{
							Players[p0].actual = MV_WALK_B ;
							Players[p0].ai_walkf = AI_WALK ;
						}
						else if ( i < 30)
							Players[p0].actual = MV_JUMP_B ;
						else
						{
							if ( (Players[p0].limp>0) && !Players[p0].fireb.succ && !Players[p0].rush.succ )
							{
								if ( i < 65 )
								{
									if ( ( i < 45 ) && Players[p0].firebx.flg && Players[p0].firebx.sflg )
									{
										if (Players[p0].firebx.spec)
										{
											Players[p0].firebx.sflg = 0 ;
											Players[p0].spower = 0 ;
										}
										play_sample( Players[p0].hadokenx );
										Players[p0].firebx.succ = 0;
										Players[p0].actual = MV_FIREBX ;
										Players[p0].flag = 0 ;
										Players[p0].autho_ht = 1 ;
										Players[p0].spower += 10 ;
									}
									else if ( Players[p0].fireb.flg )
									{
										play_sample( Players[p0].hadoken );
										Players[p0].fireb.succ = 0;
										Players[p0].actual = MV_FIREB ;
										Players[p0].flag = 0 ;
										Players[p0].autho_ht = 1 ;
										Players[p0].spower += 10 ;
									}
									else
										Players[p0].actual = MV_JUMP_B ;
								}
								else
								{
									if ( ( i < 80 ) && Players[p0].rushx.flg && Players[p0].rushx.sflg )
									{
										if (Players[p0].rushx.spec)
										{
											Players[p0].rushx.sflg = 0 ;
											Players[p0].spower = 0 ;
										}
										play_sample( Players[p0].copterx );
										Players[p0].rushx.succ = 0;
										Players[p0].actual = MV_RUSHX ;
										Players[p0].flag = 0 ;
										Players[p0].autho_ht = 1 ;
										Players[p0].spower += 10 ;
									}
									else if ( Players[p0].rush.flg )
									{
										play_sample( Players[p0].copter );
										Players[p0].rush.succ = 0;
										Players[p0].actual = MV_RUSH ;
										Players[p0].flag = 0 ;
										Players[p0].autho_ht = 1 ;
										Players[p0].spower += 10 ;
									}
									else
										Players[p0].actual = MV_JUMP_B ;
								}
							}
						}
					}
					else
					{
						i = GpRandN(100) ;

						if ( i < 50 )
						{
							Players[p0].actual = MV_STATIC ;
							Players[p0].ai_static = AI_STATIC;
						}
						else if ( i < 65 )
							Players[p0].actual = MV_JUMP_F ;
						else if ( i < 80 )
							Players[p0].actual = MV_JUMP_U ;
						else if ( i < 85 )
						{
							Players[p0].actual = MV_WALK_B ;
							Players[p0].ai_walkf = AI_WALK ;
						}
						else
						{
							Players[p0].actual = MV_WALK_F ;
							Players[p0].ai_walkb = AI_WALK ;
						}
					}
				}
			}
		}
	}
	else if ( (Players[p0].actual >= MV_JUMP_U) && (Players[p0].ak==0) && (Players[p0].apch==0))
	{
		/* AIR AI !!! */

		ti0 = Players[p1].actual == MV_SPUNCH	&& testImpact(p1,p0,&Players[p1].spunch);
		ti1 = Players[p1].actual == MV_WPUNCH	&& testImpact(p1,p0,&Players[p1].wpunch);
		ti2 = Players[p1].actual == MV_SKICK	&& testImpact(p1,p0,&Players[p1].skick);
		ti3 = Players[p1].actual == MV_WKICK	&& testImpact(p1,p0,&Players[p1].wkick);
		ti4 = Players[p1].ak					&& testImpact(p1,p0,&Players[p1].akick);
		ti5 = Players[p1].apch					&& testImpact(p1,p0,&Players[p1].apunch);

		g = 1;
		h = GpRandN(100) ;
		if ( ti0 || ti1 || ti2 || ti3 || ti4 || ti5 || (Players[p1].actual == MV_RUSH) )
		{
			if ( h < defense )
			{
				g = 0;
				if (Players[p0].invers==0)
					JOY_LT(p0) = 1;
				else
					JOY_RT(p0) = 1;
			}
			else
				JOY_LT(p0) = JOY_RT(p0) = 0;
		}
		if (g && testImpact(p0,p1,&Players[p0].akick) )
		{
			if (h < offense)
			{
				doImpact(p0,p1,&Players[p0].akick);
				Players[p0].ak = 1 ;
				g = 0;
			}
			else
				Players[p0].ak = 0 ;
		}
		if (g && testImpact(p0,p1,&Players[p0].apunch) )
		{
			if (h < offense)
			{
				doImpact(p0,p1,&Players[p0].apunch);
				Players[p0].apch = 1 ;
			}
			else
				Players[p0].apch = 0 ;
		}
	}
	computeZoom(p0,oldx);
}

/*
 * Update attack and check impact
 */

void checkAttack(int p0)
{
	int p1 = 1-p0;
	int oldx0 = Players[p0].x;
	int oldx1 = Players[p1].x;
	int joy_rt = Players[p1].invers==0 ? JOY_LT(p1) : JOY_RT(p1);

	if( (Players[p0].actual == MV_SPUNCH) && ( Players[p0].flag == ( (Players[p0].spunch.hit-1)*Players[p0].spunch.spd) ) )/* PUNCH */
	{
		if ( testImpact(p0,p1,&Players[p0].spunch))
		{
			doImpact(p0,p1,&Players[p0].spunch);
			if ( Players[p1].y<(Players[p1].sol-5) )
			{
				Players[p1].actual = MV_KO ;
				Players[p0].hitfram = (Players[p0].spunch.hit-1)*Players[p0].spunch.spd ;
				Players[p0].wimpact_ct = 10 ;
				Hurt(2);
			}
			if (joy_rt)
			{
				Players[p0].bimpact_ct = 10 ;
				Players[p1].actual = JOY_DN(p1) ? MV_GGUARD : MV_GUARD ;
				Players[p1].life = Players[p1].life - BLOCK0 ;
				Block();
			}
			else
			{
				Players[p1].actual = JOY_DN(p1) ? MV_GHURT : MV_HURT ;
				Players[p0].hitfram = (Players[p0].spunch.hit-1)*Players[p0].spunch.spd ;
				Players[p0].wimpact_ct = 10 ;
				Hurt(1);
			}
			Players[p1].flag = 0 ;
		}
	}
	else if( (Players[p0].actual == MV_WPUNCH) && ( Players[p0].flag == ( (Players[p0].wpunch.hit-1)*Players[p0].wpunch.spd) ) )/* WPUNCH */
	{
		if ( testImpact(p0,p1,&Players[p0].wpunch))
		{
			doImpact(p0,p1,&Players[p0].wpunch);
			if (joy_rt)
			{
				Players[p0].bimpact_ct = 10 ;
				Players[p1].actual = JOY_DN(p1) ? MV_GGUARD : MV_GUARD ;
				Players[p1].life = Players[p1].life - BLOCK0 ;
				Block();
			}
			else
			{
				Players[p0].wimpact_ct = 10 ;
				Players[p1].actual = JOY_DN(p1) ? MV_GHURT : MV_HURT;
				Players[p0].hitfram = (Players[p0].wpunch.hit-1)*Players[p0].wpunch.spd ;
				Hurt(1);
			}
			Players[p1].flag = 0 ;
		}
	}
	else if( (Players[p0].actual == MV_SKICK) && ( Players[p0].flag == ( (Players[p0].skick.hit-1)*Players[p0].skick.spd) ) )/* KICK */
	{
		if ( testImpact(p0,p1,&Players[p0].skick))
		{
			doImpact(p0,p1,&Players[p0].skick);
			if ( Players[p1].y<(Players[p1].sol-5) )
			{
				Players[p0].wimpact_ct = 10 ;
				Players[p1].actual = MV_KO ;
				Players[p0].hitfram = (Players[p0].skick.hit-1)*Players[p0].skick.spd ;
				Hurt(2);
			}
			else if (joy_rt)
			{
				Players[p0].bimpact_ct = 10 ;
				Players[p1].actual = JOY_DN(p1) ? MV_GGUARD : MV_GUARD ;
				Players[p1].life = Players[p1].life - BLOCK0 ;
				Block();
			}
			else
			{
				Players[p0].wimpact_ct = 10 ;
				Players[p1].actual = JOY_DN(p1) ? MV_GHURT : MV_HURT ;
				Players[p0].hitfram = (Players[p0].skick.hit-1)*Players[p0].skick.spd ;
				Hurt(1);
			}
			Players[p1].flag = 0 ;
		}
	}
	else if( (Players[p0].actual == MV_WKICK) && ( Players[p0].flag == ( (Players[p0].wkick.hit-1)*Players[p0].wkick.spd) ) )/* WKICK */
	{
		if ( testImpact(p0,p1,&Players[p0].wkick))
		{
			doImpact(p0,p1,&Players[p0].wkick);
			if (joy_rt)
			{
				Players[p0].bimpact_ct = 10 ;
				Players[p1].actual = JOY_DN(p1) ? MV_GGUARD : MV_GUARD;
				Players[p1].life = Players[p1].life - BLOCK0 ;
				Block();
			}
			else
			{
				Players[p0].wimpact_ct = 10 ;
				Players[p1].actual = JOY_DN(p1) ? MV_GHURT : MV_HURT ;
				Players[p0].hitfram = (Players[p0].wkick.hit-1)*Players[p0].wkick.spd ;
				Hurt(1);
			}
			Players[p1].flag = 0 ;
		}
	}
	else if( ( Players[p0].actual == MV_GKICK)
          && ( Players[p0].flag == ( (Players[p0].gkick.hit-1)*Players[p0].gkick.spd) )
		  && (Players[p1].actual < MV_JUMP_U) )	/* GKICK */
	{
		if ( testImpact(p0,p1,&Players[p0].gkick))
		{
			doImpact(p0,p1,&Players[p0].gkick);
			if (JOY_DN(p1))
			{
				if (joy_rt)
				{
					Players[p0].bimpact_ct = 10 ;
					Players[p1].actual = MV_GGUARD ;
					Players[p1].life = Players[p1].life - BLOCK0 ;
					Block();
				}
				else
				{
					Players[p0].wimpact_ct = 10 ;
					Players[p1].actual = MV_GHURT ;
					Players[p0].hitfram = (Players[p0].gkick.hit-1)*Players[p0].gkick.spd ;
					Hurt(1);
				}
			}
			else if ( Players[p0].flag < (Players[p0].gkick.hit*Players[p0].gkick.spd) )
			{
				Players[p0].wimpact_ct = 10 ;
				Players[p1].actual = MV_KO ;
				Players[p0].hitfram = (Players[p0].gkick.hit-1)*Players[p0].gkick.spd ;
				Hurt(2);
			}
			Players[p1].flag = 0 ;
		}
	}
	else if( (Players[p0].actual == MV_GPUNCH)
		  && ( Players[p0].flag == ( (Players[p0].gpunch.hit-1)*Players[p0].gpunch.spd) )
		  && ( Players[p1].actual < MV_JUMP_U ) )	/* GPUNCH */
	{
		if ( testImpact(p0,p1,&Players[p0].gpunch))
		{
			doImpact(p0,p1,&Players[p0].gpunch);
			if (JOY_DN(p1))
			{
				if (joy_rt)
				{
					Players[p0].bimpact_ct = 10 ;
					Players[p1].actual = MV_GGUARD ;
					Players[p1].life = Players[p1].life - BLOCK0 ;
					Block();
				}
				else
				{
					Players[p0].wimpact_ct = 10 ;
					Players[p1].actual = MV_GHURT ;
					Players[p0].hitfram = (Players[p0].gpunch.hit-1)*Players[p0].gpunch.spd ;
					Hurt(1);
				}
			}
			else if ( Players[p0].flag < (Players[p0].gpunch.hit*Players[p0].gpunch.spd) )
			{
				Players[p0].wimpact_ct = 10 ;
				Players[p1].actual = MV_HURT ;
				Players[p0].hitfram = (Players[p0].gpunch.hit-1)*Players[p0].gpunch.spd ;
				Hurt(1);
			}
			Players[p1].flag = 0 ;
		}
	}
	else if ( Players[p0].ak == (Players[p0].akick.hit-1)*Players[p0].akick.spd ) /* AIR-KICK */
	{
		if ( testImpact(p0,p1,&Players[p0].akick))
		{
			doImpact(p0,p1,&Players[p0].akick);
			if ( Players[p1].y<(Players[p1].sol-5) )
			{
				Players[p0].wimpact_ct = 10 ;
				Players[p1].actual = MV_KO ;
				Players[p0].hitfram = (Players[p0].akick.hit-1)*Players[p0].akick.spd ;
				Hurt(2);
			}
			else
			{
				if (joy_rt)
				{
					Players[p0].bimpact_ct = 10 ;
					Players[p1].actual = JOY_DN(p1) ? MV_GGUARD : MV_GUARD ;
					Players[p1].life = Players[p1].life - BLOCK0 ;
					Block();
				}
				else if (Players[p0].y>(Players[p0].sol-20))
				{
					Players[p0].wimpact_ct = 10 ;
					Players[p1].actual = JOY_DN(p1) ? MV_GHURT : MV_HURT ;
					Players[p0].hitfram = (Players[p0].akick.hit-1)*Players[p0].akick.spd ;
					Hurt(1);
				}
			}
			Players[p1].flag = 0 ;
		}
	}
	else if ( Players[p0].apch == (Players[p0].apunch.hit-1)*Players[p0].apunch.spd ) /* AIR-PUNCH */
	{
		if ( testImpact(p0,p1,&Players[p0].apunch))
		{
			doImpact(p0,p1,&Players[p0].apunch);
			if ( Players[p1].y<(Players[p1].sol-5) )
			{
				Players[p0].wimpact_ct = 10 ;
				Players[p1].actual = MV_KO ;
				Players[p0].hitfram = (Players[p0].apunch.hit-1)*Players[p0].apunch.spd ;
				Hurt(2);
			}
			else
			{
				if (joy_rt)
				{
					Players[p0].bimpact_ct = 10 ;
					Players[p1].actual = JOY_DN(p1) ? MV_GGUARD : MV_GUARD;
					Players[p1].life = Players[p1].life - BLOCK0 ;
					Block();
				}
				else if (Players[p0].y>(Players[p0].sol-20))
				{
					Players[p0].wimpact_ct = 10 ;
					Players[p1].actual = JOY_DN(p1) ? MV_GHURT : MV_HURT ;
					Players[p0].hitfram = (Players[p0].apunch.hit-1)*Players[p0].apunch.spd ;
					Hurt(1);
				}
			}
			Players[p1].flag = 0 ;
		}
	}
	computeZoom(p0,oldx0);
	computeZoom(p1,oldx1);
}

/*
 * Move fireball and check impact or exit
 */

void updateFireBall(int p0,int i,int dmg)
{
	int p1 = 1-p0;
	int x0,a;
	int joy_rt = Players[p1].invers==0 ? JOY_LT(p1) : JOY_RT(p1);

	Players[p0].fballs[i].x += Players[p0].fballs[i].dx * Players[p0].fball.pix ;
	Players[p0].fballs[i].flg++ ;
	if (Players[p0].fballs[i].flg > (Players[p0].fball.nbf * Players[p0].fball.spd)-1 )
		Players[p0].fballs[i].flg = 0 ;
	x0 = Players[p0].fballs[i].x + (Players[p0].fballs[i].dx>0 ? 3 : 1) *(Players[p0].fballs[i].w>>2);
	if (Players[p1].fballs[0].on)
	{
		if ( ( x0 > Players[p1].fballs[0].x) && ( x0 < Players[p1].fballs[0].x + Players[p1].fballs[0].w ) )
		{
			Players[p0].fballs[i].on = 0 ;
			Players[p1].fballs[0].on = 0 ;
			Players[p0].limoffx = Players[p0].fballs[i].x + (Players[p0].fballs[i].dx>0 ? Players[p0].fballs[i].offx : 0) ;
			Players[p0].limoffy = Players[p0].fballs[i].y + Players[p0].fballs[i].offy ;
			Players[p0].bimpact_ct = 10 ;
			Hurt(1);
			return;
		}
	}
	if (Players[p1].fballs[1].on)
	{
		if ( ( x0 > Players[p1].fballs[1].x) && ( x0 < Players[p1].fballs[1].x + Players[p1].fballs[1].w ) )
		{
			Players[p0].fballs[i].on = 0 ;
			Players[p1].fballs[1].on = 0 ;
			Players[p0].limoffx = Players[p0].fballs[i].x + (Players[p0].fballs[i].dx>0 ? Players[p0].fballs[i].offx : 0) ;
			Players[p0].limoffy = Players[p0].fballs[i].y + Players[p0].fballs[i].offy ;
			Players[p0].bimpact_ct = 10 ;
			Hurt(1);
			return;
		}
	}
	a = Players[p1].width/3;
	if ( ( x0 > Players[p1].x + a ) && ( x0 < Players[p1].x + (a<<1) ) )
	{
		if ( Players[p0].autho_ht && (Players[p1].y > (Players[p1].sol-30)) )
		{
			Players[p1].damag = dmg ;
			Players[p0].limoffx = Players[p0].fballs[i].x + (Players[p0].fballs[i].dx>0 ? Players[p0].fballs[i].offx : 0) ;
			Players[p0].limoffy = Players[p0].fballs[i].y + Players[p0].fballs[i].offy ;
			if ( Players[p1].y<(Players[p1].sol-5) )
			{
				Players[p0].simpact_ct = 10 ;
				Players[p1].actual = MV_KO ;
				Hurt(1);
			}
			if (joy_rt)
			{
				Players[p0].bimpact_ct = 10 ;
				Players[p1].actual = JOY_DN(p1) ? MV_GGUARD : MV_GUARD;
				Players[p1].life = Players[p1].life - BLOCK1 ;
				Block() ;
			}
			else
			{
				Players[p0].simpact_ct = 10 ;
				Players[p1].actual = JOY_DN(p1) ? MV_GHURT : MV_HURT ;
				Hurt(1);
			}
			Players[p1].flag = 0 ;
			Players[p0].fballs[i].on = 0 ;
			Players[p0].autho_ht = 0 ;
		}
	}
	if ((Players[p0].fballs[i].x > (cx+zoomwidth)) || (Players[p0].fballs[i].x < -Players[p0].fballs[i].w))
		Players[p0].fballs[i].on = 0 ;
}

/*
 * Fireballs update
 */

void updateFireBalls(int p)
{
	if (Players[p].fballs[0].on)
		updateFireBall(p,0,Players[p].fireb.dmg);
	if (Players[p].fballs[1].on)
		updateFireBall(p,1,Players[p].firebx.dmg);
}

/*
 * KO anim for loser, Winning anim for winner
 */

void showWinner(int p0)
{
	int p1 = 1-p0, i, angle;

	Players[p0].vic++;

	if (!Players[p1].female)
	{
		CLEAR_SAMPLE(argh_snd)
		argh_snd = load_sample ("wav\\argh1.wav") ;
		play_sample( argh_snd );
	}
	else
	{
		CLEAR_SAMPLE(female_snd)
		female_snd = load_sample ("wav\\argh2.wav") ;
		play_sample( female_snd );
	}

	Players[p0].flag = 1;
	for ( Players[p1].flag = 1 ; Players[p1].flag < 160 ; Players[p1].flag+=skp_flag+1 )
	{
		if (animated)
			bkgd_counter++;
		blit_Bkgd() ;
		if ( Players[p0].y < Players[p0].sol )
			GJump (p0, 5  );
		else
			GStatic (p0, (Players[p0].flag/Players[p0].statik.spd) );
		GDead (p1, (Players[p1].flag/20)  );

		Players[p0].flag+=skp_flag+1 ;
		if (Players[p0].flag > ((Players[p0].statik.spd*Players[p0].statik.nbf)-1) )
			Players[p0].flag = 0 ;

		if ( Players[p0].y < Players[p0].sol )
			Players[p0].y++ ;
		if ( Players[p1].y < Players[p1].sol )
			Players[p1].y++ ;

		i = Players[p1].x;
		Players[p1].x += Players[p1].invers==0 ? (Players[p1].x>0 ? -1 : 0) : (Players[p1].x + Players[p1].width < Bkgd->w ? 1 : 0) ;

		computeZoom(p1,i);
		showZoom(cx);
		blit_KOF91();
	}

	if (t_clock <= 1)
	{
		openZip(skinzip[getOptionValue(OPTION_SKIN)]);
		CLEAR_BM(Carton_TO)
		Carton_TO = load_pcx( "sprites\\timeup.pcx", 0);
		closeZip();
		CLEAR_SAMPLE(to_snd)
		to_snd = load_sample ("wav\\timeup.wav") ;
		masked_blit(Carton_TO, virtscreen, 0, 0,(320 - Carton_TO->w) / 2,(240 - Carton_TO->h) / 2, Carton_TO->w,Carton_TO->h);
		play_sample( to_snd );
	}
	else
	{
		CLEAR_SAMPLE(ko_snd)
		ko_snd = load_sample ("wav\\ko.wav") ;
		openZip(skinzip[getOptionValue(OPTION_SKIN)]);
		CLEAR_BM(Carton_KO)
		Carton_KO = load_pcx("sprites\\ko.pcx", 0);
		closeZip();
		masked_blit(Carton_KO , virtscreen , 0 , 0, (320-Carton_KO->w)/2, (240-Carton_KO->h)/2, Carton_KO->w ,Carton_KO->h) ;
		play_sample( ko_snd );
	}
	blit_KOF91();

	GpThreadSleep(1200+50*getOptionValue(OPTION_SPEED));

	if (getOptionValue(OPTION_FIGHTANIM)==0)
	{
		if (Players[p0].life >= max_life)
		{
			openZip(skinzip[getOptionValue(OPTION_SKIN)]);
			CLEAR_BM(B_prfct)
			B_prfct = load_pcx("sprites\\perfect.pcx",0);
			closeZip();
			CLEAR_SAMPLE(prfct_snd)
			prfct_snd = load_sample ("wav\\perfect.wav") ;
		}
		load_win(p0);
		for ( Players[p0].flag = 1 ; Players[p0].flag < (Players[p0].outwin.nbf*Players[p0].outwin.spd) ; Players[p0].flag+=skp_flag+1 )
		{
			if (animated)
				bkgd_counter++;
			blit_Bkgd() ;
			GDead (p1, 7  ) ;
			GOutwin (p0, (Players[p0].flag/Players[p0].outwin.spd)) ;
			showZoom(cx);
			blit_KOF91();
		}
		unload_anim(p0,Players[p0].outwin.nbf);

		angle = (Carton_WN->w/Carton_WN->h) ;
		if (Players[p0].life >= max_life)
			play_sample(prfct_snd);

		for ( i = Carton_WN->w ; i > (Carton_WN->w/3) ; i-=skp_flag+1 )
		{
			if (Players[p0].life >= max_life)
				draw_sprite(virtscreen, B_prfct, 160 - B_prfct->w / 2, 120 - B_prfct->h);
			blit_KOF91();
			showZoom(cx);
			stretch_sprite (virtscreen ,Carton_WN ,(p0==0 ? 30 : 290-i), 30, i , i/angle);
		}
	}

	CLEAR_BM(Carton_KO)
	CLEAR_SAMPLE(ko_snd)
	CLEAR_BM(Carton_TO)
	CLEAR_SAMPLE(to_snd)
	CLEAR_BM(B_prfct)
	CLEAR_SAMPLE(prfct_snd)
	CLEAR_SAMPLE(argh_snd)
	CLEAR_SAMPLE(female_snd)
}

/*
 * Character intro animation
 */

void showIntro(int p0)
{
	int p1 = 1-p0;
	for ( Players[p1].flag = 1 ; Players[p1].flag < (Players[p1].intro.nbf*9) ; Players[p1].flag+=skp_flag+1 )
	{
		if (animated)
			bkgd_counter++;
		showZoom(cx);
		blit_KOF91();
		blit_Bkgd() ;

		Players[p0].flag+=skp_flag+1 ;

		if ( Players[p0].flag > ((Players[p0].statik.spd*Players[p0].statik.nbf)-1) )
			Players[p0].flag = 0 ;
		if ( Players[p0].flag<(Players[p0].intro.nbf*9) )
			GIntro (p0, (int)(Players[p0].flag/9)) ;
		else
			GStatic(p0, (int)(Players[p0].flag/Players[p0].statik.spd) ) ;
		GIntro (p1, (int)(Players[p1].flag/9)) ;
	}
}
